//#pragma GCC target ("avx2")
//#pragma GCC optimization ("Ofast")
//#pragma GCC optimization ("unroll-loops")

//#pragma comment(linker,"/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

//order_of_key(k): Number of items strictly smaller than k .
//find_by_order(k): K-th element in a set (counting from zero).
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define full(x,n) x,x+n+1
#define full(x) x.begin(),x.end()
#define finish return 0

#define putb push_back
#define f first
#define s second

//logx(a^n)=loga(a^n)/logx(a)
//logx(a*b)=logx(a)+logx(b)
//logx(y)=log(y)/log(x)
//logb(n)=loga(n)/loga(b)

#define ordered_set tree<ll,null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update>
#define putf push_front
#define gainb pop_back

//(a+b)^n=sum of C(n,i)*a^i*b^(n-i) 0<=i<=n
//(a-b)^n=sum of C(n,i)*a^i*b^(n-i) for even i-for odd i

#define gainf pop_front
#define len(x) (int)x.size()

// 1/b%mod=b^(m-2)%mod
// (a>>x)&1==0
// a^b=(a+b)-2(a&b)

typedef double db;
typedef long long ll;

//sum of squares n*(n+1)*(2n+1)/6
//sum of cubes [n*(n+1)/2]^2
//sum of squares for odds n*(4*n*n-1)/3
//sum of cubes for odds n*n*(2*n*n-1)

const int ary=2e5+5;
const int mod=1e9+7;
const ll inf=1e18;

using namespace std;
using namespace __gnu_pbds;
int n,m,u[ary],v[ary],sz[ary],p[ary],c,cl[ary];
bool w[ary];
vector< pair<int,int> > q;
int find(int a){
	if(a==p[a]){
		return a;
	}
	return p[a]=find(p[a]);
}
void add(int x,int y){
	if(sz[x]<sz[y]){
		swap(x,y);
	}
	p[y]=x;
	sz[x]+=sz[y];
}
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
	cin>>n>>m;
	c=n;
	for(int i=1;i<=n;i++){
		p[i]=i;
		sz[i]=1;
		cl[i]=i;
	}
	for(int i=1;i<=m;i++){
		cin>>u[i]>>v[i];
		int x=find(u[i]);
		int y=find(v[i]);
		if(x==y){
			continue;
		}
		add(x,y);
		w[i]=1;
	}
	for(int i=1;i<=m;i++){
		if(w[i]){
			q.putb({u[i],v[i]});
			continue;
		}
		c++;
		q.putb({u[i],c});
		cl[c]=v[i];
	}
	cout<<c<<"\n";
	for(int i=1;i<=c;i++){
		cout<<cl[i]<<" ";
	}
	cout<<"\n";
	for(int i=0;i<c-1;i++){
		cout<<q[i].f<<" "<<q[i].s<<"\n";
	}
}
