#include <bits/stdc++.h>
#define ll long long

using namespace std;

vector<vector<int> > graph;
vector<int> used;
int waylen = 0;
int solves = 0;


int dfs(int n){
    used[n] = 1;
    //cout << "in: " << n << '\n';

    //cout << waylen << '\n';

    if(waylen > 3){
        return 0;
    }

    for(int i = 0; i < graph[n].size(); i++){
        //Идем по соседям n вершины
        int to = graph[n][i];
        if(waylen == 3 && to == 0){
            solves++;
            return 0;
        }

        if(used[to] == 0){
            waylen++;
            dfs(to);
            waylen--;
            used[to] = 0;
        }

        
    }
    return 0;
}

int printGR(vector<vector<int>> &a){
    for(int i = 0; i < a.size(); i++){
        cout << i << " -> ";
        for(int j = 0; j < a[i].size(); j++){
            cout << a[i][j] << " ";
        }
        cout << '\n';
    }
    return 0;
}

int main() {
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    used.resize(n);
    for(int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;

        graph[x].push_back(y);
        graph[y].push_back(x);
           
    }

    //printGR(graph);
    //cout << '\n';
    dfs(0);

    cout << solves << '\n';


    return 0;
}