#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n;
    cin >> n;
    long long ans = 1e18;
    for (long long a = 1; a * a <= n; ++a){
        if (n % a == 0){
            ans = min(ans, abs(a - n / a));
        }
    }
    for (long long k = 1; k * k <= n; k += 2){
        if (n % k == 0){
            ans = min(ans, abs(2 * n / k - (k + 1) / 2));
            if (n % 2 == 1){
                long long k2 = n / k;
                ans = min(ans, abs(2 * n / k2 - (k2 + 1) / 2));
            }
        }

    }
    for (long long k = 1; k * k <= 2 * n - 1; k += 2){
        if ((2 * n - 1) % k == 0){
            ans = min(ans, abs(-(k + 1) / 2 + (2 * n - 1) / k));
            long long k2 = (2 * n - 1) / k;
            ans = min(ans, abs(-(k2 + 1) / 2 + (2 * n - 1) / k2));
        }
    }
    for (long long k = 1; k * k <= 2 * n + 1; k += 2){
        if ((2 * n + 1) % k == 0){
            ans = min(ans, abs(-(k + 1) / 2 + (2 * n + 1) / k));
            long long k2 = (2 * n + 1) / k;
            ans = min(ans, abs(-(k2 + 1) / 2 + (2 * n + 1) / k2));
        }
    }
    cout << ans;
    return 0;
}