#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int newv;

vector<vector<int>> g;
vector<int> used;
vector<int> color;
vector<pair<int, int>> ans;

void dfs(int v, int p){
    used[v] = 1;
    for(int u : g[v]){
        if(u == p) continue;
        if(used[u] == 0){
            dfs(u, v);
            ans.emplace_back(v, u);
        }
        else if(used[u] == 1){
            ans.emplace_back(v, newv++);
            color.emplace_back(u);
        }
    }
    used[v] = 2;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    newv = n;
    g.resize(n);
    used.resize(n, 0);
    color.resize(n);
    iota(color.begin(), color.end(), 0);
    for(int i = 0; i < m; ++i){
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    dfs(0, -1);
    cout << color.size() << "\n";
    for(int i : color){
        cout << i + 1 << " ";
    }
    cout << "\n";
    for(int i = 0; i < ans.size(); ++i){
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
    }

    return 0;
}