#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long double n;
    cin >> n;
    long double v, u;
    cin >> v >> u;
    vector<long double> cr(n);
    for(int i = 0; i < n; ++i){
        cin >> cr[i];
    }
    long double t = 0;
    sort(cr.rbegin(), cr.rend());
    int k = 1;
    for(int i = 1; i < n; ++i){
        cr[i] = max((long double)0, cr[i] - t * v);
        long double tnow = min((cr[i - 1] - cr[i]) / u * i, cr[i] / v);
        cr[i] -= tnow * v;
        if (cr[i] < 1e-8){
            break;
        }
        ++k;
        t += tnow;
    }
    t += cr[k] / (v + u / n);
    cout << fixed << setprecision(10) << t * u;

    return 0;
}