#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<bool> boolval(n, false);
    for(int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
        if(v == 0){
            boolval[u] = true;
        }
        if(u == 0){
            boolval[v] = true;
        }
    }
    vector<int> val(n, 0);
    for(int i = 0; i < n; ++i){
        for(int u : g[i]){
            if(boolval[u])++val[i];
        }
    }
    long long ans = 0;
    for(int i = 1; i < n; ++i){
        ans += (long long)val[i] * ((long long)val[i] - 1ll);
    }
    cout << ans;

    return 0;
}