/// two to the one from the one to the three 

#pragma GCC optimize("O3")
//#pragma comment(linker, "/STACK:36777216")

#include<bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(x) (int) x.size()
#define all(z) (z).begin(), (z).end()
 
using namespace std;

using ll = long long;
using pii = pair<int, int>;                                   

const int MOD = 1e9 + 7;
const int INF = 1e9 + 1e2;
  
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fin() {
#ifdef AM
    freopen(".in", "r", stdin);
#endif        
}                   

const bool flag = 0;

const int N = 5e5+10;

int p[N], sz[N], c[N], cur;    

int get(int x) {
    if (p[x] == x) {
        return x;
    }
    return p[x] = get(p[x]);
}

bool unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) {
        return true;
    }
    if (sz[a] > sz[b]) {
        swap(a, b);
    }
    p[a] = b;
    sz[b] += sz[a];
    return false;
}

void ma1n() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        p[i] = i, sz[i] = 1, c[i] = i;
    }         
    cur = n;
    vector<pii> ans;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if (unite(u, v)) {
            c[cur] = c[v];
            ans.pb({u, cur++});
        } else {
            ans.pb({u, v});
        }
    }
    cout << cur << "\n";
    for (int i = 0; i < cur; ++i) {
        cout << c[i]+1 << " ";
    }
    cout << "\n";
    for (pii x : ans) {
        cout << x.x+1 << " " << x.y+1 << "\n";
    }
}                                                  

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr), fin();
    int ts = 1;
    if (flag) {
        cin >> ts;
    }
    while (ts--) {
        ma1n(); 
    }
    return 0;
}