/// two to the one from the one to the three 

#pragma GCC optimize("O3")
//#pragma comment(linker, "/STACK:36777216")

#include<bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(x) (int) x.size()
#define all(z) (z).begin(), (z).end()
 
using namespace std;

using ll = long long;
using pii = pair<int, int>;                                   

const int MOD = 1e9 + 7;
const int INF = 1e9 + 1e2;
  
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fin() {
#ifdef AM
    freopen(".in", "r", stdin);
#endif        
}                   

const bool flag = 0;

const int N = 1e6+10;

int min(int x, int y, int z) { 
    return min(min(x, y), z); 
} 

int DP[2][int(1e4+10)]; 

int EditDistDP(string& str1, string& str2) {
    int len1 = str1.length(); 
    int len2 = str2.length(); 
    memset(DP, 0, sizeof DP); 
    for (int i = 0; i <= len1; i++) 
        DP[0][i] = i; 
  
    for (int i = 1; i <= len2; i++) { 
        for (int j = 0; j <= len1; j++) { 
            if (j == 0) 
                DP[i % 2][j] = i; 
            else if (str1[j - 1] == str2[i - 1]) { 
                DP[i % 2][j] = DP[(i - 1) % 2][j - 1]; 
            } else { 
                DP[i % 2][j] = 1 + min(DP[(i - 1) % 2][j], 
                                       min(DP[i % 2][j - 1], 
                                           DP[(i - 1) % 2][j - 1])); 
            } 
        } 
    } 
    return DP[len2 % 2][len1]; 
}  

void ma1n() {
    string s;
    string t;
    cin >> s >> t;
    int n;
    cin >> n;
    n += 2;
    vector<string> w(n);
    w[0] = s;
    w[n - 1] = t;
    for (int i = 1; i < n - 1; i++) {
        cin >> w[i];
    }
    vector<vector<int>> c(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            c[i][j] = EditDistDP(w[i], w[j]);
        }
    }
    vector<int> k(n);
    vector<int> e(n, INF);
    vector<int> p(n, -1);
    priority_queue<pair<pii, int>> q;
    e[0] = 0;
    q.push({{e[0], k[0]}, 0});
    while (!q.empty()) {
        int w = -q.top().x.x;
        int u = q.top().y;
        q.pop();
        if (w != e[u]) {
            continue;
        }            
        for (int v = 1; v < n; v++) {
            if (v == u)
                continue;
            if ((e[v] > e[u] + c[u][v]) || (e[v] == e[u] + c[u][v] && k[v] < k[u] + 1)) {
                e[v] = e[u] + c[u][v];
                p[v] = u;
                k[v] = k[u] + 1;
                q.push({{-e[v], k[v]}, v});
            }
        }
    }    
    cout << e[n - 1] << ' ' << k[n - 1] - 1 << '\n';
    int cur = n - 1;
    vector<string> path;
    while (cur >= 0) {
        if (cur != n - 1 && cur)
            path.pb(w[cur]);
        cur = p[cur];
    }
    reverse(path.begin(), path.end());
    for (auto word : path)
        cout << word << '\n';            
}                                                      

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr), fin();
    int ts = 1;
    if (flag) {
        cin >> ts;
    }
    while (ts--) {
        ma1n(); 
    }
    return 0;
}