#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef double ld;
typedef pair<int, int> pii;

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

mt19937 gen(time(0));

//#define int ll
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)(x.size())
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int N = 1e5 + 1;
int x[N], y[N];

int d;

bool cmp(int a, int b) {
    ll x1 = x[a] - x[d], y1 = y[a] - y[d];
    ll x2 = x[b] - x[d], y2 = y[b] - y[d];
    ll vec = x1 * y2 - x2 * y1;
    if (vec == 0) {
        return x1 * x1 + y1 * y1 < x2 * x2 + y2 * y2;
    }
    return vec >= 0;
}

bool bad(int a, int b, int d) {
    ll x1 = x[a] - x[d], y1 = y[a] - y[d];
    ll x2 = x[b] - x[d], y2 = y[b] - y[d];
    ll vec = x1 * y2 - x2 * y1;
    return vec <= 0;
}

void run() {
  int n, l;
  cin >> n >> l;
  for(int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  d = 0;
  for(int i = 0; i < n; i++) {
    if (y[i] < y[d] || (y[i] == y[d] && x[i] < x[d]))
        d = i;
  }
  vector<int> ord(n);
  iota(all(ord), 0);
  sort(all(ord), cmp);
  cout << endl;
  vector<int> st;
  for(int i = 0; i < n; i++) {
    while (size(st) >= 2 && bad(st[size(st) - 2], st[size(st) - 1], ord[i]))
        st.pop_back();
    st.push_back(ord[i]);
  }
  for(int x : st) cout << x << ' '; cout << endl;
    ld di = 0;
    for(int i = 0; i < size(st); i++) {
        int j = (i + 1) % size(st);

        di += sqrt((x[st[i]]-x[st[j]])*(x[st[i]]-x[st[j]])+
                   (y[st[i]]-y[st[j]])*(y[st[i]]-y[st[j]]));
    }

 cout << fixed << setprecision(10) << di + l * 4 * sqrt(2);

}

signed main() {
   freopen("input.txt", "r", stdin);
#ifdef LOCAL
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  run();
}
