#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <string>
#include <limits.h>
#include <iterator>
#include <queue>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

vector <vector<int>> g(1e5 + 1000);
vector <int> ans;


void dfs(vector <bool> &used, int v, int cnt, int last) {
	if (cnt == 3) {
		ans.push_back(v);
		return;
	}
	for (auto now : g[v]) {
		if (now == last)
			continue;
		dfs(used,now, cnt + 1, v);
	}
}

bool find(int x) {
	for (int i = 0; i < g[1].size(); i++) {
		if (g[1][i] == x)
			return true;
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 1; i < n + 1; i++) {
		sort(g[i].begin(), g[i].end());
	}
	int count = 0;
	vector <bool> used(n + 1, true);
	used[1] = false;
	dfs(used, 1, count, 0);
	int cnt = 0;
	for (int i = 0; i < ans.size(); i++) {
		if (find(ans[i])) {
			cnt++;
		}
	}
	cout << cnt;
	return 0;
}