#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <string>
#include <limits.h>
#include <iterator>
#include <queue>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

vector <vector<int>> g(1e5 + 1000);
int cnt = 0;

bool find(int x) {
	for (int i = 0; i < g[1].size(); i++) {
		if (g[1][i] == x)
			return true;
	}
	return false;
}

void dfs(int v, int count, int last) {
	if (count == 4) {
		if (v == 1) {
			cnt++;
			//cout << last << " ";
		}
		return;
	}
	for (auto now : g[v]) {
		if (now == last)
			continue;
		dfs(now, count + 1, v);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int count = 0;
	dfs(1, count, 0);
	cout << cnt;
	return 0;
}