#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
using namespace std;

#define _CRT_SECURE_NO_WARNINGS
#define fastio ios_base::sync_with_stdio(false); cin.tie(0);
#define ll long long
#define add push_back
#define fr first
#define sc second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define plb pair<long long, bool>
#define filein(a) freopen(a, "r", stdin);
#define fileout(a) freopen(a, "w", stdout);

const int N = 500005;

vector<int> g[N];
vector<pii> p;
map<pii, pii> change;
int hoh[N], c = 0, color[N];

void bfs(int u){
	queue<int> q;
	hoh[u]=1;
	color[u] = 1;
	q.push(u);
	while(!q.empty()){
		u=q.front();
		q.pop();
		for(int i=0; i<g[u].size(); i++){
			int h=g[u][i];
			if(!hoh[h]){
				hoh[h]=hoh[u]+1;
				q.push(h);
				color[h] = h;
			}
			else if(hoh[h] >= hoh[u] && change[pii(min(u, h), max(u, h))] == pii(0, 0)){
				c++;
				change[pii(min(u, h), max(u, h))] = pii(u, c);
				color[c] = h;
			}
		}
	}
}

int main(){
	fastio

	int n, m;
	ll ans = 0;
	cin >> n >> m;
	c = n;
	for(int i = 0; i < m; i++){
		int v, w;
		cin >> v >> w;
		p.add(pii(min(v, w), max(v, w)));
		g[v].add(w);
		g[w].add(v);
	}
	bfs(1);
	cout << c << endl;
	for(int i = 1; i <= c; i++){
		cout << color[i] << " ";
	}
	cout << endl;
	for(int i = 0; i < m; i++){
		if(change[p[i]] == pii(0, 0)){
			cout << p[i].fr << " " << p[i].sc << endl;
		}
		else{
			cout << change[p[i]].fr << " " << change[p[i]].sc << endl;
		}
	}
	return 0;
}