#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iterator>
using namespace std;
int n, m, used[100'002];
set<int> g[100'002];
vector <int> dt[100'002];
int color[1'000'000'2];
int cur_v;
void dfs(int u, int par)
{
	for (auto it = g[u].begin(); it != g[u].end(); it++)
	{
		int v = *it;
		if (v != par)
		{
			if (used[v] == 0)
			{
				used[v] = 1;
				dt[u].push_back(v);
				//dt[v].push_back(u);
				dfs(v, u);
			}
			else
			{
				//dt[cur_v].push_back(u);
				dt[u].push_back(cur_v);
				color[cur_v] = v;
				cur_v++;
				it = g[u].erase(it);
				g[v].erase(u);
			}
		}
	}	
}
int main()
{
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		color[u] = u;
		color[v] = v;
		g[u].insert(v);
		g[v].insert(u);
	}
	cur_v = n + 1;
	used[1] = 1;
	dfs(1, -1);
	cout << cur_v - 1 << '\n';
	for (int i = 1; i < cur_v; i++)
		cout << color[i] << ' ';
	cout << '\n';
	for (int i = 1; i <= n; i++)
	{
		for (int j = 0; j < dt[i].size(); j++)
		{
			cout << i << ' ' << dt[i][j] << '\n';
		}
	}
	return 0;
}