#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define fr first
#define sc second
#define all(x) x.begin(),x.end()
#define pii pair<int,int>
#define ld long double

const int N = 1e5 + 10;
const int inf = 1e18;
const int mod = 1e9 + 7;

int t[4 * N];
int a[N];

int f(int x, int y) {
    return x + y;
}

void build(int v, int l, int r) {
    if (l == r)t[v] = a[l];
    else {
        int m = (l + r) >> 1;
        build(v << 1, l, m);
        build((v << 1) ^ 1, m + 1, r);
        t[v] = f(t[v << 1], t[(v << 1) ^ 1]);
    }
}

void upd(int v, int l, int r, int id, int x) {
    if (l == r)t[v] = x;
    else {
        int m = (l + r) >> 1;
        if (id <= m)upd(v << 1, l, m, id, x);
        else upd((v << 1) ^ 1, m + 1, r, id, x);
        t[v] = f(t[v << 1], t[(v << 1) ^ 1]);
    }
}

int que(int v, int tl, int tr, int l, int r) {
    if (l > tr || tl > r)return 0;
    if (l <= tl && tr <= r)return t[v];
    int tm = (tl + tr) >> 1;
    return f(que(v << 1, tl, tm, l, r), que((v << 1) ^ 1, tm + 1, tr, l, r));
}

int pow(int x, int y) {
    if (y == 0)return 1;
    if (y % 2)return (x * pow(x, y - 1)) % mod;
    int z = pow(x, y / 2);
    return (z * z) % mod;
}

int inv(int x) {
    return pow(x, mod - 2);
}

signed main() {
//    freopen(".txt", "r", stdin);
//    freopen(".txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    int n;
    ld l;
    cin >> n >> l;
    vector<ld> a;
    for (int i = 0; i < n; ++i) {
        ld x;
        cin >> x;
        a.pb(x);
    }
    ld val = l / 2.0;
    sort(a.begin(), a.end());
    int ans = n * (n - 1) * (n - 2) / 6;
    for (int i = 0; i < n; ++i) {
        int le = i;
        int ri = a.size();
        while (le + 1 < ri) {
            int mid = (le + ri) / 2;
            if (a[mid] - a[i] < val) le = mid;
            else ri = mid;
        }
        int d = le - i - 1;
        ans -= d * (d + 1) / 2;
        a.pb(a[i] + l);
    }
    cout << ans;
}
