#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define fr first
#define sc second
#define all(x) x.begin(),x.end()
#define pii pair<int,int>
#define ld long double

const int N = 1e5 + 10;
const int inf = 1e18;
const int mod = 1e9 + 7;

int p[N];

int find(int x) {
    if (x == p[x])return x;
    return (p[x] = find(p[x]));
}

bool unite(int x, int y) {
    x = find(x);
    y = find(y);
    p[x] = y;
    return x != y;
}

signed main() {
//    freopen(".txt", "r", stdin);
//    freopen(".txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.precision(12);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) p[i] = i;
    vector<pair<int, int>> left;
    vector<pair<int, int>> res;
    vector<int> col;
    for (int i = 0; i < n; ++i)col.pb(i);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        if (unite(x, y)) {
            res.pb({x, y});
        } else left.pb({x, y});
    }
//    cout << left.size() << endl;
    for (auto e : left) {
        int x = e.fr;
        int y = e.sc;
//        cout << x << " " << y << endl;
        res.pb({col.size(), x});
        col.pb(y);
    }
    cout << col.size() << endl;
    for (int i : col) cout << i + 1 << " ";
    cout << endl;
    for (auto z : res) {
        cout << z.fr + 1 << " " << z.sc + 1 << endl;
    }
}