#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define fr first
#define sc second
#define all(x) x.begin(),x.end()
#define pii pair<int,int>
#define ld long double

const int N = 1e5 + 10;
const int inf = 1e18;
const int mod = 1e9 + 7;
vector<int> g[N];
bool used[N];
int d[N];
queue<int> q;

void bfs() {
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        used[v] = true;
        for (int to : g[v]) {
            if (!used[to]) {
                d[to] = d[v] + 1;
                used[to] = true;
                q.push(to);
            }
        }
    }
}

signed main() {
//    freopen(".txt", "r", stdin);
//    freopen(".txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    q.push(0);
    bfs();
    int cnt[n];
    fill(cnt, cnt + n, 0);
    for (int i = 0; i < n; ++i) {
        if (d[i] == 1 || d[i] == 2) {
            for (int to : g[i]) {
                if (d[to] == 1)cnt[i]++;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (d[i] == 1) {
            for (int to : g[i]) {
                if (d[to] == 1 || d[to] == 2) {
                    ans += cnt[to] - 1;
                }
            }
        }
    }
    cout << ans;
}