from math import sqrt

def suit(w, h, n):
    p = w * h
    return p == n or p - (h // 2) == n or p - ((h + 1) // 2) == n
def solve_fast(n):
    m = 1e9
    s = int(sqrt(n))
    for w in range(max(0, s - 500), s + 500):
        for h in range(max(0, s - 500), s + 500):
            if suit(w,h, n):
                m = min(m, abs(w - h))
    return m

print(solve_fast(int(input())))