#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

#define int long long

using namespace std;

const int INF = 1e9;
const int len = 1000001;


int n;

bool suit(int w, int h){
    int p = w * h;
    return p == n || p - h / 2 == n || p - (h + 1) / 2 == n;
}

signed main() {
    cin >> n;
    int s = sqrt(n), m = INF;
    for (int i = max(0LL, s - 1000); i < s + 1000; ++i){
        for (int j = max(0LL, s - 1000); j < s + 1000; ++j){
            if (suit(i, j))
                m = min(m, abs(i - j));

        }
    }
    cout << m;

}

