#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<bool>> g;
vector<bool> used;
int n, m;

int dfs(int u, int cnt){
    if (cnt == 0)
        return g[u][1];
    int ans = 0;
    used[u] = true;
    for (int v = 1; v <= n; ++v)
        if (g[u][v] && !used[v])
            ans += dfs(v, cnt - 1);
    used[u] = false;
    return ans;
}

int main() {
    cin >> n >> m;
    g.resize(n + 1, vector<bool>(n + 1));
    used.resize(n + 1);

    for (int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        g[u][v] = true;
        g[v][u] = true;
    }
    cout << dfs(1, 3);
}

