#include <cstdio>
#include <cmath>

#define min(a, b) ((a) > (b) ? (b) : (a))

void Rec( int **A, int **B, int dep, int n, int N )
{
  B[n][0] = 1;

  if (dep == 2)
  {
    B[n][1]++;
    return;
  }

  for (int i = 0; i < N; i++)
    if (A[i][0] == n && A[i][1] != 0)
      Rec(A, B, dep + 1, A[i][1], N);
    else if (A[i][1] == n && A[i][0] != 0)
      Rec(A, B, dep + 1, A[i][0], N);
}

int main()
{
  int n, m;

  // Read data
  scanf("%d", &n);
  scanf("%d", &m);
  int **A = new int *[m];
  for (int i = 0; i < m; i++)
    A[i] = new int[2];

  for (int i = 0; i < n; i++)
    for (int j = 0; j < 2; j++)
      A[i][j] = 0;

  for (int i = 0; i < m; i++)
  {
    int a, b;
    scanf("%d", &a);
    scanf("%d", &b);
    A[i][0] = a - 1;
    A[i][1] = b - 1;
  }

  int **B = new int *[n];
  for (int i = 0; i < n; i++)
  {
    B[i] = new int[2];
    B[i][0] = B[i][1] = 0;
  }

  for (int i = 0; i < m; i++)
    if (A[i][0] == 0)
      Rec(A, B, 1, A[i][1], m);
    else if (A[i][1] == 0)
      Rec(A, B, 1, A[i][0], m);

  int res = 0;
  for (int i = 1; i < n; i++)
    if (B[i][0] == 1)
      res += B[i][1] * (B[i][1] - 1);
  printf("%d", res);

  // Free everything
  for (int i = 0; i < n; i++)
    delete[] B[i];
  delete[] B;

  for (int i = 0; i < m; i++)
    delete[] A[i];
  delete[] A;

  /*
  int n, u, v;
  long long S = 0;

  scanf("%d", &n);
  scanf("%d", &v);
  scanf("%d", &u);

  for (int i = 0; i < n; i++)
  {
    int a_i;
    scanf("%d", &a_i);
    S += a_i;
  }

  printf("%.6lf", (double)u * S / ((double)n * v + u));
  */

  return 0;
}
