#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

int min3(int a, int b, int c) {
  return min(min(a,b), c);
}

int max3(int a, int b, int c) {
  return max(max(a,b), c);
}

void sort(int&a, int&b, int&c) { 
  int mn = min3(a, b, c);
  int mx = max3(a, b, c);
  int x = mn, y, z = mx;
  if (a != mn && a != mx)
    y = a;
  else if (b != mn && b != mx)
    y = b;
  else
    y = c;
  a = x;
  b = y;
  c = z;
  return;
}

int main() {
  long n, L;
  vector<long> mas(300000);
  int m = 0;

  cin >> n >> L;

  for (int i = 0; i < n; i++)
  {
    cin >> mas[i];
  }
  for ( int i = 0; i < n; i++)
  {
    for (int j = i + 1; j < n; j++)
    {
      for (int k = j + 1; k < n; k++)
      {
        int x = mas[i], y = mas[j], z = mas[k];
        sort(x, y, z);
        if (L - abs(x-z) <= L/2 && abs(x-y) <= L/2 && abs(z-y) <= L/2)
          m++;
      }
    }
  }
  cout << m;
  return 0;
}

