//follow God
 
//#pragma optimization_level 3
 
//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
 
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <chrono>
#include <ctime>
#include <queue>
#include <math.h>
#include <deque>
#include <stack>
#include <iomanip>
#include <assert.h>
#include <stdio.h>
#include <cstring>
#include <random>
 
using namespace std;
 
#define int long long
#define ll long long
#define ull unsigned long long
#define ld long double
#define pii pair<int, int>
#define pld pair<ld, ld>
#define ti tuple<int, int, int>
#define vi vector <int>
#define vpi vector <pii>
#define vld vector <ld>
#define try tr
#define left left11
#define right right11
#define lb lower_bound
#define ub upper_bound
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define pb push_back
#define pf push_front
#define sqr(a) ((a) * (a))
#define dbg(x) cout << #x << " : " << x << endl;
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
 
#define x first
#define y second
 
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
 
clock_t START;
 
inline ld TIME() {
    return (ld) (clock() - START) / CLOCKS_PER_SEC;
}
 
void SHOW() {
    cout << fixed << setprecision(10);
    cout << TIME() << " SECONDS FROM START\n";
}
 
ld TL = 2.0;
int calls = 0;
 
inline bool IS() {
    if (TL - TIME() < 0.1)
        return true;
    return false;
}
 
template<typename T1, typename T2>
inline bool amin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
 
template<typename T1, typename T2>
inline bool amax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
 
template<typename T1, typename T2>
ostream &operator<<(ostream &os, pair<T1, T2> &p) {
    os << p.first << ' ' << p.second;
    return os;
}
 
template<typename T1, typename T2>
istream &operator>>(istream &is, pair<T1, T2> &p) {
    is >> p.first >> p.second;
    return is;
}
 
template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u : v) is >> u;
    return is;
}
 
template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u : v) os << u << ' ';
    return os;
}
 
int hash_mod[4] = {1000000007, 998244353, 1000000009, 999999937}, mod = hash_mod[rnd() % 4];
int hash_pows[4] = {179, 239, 1007, 2003}, P = hash_pows[rnd() % 4];
 
int binpow(int x, int p) {
    int res = 1;
    while (p) {
        if (p % 2)
            res = (res * x) % mod;
        x = (x * x) % mod;
        p /= 2;
    }
    return res;
}
 
const int N = 1e6 + 7, NS = 2e3 + 7, lg = 20, sq = 550, inf = 2e9 + 7;
const ld eps = 1e-7, pi = 3.14159265359;

struct pt{
    ld x;
    ld y;
    pt(ld a = 0, ld b = 0) {
        x = a;
        y = b;
    }
};

ld dist(pt p1, pt p2) {
    return sqrtl(sqr(p1.x - p2.x) + sqr(p1.y - p2.y));
}

struct vec{
    ld x;
    ld y;
};

vec tov(pt p1, pt p2) {
    vec v;
    v.x = p2.x - p1.x;
    v.y = p2.y - p1.y;
    return v;
}

ld operator*(vec v1, vec v2) {
    return v1.x * v2.x + v1.y * v2.y;
}

ld operator^(vec v1, vec v2) {
    return v1.x * v2.y - v1.y * v2.x;
}

pt st;

bool cmp(pt p1, pt p2) {
    vec v1 = tov(st, p1), v2 = tov(st, p2);
    if(abs(v1 ^ v2) >= eps)
        return (v1 ^ v2) > 0;
    return (v1 * v1) < (v2 * v2);
}

void solve() {

    int n, l;
    cin >> n >> l;
    vector <pt> c;
    for (int i = 0; i < n; i++) {
        pt p;
        cin >> p.x >> p.y;
        c.emplace_back(p.x, p.y + l);
        c.emplace_back(p.x, p.y - l);
        c.emplace_back(p.x + l, p.y);
        c.emplace_back(p.x - l, p.y);
    }
    st = c[0];
    vector <pt> r;
    for (int i = 1; i < c.size(); i++) {
        if(c[i].x < st.x || (c[i].x == st.x && c[i].y < st.y)) {
            r.pb(st);
            st = c[i];
        }
        else 
            r.pb(c[i]);
    }
    sort(all(r), cmp);
    vector <pt> h;
    h.pb(st);
    for (auto u : r) {
        while(h.size() > 2 && (tov(h[h.size() - 2], h[h.size() - 1]) ^ tov(h[h.size() - 2], u)) <= 0) 
            h.pop_back();
        h.pb(u);
    }
    ld ans = 0;
    for (int i = 0; i < h.size(); i++) {
        ans += dist(h[i], h[(i + 1) % h.size()]);
    }
    cout << fixed << setprecision(20);
    cout << ans;
}
 
signed main() {
    fast
    solve();
}