//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

#define int long long
#define ll long long
#define ld long double
#define pb push_back

const int N = 1e6 + 10;
set<int> g[N];
vector<int> color(N);

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    set<pair<int,int>> ans;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        ans.insert({a, b});
        g[a].insert(b);
        g[b].insert(a);
    }
    deque<int> q;
    int col = 2;
    color[1] = 1;
    int now = n + 1;
    q.pb(1);
    while(!q.empty()){
        int v = q.front();
        vector<int> del;
        q.pop_front();
        for (auto to : g[v]){
            if (color[to] == 0){
                color[to] = col++;
                q.push_back(to);
            }
            else{
                if (color[to] > color[v]){
                    color[now] = to;
                    del.pb(to);
                    ans.insert({now, v});
                    now++;
                }
            }
        }
        for (auto to : del){
            ans.erase({to, v});
            ans.erase({v, to});
            g[to].erase(v);
            g[v].erase(to);
        }
    }
    cout << now - 1 << endl;
    for (int i = 1; i <= n; i++){
        cout << i << " ";
    }
    for (int i = n + 1; i < now; i++){
        cout << color[i] << " ";
    }
    cout << endl;
    for (auto to : ans){
        cout << to.first << " " << to.second << endl;
    }
    return 0;
}
