//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

#define int long long
#define ll long long
#define ld long double
#define pb push_back

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<pair<int,int>, pair<int,int>>> v;
    vector<vector<pair<int, int>>> col(2 * n + 1);
    for (int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        if (a == b) {
            col[a].pb({2 * i + 1, 2 * i + 2});
        }
        else{
            v.pb({{a, b}, {2 * i + 1, 2 * i + 2}});
        }
    }
    set<pair<int, int>> st;
    for (int i = 0; i < col.size(); i++){
        if (col[i].size() != 0){
            int vvv = col[i].size();
            st.insert({-vvv, i});
        }
    }
    int last = -1, first = 0;
    vector<int> ans;
    while(st.size() > 0){
        auto it = st.begin();
        if (last != it->second){
            if (last == -1) first = it->second;
            ans.pb(col[it->second][col[it->second].size() - 1].first);
            ans.pb(col[it->second][col[it->second].size() - 1].second);
            col[it->second].pop_back();
            pair<int,int> p = *it;
            st.erase(p);
            if (col[p.second].size() != 0){
                int u = col[p.second].size();
                st.insert({-u, p.second});
            }
            last = p.second;
            continue;
        }
        if (st.size() == 1) break;
        it++;
        if (last != it->second){
            if (last == -1) first = it->second;
            ans.pb(col[it->second][col[it->second].size() - 1].first);
            ans.pb(col[it->second][col[it->second].size() - 1].second);
            col[it->second].pop_back();
            pair<int,int> p = *it;
            st.erase(p);
            if (col[p.second].size() != 0){
                int u = col[p.second].size();
                st.insert({-u, p.second});
            }
            last = p.second;
            continue;
        }
    }
    if (first == last){
        int aa = ans[ans.size() - 2], bb = ans[ans.size() - 1];
        ans.pop_back();
        ans.pop_back();
        col[last].pb({aa, bb});
    }

    vector<pair<pair<int,int>, pair<int,int>>> have, not_have;
    for (auto to : v){
        if (to.first.first != first && to.first.second != first){
            not_have.pb(to);
        }
        else{
            if (to.first.first != first){
                swap(to.first.first, to.first.second);
                swap(to.second.first, to.second.second);
            }
            have.pb(to);
        }
    }
    int constt = min((int)not_have.size(), (int)col[first].size());
    for (int i = 0; i < constt; i++){
        if (ans.size() == 1) first = ans.back();
        ans.pb(col[first][col[first].size() - 1].first);
        if (ans.size() == 1) first = ans.back();
        ans.pb(col[first][col[first].size() - 1].second);
        if (ans.size() == 1) first = ans.back();
        col[first].pop_back();
        if (ans.size() == 1) first = ans.back();
        ans.pb(not_have.back().second.first);
        if (ans.size() == 1) first = ans.back();
        ans.pb(not_have.back().second.second);
        if (ans.size() == 1) first = ans.back();
        not_have.pop_back();
    }
    if (ans.size()==0){
        if (ans.size() == 1) first = ans.back();
        ans.pb(not_have.back().second.first);
        if (ans.size() == 1) first = ans.back();
        ans.pb(not_have.back().second.second);
        if (ans.size() == 1) first = ans.back();
        not_have.pop_back();
        not_have.clear();
        have.clear();
        for (auto to : v){
            if (to.second.first == ans[0] || to.second.second == ans[0]){
                continue;
            }
            if (to.first.first != first && to.first.second != first){
                not_have.pb(to);
            }
            else{
                if (to.first.first != first){
                    swap(to.first.first, to.first.second);
                    swap(to.second.first, to.second.second);
                }
                have.pb(to);
            }
        }
    }
    for (auto to : have){
        if (ans.size() == 1) first = ans.back();
        ans.pb(to.second.first);
        if (ans.size() == 1) first = ans.back();
        ans.pb(to.second.second);
        if (ans.size() == 1) first = ans.back();
        last = ans.back();
    }
    for (auto to : not_have){
        if (to.first.first == last){
            swap(to.second.second, to.second.first);
            swap(to.first.second, to.first.first);
        }
        if (ans.size() == 1) first = ans.back();
        ans.pb(to.second.first);
        if (ans.size() == 1) first = ans.back();
        ans.pb(to.second.second);
        if (ans.size() == 1) first = ans.back();
        last = to.first.second;
    }
    cout << ans.size() / 2 << endl;
    for (auto to : ans){
        cout << to << " ";
    }
    return 0;
}
