//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

#define x first
#define y second
//#define int long long
#define ll long long
#define ld long double
#define pb push_back

const int INF = 1e9 + 228;

int lev(const string &s, const string &t) {
    int n = s.size(), m = t.size();
    vector<int> dp(m + 1);
    for (int i = 0; i <= m; ++i) dp[i] = i;
    for (int i = 1; i <= n; ++i) {
        vector<int> new_dp(m + 1, INF);
        for (int j = 0; j <= m; ++j) {
            if (j == 0) new_dp[j] = i; else {
                new_dp[j] = min(new_dp[j], new_dp[j - 1] + 1);
                new_dp[j] = min(new_dp[j], dp[j] + 1);
                new_dp[j] = min(new_dp[j], dp[j - 1] + 1);
                if (s[i - 1] == t[j - 1]) new_dp[j] = min(new_dp[j], dp[j - 1]);
            }
        }
        dp = new_dp;
    }
    return dp[m];
}

bool better(const pair<int, int> &a, const pair<int, int> &b) {
    return a.x < b.x || (a.x == b.x && a.y > b.y);
}

const int N = 1005;

string w[N];
int dlv[N][N];
pair<int, int> d[N];
int pr[N];
bool used[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> w[0] >> w[1];
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> w[2 + i];
    n += 2;
    for (int i = 0; i < n; ++i){
        for (int j = i + 1; j < n; ++j){
            dlv[i][j] = dlv[j][i] = lev(w[i], w[j]);
        }
    }
    for (int i = 0; i < n; ++i) d[i] = {INF, -INF};
    d[0] = {0, 0};
    for (int it = 0; it < n; ++it) {
        int id = -1;
        for (int i = 0; i < n; ++i) {
            if (!used[i] && (id == -1 || better(d[i], d[id]))) id = i;
        }
        used[id] = 1;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                pair<int, int> new_d = {d[id].x + dlv[id][i], d[id].y};
                if (i >= 2) ++new_d.y;
                if (better(new_d, d[i])) {
                    d[i] = new_d;
                    pr[i] = id;
                }
            }
        }
    }
    vector<int> ids;
    int cur = 1;
    while (cur != 0) {
        if (cur >= 2) ids.pb(cur);
        cur = pr[cur];
    }
    reverse(ids.begin(), ids.end());
    cout << dlv[0][1] << " " << ids.size() << '\n';
    for (auto id : ids) cout << w[id] << '\n';
    return 0;
}
