#include <iostream>
#include <vector>
#include <set>
#define int long long

using namespace std;

set<pair<int, int>> coord;
vector<int> pruzhins(0);
void rec(pair<int, int> start, vector<bool> used)
{
	
	for (int i = 0; i < pruzhins.size(); i++)
	{
		if (!used[i])
		{
			for (int j = 0; j <= pruzhins[i]; j++)
			{
				coord.insert({ j + start.first, start.second });
				coord.insert({ start.first, start.second + j });
			}
			used[i] = true;
			pair <int, int> newStart = { start.first + pruzhins[i], start.second };
			rec(newStart, used);
			newStart = { start.first, start.second + pruzhins[i] };
			rec(newStart, used);
			used[i] = false;
		}
	}

}

signed main()
{

	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int tmp;
		cin >> tmp;
		pruzhins.push_back(tmp);
	}
	vector<bool> booling(n);
	rec({ 0,0 }, booling);
	cout << coord.size();
	return 0;
}