#include <bits/stdc++.h>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;

vector <vector <int>> g;
vector <bool> visited;
vector<bool> places;


ll gb = 0;

void bfs(int u) {
    queue <int> q;
    q.push(u);
    visited[u] = 1;


    while(!q.empty()){
        int v = q.front();
        q.pop();

        for (int i = 0; i < g[v].size(); i++) {
            int to = g[v][i];

            if (!visited[to]) {
                visited[to] = 1;
                q.push(to);
            }
        }
    }
}


void dfs(int v, int steps) {
    if(steps == 3) {
        if(places[v] == true) {
            gb++;
        }
        return;
    }

    visited[v] = 1;

    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i];

        if (!visited[to]) {
            dfs(to, steps + 1);
        }
    }

    visited[v] = 0;
    return;
}


int gcd(int a, int b) {
    if (b == 0)
        return a;

    return gcd(b, a % b);
}


int main() {
    int n, m;
    cin >> n >> m;

    g.resize(n);
    visited.resize(n, false);
    places.resize(n, false);

    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;

        if(a == 0) {
            places[b] = true;
        }
        else if(b == 0) {
            places[a] = true;
        }

        g[a].push_back(b);
        g[b].push_back(a);
    }

    dfs(0, 0);
    cout << gb << endl;

    return 0;
}

/*

10 14
1 5
2 5
5 6
2 3
1 3
2 4
4 6
1 6
1 7
7 8
8 1
1 10
9 10
9 8

3 3
1 2
2 3
3 1

*/


// E
/*
int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);


    ll n;
    cin >> n;


    ll l = 1, r = n + 1;
    while (r - l > 2) {
        ll m1 = (2 * l + r) / 3;
        ll m2 = (2 * r + l) / 3;

        ll maxLen1 = n / m1 + 1 * (n % m1 != 0),
            maxLen2 = n / m2 + 1 * (n % m2 != 0);

        if (abs(maxLen1 - m1) < abs(maxLen2 - m2)) {
            r = m1;
        }
        else {
            l = m2;
        }
    }

    ll r1 = l,
        r2 = l + 1,
        r3 = l + 2,
        r4 = r;

    ll ans1 = abs((n / r1 + 1 * (n % r1 != 0)) - r1);
    ll ans2 = abs((n / r2 + 1 * (n % r2 != 0)) - r2);
    ll ans3 = abs((n / r3 + 1 * (n % r3 != 0)) - r3);
    ll ans4 = abs((n / r4 + 1 * (n % r4 != 0)) - r4);


    ll ans = min(
       min(ans1, ans2),
       min(ans3, ans4)
    );

    cout << ans << endl;

    return 0;
}*/
