#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(0)

#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define sqr(a) ((a) * (a))
#define vout(v) cout << #v << ": " << (v) << '\n';

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = 0x7fffffff;
const ll MOD = (1 << 30) + 1;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const int MAXN = 1e5 + 1000;

int a[110];
int dp[1001000];
vector <int> v;

int main() {
	fast();
	int n, m;
	cin >> n;
    long long sum = 0;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        sum += a[i];
    }
    long long ans = (sum + 1) * (sum + 2) / 2;
    for (int i = 0; i <= sum; i++)
        dp[i] = 0;
    dp[0] = 1;
    for (int i = 0; i < n; i++){
        for (int j = sum; j >= 0; j--)
            if (dp[j] == 1 && j + a[i] <= sum)
                dp[j + a[i]] = 1;
    }
    for (int i = 1; i <= sum; i++)
        if (dp[i] == 0)
            v.push_back(i);
    int r = v.size() - 1;
    for (int l = 0; l < v.size(); l++){
        while (r >= l && a[l] + a[r] > sum)
            r--;
        ans -= max(0, r - l + 1);
    }
    cout << ans << '\n';
	return 0;
}
