#include<bits/stdc++.h>
using namespace std;

struct pt {
	double x, y;
};
vector<pt> v;
bool cmp (pt a, pt b) {
	return a.x < b.x || a.x == b.x && a.y < b.y;
}

bool cw (pt a, pt b, pt c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool ccw (pt a, pt b, pt c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull (vector<pt> & a) {
	if (a.size() == 1)  return;
	sort (a.begin(), a.end(), &cmp);
	pt p1 = a[0],  p2 = a.back();
	vector<pt> up, down;
	up.push_back (p1);
	down.push_back (p1);
	for (size_t i=1; i<a.size(); ++i) {
		if (i==a.size()-1 || cw (p1, a[i], p2)) {
			while (up.size()>=2 && !cw (up[up.size()-2], up[up.size()-1], a[i]))
				up.pop_back();
			up.push_back (a[i]);
		}
		if (i==a.size()-1 || ccw (p1, a[i], p2)) {
			while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i]))
				down.pop_back();
			down.push_back (a[i]);
		}
	}
	a.clear();
	for (size_t i=0; i<up.size(); ++i)
		a.push_back (up[i]);
	for (size_t i=down.size()-2; i>0; --i)
		a.push_back (down[i]);
}
int main()
{
double a,b,n,l;
	double otv=0;
	pt A;
	cin>>n>>l;
	for(int i=0;i<n;i++)
	{
		cin>>a>>b;
		
		
		A.x=a-l;
		A.y=b;
		v.push_back(A);
		
		A.x=a+l;
		A.y=b;
		v.push_back(A);
		
		A.x=a;
		A.y=b-l;
		v.push_back(A);
		
		A.x=a;
		A.y=b+l;
		v.push_back(A);
	}
	convex_hull(v);
	


//	for(int i=0;i<v.size();i++)
//	{
//		cout<<v[i].x<<' '<<v[i].y<<endl;
//	}
//

	for(int i=0;i<v.size()-1;i++)
	{
		otv=otv+sqrt(abs(v[i].x-v[i+1].x)*abs(v[i].x-v[i+1].x)+abs(v[i].y-v[i+1].y)*abs(v[i].y-v[i+1].y) )      ;
	}
		otv=otv+sqrt(abs(v[v.size()-1].x-v[0].x)*abs(v[v.size()-1].x-v[0].x)+abs(v[v.size()-1].y-v[0].y)*abs(v[v.size()-1].y-v[0].y) )      ;

cout<<fixed<<setprecision(12)<<otv;
}
