#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const double EPS = 1e-9;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    ll n;
    cin >> n;
    ll ans = 1e15;
    for (ll d = 0; d * d <= n; ++d) {
        // aaaaaaaaaaaaaaaaaa
        ll left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            ll y = mid + d;
            if (mid * y >= n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        ll y = right + d;
        if (right * y == n) {
            cout << d;
            return;
        }
        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            ll x = 2 * mid;
            y = x + d;
            if ((2 * y - 1) * x >= 2 * n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        ll x = 2 * right;
        y = x + d;
        if ((2 * y - 1) * x == 2 * n) {
            cout << d;
            return;
        }
        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            x = 2 * mid + 1;
            y = x + d;
            if (y * (x + 1) + (y - 1) * (x - 1) >= 2 * n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        x = 2 * right + 1;
        y = x + d;
        if (y * (x + 1) + (y - 1) * (x - 1) == 2 * n) {
            cout << d;
            return;
        }

        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            x = 2 * mid + 1;
            y = x + d;
            if ((y - 1) * (x + 1) + y * (x - 1) >= 2 * n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        x = 2 * right + 1;
        y = x + d;
        if ((y - 1) * (x + 1) + y * (x - 1) == 2 * n) {
            cout << d;
            return;
        }
        // govno

        d = -d;

        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            y = mid + d;
            if (mid * y >= n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        y = right + d;
        if (right * y == n) {
            cout << -d;
            return;
        }
        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            ll x = 2 * mid;
            y = x + d;
            if ((2 * y - 1) * x >= 2 * n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        x = 2 * right;
        y = x + d;
        if ((2 * y - 1) * x == 2 * n) {
            cout << -d;
            return;
        }
        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            x = 2 * mid + 1;
            y = x + d;
            if (y * (x + 1) + (y - 1) * (x - 1) >= 2 * n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        x = 2 * right + 1;
        y = x + d;
        if (y * (x + 1) + (y - 1) * (x - 1) == 2 * n) {
            cout << -d;
            return;
        }

        left = 0, right = 1e7;
        while (right - left > 1) {
            ll mid = (left + right) / 2;
            x = 2 * mid + 1;
            y = x + d;
            if ((y - 1) * (x + 1) + y * (x - 1) >= 2 * n) {
                right = mid;
            } else {
                left = mid;
            }
        }
        x = 2 * right + 1;
        y = x + d;
        if ((y - 1) * (x + 1) + y * (x - 1) == 2 * n) {
            cout << -d;
            return;
        }
        d = -d;
        // -d;
    }
}

int main() {
    fast_in_out();
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
//    freopen("err.txt", "w", stderr);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
    return 0;
}
