#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<short> visited;
vector<vector<int>> mas;
vector<vector<int>> graph;
vector<int> colors;
int tek = 0;

void DFS(int me, int parent)
{
    visited[me] = 1;

    for (int i = 0; i < mas[me].size(); ++i)
    {
        if (visited[mas[me][i]] == 1 && mas[me][i] != parent)
        {
            colors[tek] = colors[me];
            graph[mas[me][i]].push_back(tek);
            ++tek;
        }
        else if (visited[mas[me][i]] == 0)
        {
            if (mas[me][i] != parent)
            {
                graph[me].push_back(mas[me][i]);
                DFS(mas[me][i], me);
            }
        }
    }
    visited[me] = 2;
}

int main()
{
    int n, m;
    cin >> n >> m;
    visited.resize(n);
    mas.resize(n);
    graph.resize(m + 1);
    tek = n;
    int a, b;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        a -= 1;
        b -= 1;
        mas[a].push_back(b);
        mas[b].push_back(a);
    }
    colors.resize(m + 1);
    for (int i = 0; i < n; ++i)
    {
        colors[i] = i + 1;
    }
    DFS(0, -1);
    cout << m + 1 << '\n';
    for (int i = 0; i < m + 1; ++i)
        cout << colors[i] << ' ';
    cout << '\n';
    for (int i = 0; i < m + 1; ++i)
    {
        for (int j = 0; j < graph[i].size(); ++j)
            cout << i + 1 << ' ' << graph[i][j] + 1 << '\n';
    }
    return 0;
}
