/*
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")
ordered_set -> less -> less_equal
ordered_set find_by_order(k) -> k element
ordered_set order_of_key(k) -> returns the number of elements in a set strictly smaller than k
*/
#include <bits/stdc++.h>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>
 
using namespace std;
// using namespace __gnu_pbds;
 
//template<typename T> using ordered_set=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
 
const long long maxn = 1e6 + 123;
const long long inf = 1e9 + 123;
const long long linf = 1e18 + 123;
const long long mod = 1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1);
int dx[8] = {0, 1, -1, 0, 1, -1, 1, -1};
int dy[8] = {1, 0, 0, -1, 1, 1, -1, -1};
 
long long a[100], dp[maxn], dp1[maxn], t[maxn * 4];
 
bool use[maxn];

void build(int v, int tl, int tr){
    if (tl == tr){
        t[v] = dp[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build (v + v, tl, tm);
    build (v + v + 1, tm + 1, tr);
    t[v] = t[v + v] + t[v + v + 1];
}

long long get(int v, int tl, int tr, int l, int r){
    if (tl > r || l > tr){
        return 0;
    }
    if (l <= tl && tr <= r){
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return get(v + v, tl, tm, l, r) + get(v + v + 1, tm + 1, tr, l, r);
}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int sum = 0;
    for (int i = 1; i <= n; i++){
        cin >> a[i];
        sum += a[i];
        use[a[i]] = 1;
    }
    dp[0] = 1;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= sum; j++){
            dp1[j] = dp[j];
        }
        for (int j = sum; j >= a[i]; j--){
            if (dp[j - a[i]] == 1){
                dp1[j] = dp[j - a[i]];
            }
        }
        for (int j = 1; j <= sum; j++){
            dp[j] = dp1[j];
        }
    }
    build(1, 1, sum);
    long long res = 0;
    for (int i = 1; i <= sum; i++){
        if (dp[i] == 1){
            res += sum - i;
        }
        else{
            /*for (int j = 1; j <= sum - i; j++){
                res += dp[j];
            }*/
            res += get(1, 1, sum, 1, sum - i);
        }
    }
    res += 2 * (sum + 1) - 1;
    cout << res;
    exit(0);
}
