/*
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")
ordered_set -> less -> less_equal
ordered_set find_by_order(k) -> k element
ordered_set order_of_key(k) -> returns the number of elements in a set strictly smaller than k
*/
#include <bits/stdc++.h>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
// using namespace __gnu_pbds;

//template<typename T> using ordered_set=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const long long maxn = 3e5 + 123;
const long long inf = 1e9 + 123;
const long long linf = 1e18 + 123;
const long long mod = 1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1);
int dx[8] = {0, 1, -1, 0, 1, -1, 1, -1};
int dy[8] = {1, 0, 0, -1, 1, 1, -1, -1};

int a[maxn], x[maxn], y[maxn];

set<pair<int, int>> s;

vector<pair<int, int>> g[maxn];

bool used[maxn], usedr[maxn];

void dfs(int v){
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++){
        pair<int, int> to = g[v][i];
        if (used[to.first] == 0){
            usedr[to.second] = 1;
            dfs(to.first);
        }
    }
}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; i++){
        cin >> x[i] >> y[i];
        s.insert({x[i], y[i]});
        g[x[i]].push_back({y[i], i});
        g[y[i]].push_back({x[i], i});
    }
    dfs(1);
    for (int i = 1; i <= n; i++){
        a[i] = i;
    }
    int cur = n + 1;
    for (int i = 1; i <= m; i++){
        if (usedr[i] == 0){
            s.erase({x[i], y[i]});
            s.insert({x[i], cur});
            a[cur] = a[y[i]];
            cur++;
        }
    }
    cout << m + 1 << "\n";
    for (int i = 1; i <= m + 1; i++){
        cout << a[i] << " ";
    }
    cout << "\n";
    for (auto i : s){
        cout << i.first << " " << i.second << "\n";
    }
    exit(0);
}
