#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
vector<ll> vec;
set<ll> st;

void func(ll n, ll w, vector<ll> used, ll s){
    w += vec[n];
    st.insert(w);
    used[n] = 1;

    for(ll i = 0; i < s; i++){
        if(!used[i])
            func(i, w, used, s);
    }
    return;
}

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)


void solve() {
    /*ll n,m;
    cin >> n >> m;
    vector<vector<ll>> a(n);
    for(ll i = 0; i < m; i++){
        ll x,y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    vector<ll> d(n,0), t(n,0);
    vector<bool> used1(n, false), used2(n,false);
    d[0] = 1;
    queue<ll> q;
    used1[0] = true;
    for(auto &i : a[0]){
        d[i] += d[0];
        used1[i] = true;
        q.push(i);
    }
    queue<ll> q2;
    while(!q.empty()){
        ll u = q.front();
        q.pop();
        for(auto &i : a[u]){
            if(i != 0){
                t[i] += d[u];
                q2.push(i);
                used2[i] = true;
            }
        }
    }
    for(ll i = 0; i < n; i++)
        d[i] += t[i];
    ll ans = 0;
    while(!q2.empty()){
        ll u = q2.front();
        q2.pop();
        for(auto &i : a[u]){
            if(!used2[i] && used1[i]){
                ans += d[i];
            }
        }
    }
    cout << ans;*/

    ll n;
    cin >> n;
    vector<ll> used(1e3 + 1, 0);
    vec.resize(n);

    for(ll i = 0; i < n; i++){
        cin >> vec[i];
    }

    for(ll i = 0; i < n; i++){
        func(i, 0, used, n);
    }
    ll ans = 0;
    for(auto i : st){
        ans += i;
    }

    cout << ans * 2 - n;
}

signed main() {
    solve();
}