import sys
from typing import List, Set

sys.setrecursionlimit(10 ** 7)


def rec(v, i):
    o = tuple(g[v])
    for nv in o:
        if nv in g[v]:
            ng.append((nv + 1, i))
            g[nv].discard(v)
            g[v].discard(nv)
            rec(nv, len(ng))


n, m = map(int, input().split())
g: List[Set[int]] = [set() for _ in range(n)]
ng = [(1, -1)]

s2is1 = lambda s: int(s) - 1
for _ in range(m):
    a, b = map(s2is1, input().split())
    g[a].add(b)
    g[b].add(a)

rec(0, 1)
print(len(ng))
print(*(t[0] for t in ng))
for i, t in enumerate(ng[1:]):
    print(t[1], i + 2)
