#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
signed main() {
  ios::sync_with_stdio(0);cin.tie(0);
  int n;
  cin >> n;
  vector<int> a(n);
  int mysum = 0;
  for (int i = 0; i < n; ++i) cin >> a[i], mysum += a[i];
  sort(a.begin(), a.end());
  const int maxs = 1e6+1;
  vector<bool> dp(maxs, false);
  dp[0] = 1;
  for (int i = 0; i < n; ++i) {
    auto ndp = dp;
    for (int sum = 0; sum + a[i] < maxs; ++sum) {
      if (dp[sum]) {
        ndp[sum + a[i]] = 1;
      }
    }
    dp.swap(ndp);
  }
  int sumdp = 0;
  for (int i = 0; i < maxs; ++i)
    if (dp[i])
      sumdp += i;
  int last = 0;
  int curSum = 0;
  for (int i = 0; i < n; ++i) {
    curSum += (a[i] - last - 1) * (n - i);
    last = a[i];
  }
  cout << sumdp + curSum + mysum + 1;
}