#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
const int maxn = 2e5+17;
vector<int> g[maxn];
vector<int> color(maxn);
bool used[maxn];
vector<pair<int, int>> edges;
int cnt1;
vector<pair<int, int>> obr;
void dfs(int v, int p = -1) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p) continue;
        if (used[u]) {
            obr.push_back({min(u, v), max(u, v)});
        } else {
            edges.push_back({u, v});
            dfs(u, v);
        }
    }
}
int main() {
    ios::sync_with_stdio(0);cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1);
    cnt1 = n;
    sort(obr.begin(), obr.end());
    obr.erase(unique(obr.begin(), obr.end()), obr.end());
    for (int i = 1; i <= n; ++i) color[i] = i;
    for (auto e : obr) {
        int u = e.first, v = e.second;
        cnt1++;
        edges.push_back({v, cnt1});
        color[cnt1] = color[u];
    }
    cout << cnt1 << '\n';
    for (int i = 1; i <= cnt1; ++i) cout << color[i] << ' ';
    cout << '\n';
    for (auto u : edges)
        cout << u.first << " " << u.second << '\n';
}