#include <bits/stdc++.h>
using namespace std;
vector <vector <int>> g;
vector <int> used;
vector <vector <int>> b;
vector <vector <int>> dots;
int b_index = 0;


void dfs(int v, int parent){
    if (used[v] != 0) return;
    used[v] = 1;
    int cur_b = b_index;
    dots[v].push_back(b_index);
    if (parent != -1){
        b[cur_b].push_back(dots[parent][0]);
    }
    for (int to : g[v]){
        if (to == parent) continue;
        if (used[to] == 1) {
            b_index ++;
            b[b_index].push_back(dots[to][0]);
            b[dots[to][0]].push_back(b_index);
            dots[v].push_back(b_index);
        } else if (used[to] == 0){
            b_index ++;
            b[cur_b].push_back(b_index);
            dfs(to, v);
        }
    }
    used[v] = 2;
}


int main(){
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n, 0);
    b.resize(m + 1);
    dots.resize(n);
    for (int i = 0; i < m; i ++){
        int u, v;
        cin >> u >> v;
        u --; v --;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1);
    cout << m + 1 << '\n';
    vector <int> colors(m + 1);
    for (int i = 0; i < dots.size(); i++){
        for (int j : dots[i]){
            colors[j] = i + 1;
        }
    }
    for (int i : colors){
        cout << i << ' ';
    }
    cout << '\n';
    set <pair <int, int>> used_s;
    for (int i = 0; i < m + 1; i ++){
        for (int j : b[i]){
            if (used_s.count({i, j}) == 0){
                cout << i + 1 << ' ' << j + 1 << '\n';
                used_s.insert({i, j});
                used_s.insert({j, i});
            }
        }
    }
}
