﻿#include <iostream>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

const int N = 101;
int a[N];
int n;

map<pair<int, int>, int> mp;
set<long long> st;

void subsetSums(int l, int r,
	int sum = 0)
{
	if (l > r) {
		st.insert(sum);
		return;
	}
	subsetSums(l + 1, r, sum + a[l]);
	subsetSums(l + 1, r, sum);
}

int main()
{
	int i, j, sum, sumall = 0, res = 0;
	cin >> n;
	for (i = 0; i < n; i++) {
		cin >> a[i];
		sumall += a[i];
	}
	subsetSums(0, n - 1);
	for (auto i : st) {
		for (j = 0; j <= i; j++) {
			mp[make_pair(j, sumall - i)] = 1;
			mp[make_pair(sumall - i, j)] = 1;
		}
	}
	for (auto i : mp)
		if (i.second == 1)
			res++;
	cout << res << endl;
	return 0;
}
