﻿/*
ЗАПУСКАЕМ
░ГУСЯ░▄▀▀▀▄░РАБОТЯГИ░░
▄███▀░◐░░░▌░░░░░░░
░░░░▌░░░░░▐░░░░░░░
░░░░▐░░░░░▐░░░░░░░
░░░░▌░░░░░▐▄▄░░░░░
░░░░▌░░░░▄▀▒▒▀▀▀▀▄
░░░▐░░░░▐▒▒▒▒▒▒▒▒▀▀▄
░░░▐░░░░▐▄▒▒▒▒▒▒▒▒▒▒▀▄
░░░░▀▄░░░░▀▄▒▒▒▒▒▒▒▒▒▒▀▄
░░░░░░▀▄▄▄▄▄█▄▄▄▄▄▄▄▄▄▄▄▀▄
░░░░░░░░░░░▌▌▌▌░░░░░
░░░░░░░░░░░▌▌░▌▌░░░░░
░░░░░░░░░▄▄▌▌▄▌▌░░░░░
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;

template <class T = int>
T next() { T x; cin >> x; return x; }

void dfs(const std::vector<std::vector<int>>& graph, std::vector<bool>& visited, set<pair<int, int>>& s,
         std::vector<int>& colors, std::vector<std::vector<int>>& tree, int u, int p)
{
    std::set<pair<int, int>>::iterator it;
    for (int v : graph[u])
    {
        if (v == p)
            continue;
        if (visited[v])
        {
            if ((it = s.find(make_pair(min(u, v), max(u, v)))) == s.end())
            {
                colors.push_back(v);
                tree[u].push_back(tree.size());
                tree.push_back(std::vector<int>({ u }));
                s.insert(make_pair(min(u, v), max(u, v)));
            }
        }
        else
        {
            visited[v] = true;
            tree[u].push_back(v);
            tree[v].push_back(u);
            colors[v] = v;
            dfs(graph, visited, s, colors, tree, v, u);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout.precision(20);

    int n, m, u, v;
    cin >> n >> m;
    std::vector<std::vector<int>> graph(n);
    set<pair<int, int>> s;
    for (int i = 0; i < m; i++)
    {
        cin >> u >> v;
        u--;
        v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    std::vector<bool> visited(n, false);
    visited[0] = true;
    std::vector<int> colors(n);
    std::vector<std::vector<int>> tree(n);
    dfs(graph, visited, s, colors, tree, 0, -1);
    cout << colors.size() << endl << colors[0] + 1;
    for (int i = 1; i < colors.size(); i++)
        cout << ' ' << colors[i] + 1;
    cout << endl;
    for (int u = 0; u < n; u++)
        for (int v : tree[u])
            if (v > u)
                cout << u + 1 << ' ' << v + 1 << endl;
    return 0;
}