/*
⣴⣶⣶⡀⠄⠄⠙⢿⣿⣿⣿⣿⣿⣴⣿⣿⣿⢃⣤⣄⣀⣥⣿
⣿⣿⣿⣧⣀⢀⣠⡌⢻⣿⣿⣿⣿⣿⣿⣿⣿⣿⠿⠿⠿⣿⣿
⣤⣤⣤⣬⣙⣛⢿⣿⣿⣿⣿⣿⣿⡿⣿⣿⡍⠄⠄⢀⣤⣄⠉
⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣿⣿⣿⢇⣿⣿⡷⠶⠶⢿⣿⣿⠇
⣿⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣿⡇⣿⣿⣿⣿⣿⣿⣷⣶⣥⣴
⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣻⣿⣿⣧⠙⠛⠛⡭⠅⠒⠦⠭⣭⡻⣿⣿⣿⣿⣿⣿⣿⣿⡿
⣿⣿⣿⣿⡆⠄⠄⠄⠄⠄⠄⠄⠄⠹⠈⢋⣽⣿⣿⣿⣿⣵⣾
⣿⣿⣿⣿⣿⠄⣴⣿⣶⣄⠄⣴⣶⠄⢀⣾⣿⣿⣿⣿⣿⣿⠃
⠛⢿⣿⣿⣿⣦⠁⢿⣿⣿⡄⢿⣿⡇⣸⣿⣿⠿⠛⠁⠄⠄⠄
⠄⠄⠉⠻⣿⣿⣿⣦⡙⠻⣷⣾⣿⠃⠿⠋⠁⠄⠄⠄⠄⠄⢀
⣮⣥⠄⠄⠄⠛⢿⣿⣿⡆⣿⡿⠃⠄⠄⠄⠄⠄⠄⠄⣠⣴⣿
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <set>
#include <fstream>
#include <climits>
#include <cmath>
#include <deque>
#include <map>
#include <ctime>
#include <random>
#include <unordered_set>
#include <chrono>
#include <queue>
#include <unordered_map>

#define ff first
#define ss second
#define pb push_back
#define pp pop_back
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define IO ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define out(a) cout << a << " ";
#define in(x) cin >> x;
#define ends cout << endl;
#define here cout << "here" << endl;
#define double ld
using namespace std;



vector <vector <pair <int, int>>> mass; vector <bool> vis;
vector <int> res; vector <int> parent;  vector <vector <int>> a;
vector <int> t; vector <int> lvl;
vector <bool> use;
int tt = 0; int rrr = 0; int n;
void bfs() {
    int start = 0;
    vis[start] = true;
    t[start] = 0;
    deque <int> arr;
    arr.pb(start);
    res.pb(start + 1);
    while (!arr.empty()) {
        int u = arr.front();
        arr.pop_front();
        for (int i = 0; i < mass[u].size(); i++) {
            int v = mass[u][i].ff;
            if (!vis[v]) {
                lvl[v] = lvl[u] + 1;
                res.pb(v + 1);
                parent[v] = u;
                vis[v] = true;
                tt++;
                t[v] = tt;
                arr.pb(v);
                a[t[u]].pb(tt);
            } else {
                if (parent[u] != v && !use[mass[u][i].ss]) {
                    use[mass[u][i].ss] = true;
                    tt++;
                    t[n + rrr] = tt;
                    rrr++;
                    res.pb(v + 1);
                    a[t[u]].pb(tt);
                }
            }
        }
    }
}



int main(){
    IO
    int m;
    cin >> n >> m;
    mass.resize(n); a.resize(m + 1); use.resize(m);
    t.resize(m + 1, 0); vis.resize(n, false); lvl.resize(n, -1);
    parent.resize(n, -1);
    for (int i = 0; i < m; i++) {
        int d, b;
        cin >> d >> b;
        d--, b--;
        mass[d].pb({b, i});
        mass[b].pb({d, i});
    }
    bfs();
    cout << res.size() << endl;
    for (int i = 0; i < res.size(); i++) cout << res[i] << ' ';
    cout << endl;
    for (int i = 0; i <= m; i++) {
        if(t[i] <= m) {
            for (int j = 0; j < a[t[i]].size(); j++) {
                cout << t[i] + 1 << ' ' << a[t[i]][j] + 1 << endl;
            }
        }
    }
    return 0;
}