#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int>> v;
vector<int> us;
queue<int> q;
vector<int> dist;
int ans = 0;

void bfs() {
    while (!q.empty()) {
        int u=q.front();
        q.pop();
        for(int i:v[u]){
            if(us[i]==2&&dist[u]==1)
                ans++;
            if(us[i]==0) {
                dist[i] = dist[u] + 1;
                q.push(i);
                if(dist[u]==1)
                    us[i]=2;
            }
        }
    }
    return;
}

int main() {
    int n, m;
    cin >> n >> m;
    v.resize(n);
    us.resize(n, 0);
    dist.resize(n, 0);
    int x, y;
    for (int i=0; i<m; i++) {
        cin >> x >> y;
        v[x-1].push_back(y-1);
        v[y-1].push_back(x-1);
    }
    q.push(0);
    bfs();
    cout << ans << endl;
    return 0;
}
