#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <string>
#include <set>
#include <deque>
#include <map>

using namespace std;

typedef long long ll;

long long n, m;
vector<vector<bool>> v(0);
vector<bool> used(0);
vector<int> q(0);
vector<pair<int, int>> p(0);

void df(int now, int last) {
	used[now] = true;
	for (int i = 0; i < n; ++i) {
		if (i != last && v[now][i] == true) {
			pair<int, int> w;
			w.first = now + 1;
			if (used[i] == true) {
				q.push_back(i + 1);
				w.second = (int) q.size();
				v[now][i] = false;
				v[i][now] = false;
			}
			else{
				w.second = i + 1;
				df(i, now);
			}
			p.push_back(w);
		}
	}
}


int main() {
	cin >> n >> m;

	v.resize(n, vector<bool>(n, false));
	used.resize(n, false);
	q.resize(n, 0);
	for (int i = 0; i < n; ++i) q[i] = i + 1;


	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		v[a][b] = true;
		v[b][a] = true;
	}
	df(0, -1);

	cout << q.size() << "\n";
	for (int i = 0; i < (int) q.size(); ++i) {
		cout << q[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < (int)p.size(); ++i) {
		cout << p[i].first << " " << p[i].second << "\n";
	}
}