#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <string>
#include <set>
#include <deque>
#include <map>

using namespace std;

typedef long long ll;

int n, m;
vector<vector<int>> rer(0);
vector<vector<bool>> ter(0);
vector<bool> used(0);
vector<int> q(0);
vector<pair<int, int>> p(0);

void df(int now, int last) {
    used[now] = true;
    for (int i = 0; i < (int) rer[now].size(); ++i) {

        if (rer[now][i] != last && ter[now][i] == true) {
            pair<int, int> w;
            w.first = now + 1;
            if (used[rer[now][i]] == true) {
                q.push_back(rer[now][i] + 1);
                w.second = (int)q.size();
                ter[now][i] = false;
                for (int j = 0; j < (int) rer[rer[now][i]].size(); ++j) {
                    if (rer[rer[now][i]][j] == now) {
                        ter[rer[now][i]][j] = false;
                    }
                }
            }
            else {
                w.second = rer[now][i] + 1;
                df(rer[now][i], now);
            }
            p.push_back(w);
        }
    }
}


int main() {
    cin >> n >> m;
    ter.resize(n, vector<bool>(0));
    rer.resize(n, vector<int>(0));
    used.resize(n, false);
    q.resize(n, 0);
    for (int i = 0; i < n; ++i) q[i] = i + 1;


    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        ter[a].push_back(true);
        ter[b].push_back(true);
        rer[a].push_back(b);
        rer[b].push_back(a);
    }
    df(0, -1);

    cout << q.size() << "\n";
    for (int i = 0; i < (int)q.size(); ++i) {
        cout << q[i] << " ";
    }
    cout << "\n";
    for (int i = 0; i < (int)p.size(); ++i) {
        cout << p[i].first << " " << p[i].second << "\n";
    }
}