#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <deque>
#include <random>
#include <string>
#include <stack>
          
using namespace std;
           
typedef long long ll;

int sum(vector<ll>& result, const vector<ll>& v, ll index, ll curSum)
{
    if (index < v.size())
    {
        curSum += v[index];
        for (int i = index + 1; i < v.size(); ++i)
        {
            int res = sum(result, v, i, curSum);
            result.push_back(res);
        }
    }
    return curSum;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    setlocale(LC_ALL, "ru");
    srand(time(NULL));

    ll n; cin >> n;
    vector<ll>a(n);
    vector<bool>b(1e6 + 10, false);
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sm += a[i];
    }
    sort(a.begin(), a.end());
    vector<ll>result;
    for (int i = 0; i < a.size(); i++) {
        ll res = sum(result, a, i, 0);
        result.push_back(res);
    }
    for (auto to: result)
        b[to] = true;
    b[0] = true;

    ll ans = 0, k = -2;
    for (int i = 0; i <= sm; i++) 
        if (b[i])
            ans += sm - i, k++;
    //cout << ans << " " << k << endl;
    cout << ans * 2 - k << endl;
}