#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <deque>
#include <random>
#include <string>
#include <stack>
          
using namespace std;
           
typedef long long ll;

vector<vector<ll>>g;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    setlocale(LC_ALL, "ru");
    srand(time(NULL));

    ll n, m; cin >> n >> m;
    g.resize(n);
    set<ll>st;
    for (int i = 0; i < m; i++) {
        ll l, r; cin >> l >> r;
        if (l == 1)
            st.insert(r - 1);
        if (r == 1) 
            st.insert(l - 1);
        g[--l].push_back(--r);
        g[r].push_back(l);
    }
    ll ans = 0;
    for (auto to: st) {
        for (int i = 0; i < g[to].size(); i++)
            if (g[to][i] != 0)
                for (int j = 0; j < g[g[to][i]].size(); j++)
                    if (st.find(g[g[to][i]][j]) != st.end() && g[g[to][i]][j] != to && g[g[to][i]][j] != g[to][i] && g[g[to][i]][j] != 0)
                        ans += 2;
    }
    cout << ans / 2;
}