#include <iostream>
#include <list>
#include <set>
using namespace std;

int n, m, v, u, ans;
list<int> gr[100005];
set<int> valid;

void dfs(int x, int step, int p1)
{
    if (step == 3)
    {
        if (valid.count(x))
            ++ans;
        return;
    }
    for (int i : gr[x])
        if (i != 1 && i != p1)
        {
            if (step == 0)
                dfs(i, step + 1, 0);
            else if (step == 1)
                dfs(i, step + 1, x);
            else if (step == 2)
                dfs(i, step + 1, p1);
        }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        cin >> v >> u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    for (int i : gr[1])
        valid.insert(i);
    dfs(1, 0, 0);
    cout << ans << "\n";
}