// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
 
#include <iostream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <chrono>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <math.h>
#include <limits.h>
#include <cstdio>
#include <stdio.h>
#include <queue>
#include <bitset>
#include <cstdlib>
#include <deque>
#include <cassert>
#include <stack>
using namespace std;
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
 
// typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
#define mp make_pair
#define f first
#define se second
#define pb push_back
#define ppb pop_back
#define emb emplace_back
#define ll long long
#define ull unsigned long long
#define cntbit(x) __builtin_popcount(x)
#define endl '\n'
#define uset unordered_set
#define umap unordered_map
#define pii pair<int, int>
#define ld long double
#define pll pair<long long, long long>
 
random_device rnd;
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
 
template <typename T> inline T range(T l, T r) {
    return uniform_int_distribution<T>(l, r)(rng);
}
 
template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}
 
template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}
 
#define int long long
 
const ll INF = 2e18;
const int mod = 999999999999999989;
const int inf = 0x3f3f3f3f;
const int N = 0 + 15;          

int n,l;

vector<pair<int,int> > p;

pair<int,pair<int,int> >mnx,mxx,mny,mxy;

inline pii diff(pii a, pii b) {
	return mp(a.f - b.f, a.se - b.se);
}

inline int vec(pii a, pii b) {
	return a.f * b.se - b.f * a.se;
}

inline double dist(pii a, pii b) {
	return sqrt((a.f - b.f) * (a.f - b.f) + (a.se - b.se) * (a.se - b.se));
}

int x[N],y[N];

signed main () {     
	cin >> n >> l;
	mnx.f = inf;
	mny.f = inf;
	mxx.f = -inf;
	mxy.f = -inf;
	for (int i = 1;i <= n;++i)
	{
		cin >> x[i] >> y[i];
		if (mnx.f > x[i])
		{
			mnx.f = x[i];
			mnx.se.f = mnx.se.se = y[i];
		}
		if (mnx.f == x[i])
		{
			mnx.se.f = min(mnx.se.f,y[i]);
			mnx.se.se = max(mnx.se.se,y[i]);
		}
		if (mny.f > y[i])
		{
			mny.f = y[i];
			mny.se.f = mny.se.se = x[i];
		}
		if (mny.f == y[i])
		{
			mny.se.f = min(mny.se.f,x[i]);
			mny.se.se = max(mny.se.se,x[i]);
		}
		if (mxx.f < x[i])
		{
			mxx.f = x[i];
			mxx.se.f = mxx.se.se = y[i];
		}
		if (mxx.f == x[i])
		{
			mxx.se.f = min(mxx.se.f,y[i]);
			mxx.se.se = max(mxx.se.se,y[i]);
		}
		if (mxy.f < y[i])
		{
			mxy.f = y[i];
			mxy.se.f = mxy.se.se = x[i];
		}
		if (mxy.f == y[i])
		{
			mxy.se.f = min(mxy.se.f,x[i]);
			mxy.se.se = max(mxy.se.se,x[i]);
		}
	}
	p.push_back(mp(mnx.f,mnx.se.f - l));
	p.push_back(mp(mnx.f,mnx.se.se + l));
	p.push_back(mp(mny.se.f,mny.f - l));
	p.push_back(mp(mny.se.se,mny.f - l));

	p.push_back(mp(mxx.f,mxx.se.f - l));
	p.push_back(mp(mxx.f,mxx.se.se + l));
	p.push_back(mp(mxy.se.f,mxy.f + l));
	p.push_back(mp(mxy.se.se,mxy.f + l));
	
	p.push_back(mp(mnx.f - l,mnx.se.f));
	p.push_back(mp(mnx.f - l,mnx.se.se));
	p.push_back(mp(mny.se.f - l,mny.f));
	p.push_back(mp(mny.se.se + l,mny.f));

	p.push_back(mp(mxx.f + l,mxx.se.f));
	p.push_back(mp(mxx.f + l,mxx.se.se));
	p.push_back(mp(mxy.se.f - l,mxy.f));
	p.push_back(mp(mxy.se.se + l,mxy.f));
	/*for (pii to : p)
	{
		cout << to.f << " " << to.se << "\n";
	}*/
	vector <pii> hull = {};
	pii now(inf, inf);
	for(pii e : p)
		Min(now, e);
	set <pii> s(p.begin(), p.end());
	s.erase(now);
	pii start = now;
	hull.pb(start);
	while(!s.empty()) {
		pii cur(-1, -1);
		for(pii e : s) {
			bool flag = true;
			for(pii e2 : s) {
				if(vec(diff(e, now), diff(e2, now)) < 0) {
					flag = false;
					break;
				}
			}
			if(flag)
				cur = e;
		}
		assert(cur.f != -1);
		if(now != start && vec(diff(start, now), diff(cur, now)) >= 0)
			break;
		s.erase(cur);
		hull.pb(now = cur);
	}
//	for(pii e : hull)
//		cout << e.f << ' ' << e.se << endl;
//	cout << endl;
	double sum = 0;
//	cout << hull.size() << "\n";
	for(int i = 0; i < hull.size(); ++i)
		sum += dist(hull[i], hull[(i + 1) % hull.size()]);
	cout.precision(50);
	cout << sum << endl;
	return 0;
}