// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
 
#include <iostream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <chrono>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <math.h>
#include <limits.h>
#include <cstdio>
#include <stdio.h>
#include <queue>
#include <bitset>
#include <cstdlib>
#include <deque>
#include <cassert>
#include <stack>
using namespace std;
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
 
// typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
#define mp make_pair
#define f first
#define se second
#define pb push_back
#define ppb pop_back
#define emb emplace_back
#define ll long long
#define ull unsigned long long
#define cntbit(x) __builtin_popcount(x)
#define endl '\n'
#define uset unordered_set
#define umap unordered_map
#define pii pair<int, int>
#define ld long double
#define pll pair<long long, long long>
 
random_device rnd;
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
 
template <typename T> inline T range(T l, T r) {
    return uniform_int_distribution<T>(l, r)(rng);
}
 
template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}
 
template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}
 
#define int long long
 
const ll INF = 2e18;
const int mod = 999999999999999989;
const int inf = 0x3f3f3f3f;
const int N = 3e5 + 15;          

int n,l;

pair<int,pair<int,int> >mnx,mxx,mny,mxy;

inline pii diff(pii a, pii b) {
	return mp(a.f - b.f, a.se - b.se);
}

inline int vec(pii a, pii b) {
	return a.f * b.se - b.f * a.se;
}

inline double dist(pii a, pii b) {
	return sqrt((a.f - b.f) * (a.f - b.f) + (a.se - b.se) * (a.se - b.se));
}

int x[N],y[N];

bool cw(pii a, pii b, pii c) {
	return a.f * (b.se - c.se) + b.f * (c.se - a.se) + c.f * (a.se - b.se) < 0;
}

bool ccw(pii a, pii b, pii c) {
	return a.f * (b.se - c.se) + b.f * (c.se - a.se) + c.f * (a.se - b.se) > 0;
}

vector <pii> convex_hull(vector<pii> a) {
	if(a.size() == 1)
		return a;
	sort(a.begin(), a.end());
	pii p1 = a[0], p2 = a.back();
	vector<pii> up = {a[0]}, down = {p1};
	for(int i = 1; i < a.size(); ++i) {
		if(i + 1 == a.size() || cw(p1, a[i], p2)) {
			while (up.size() >= 2 && !cw(up[up.size()-2], up[up.size()-1], a[i]))
				up.ppb();
			up.pb(a[i]);
		}
		if(i + 1 == a.size() || ccw(p1, a[i], p2)) {
			while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i]))
				down.ppb();
			down.pb(a[i]);
		}
	}
	a.clear();
	for(int i = 0; i < up.size(); ++i)
		a.push_back (up[i]);
	for(int i = down.size() - 2; i >= 0; --i)
		a.push_back (down[i]);
	return a;
}

signed main () {     
	cin >> n >> l;
	vector <pii> p(n);
	for(int i = 0; i < n; ++i)
		cin >> p[i].f >> p[i].se;
	vector<pair<int,int> > hull = convex_hull(p);
	vector <pii> nw = {};
	for(int i = 0; i < hull.size(); ++i) {
		nw.pb(mp(hull[i].f + l, hull[i].se));
		nw.pb(mp(hull[i].f, hull[i].se + l));
		nw.pb(mp(hull[i].f - l, hull[i].se));
		nw.pb(mp(hull[i].f, hull[i].se - l));
	}
	hull = convex_hull(nw);
	double sum = 0.0;
	for(int i = 0; i < hull.size(); ++i)
		sum += dist(hull[i], hull[(i + 1) % hull.size()]);
	cout.precision(50);
	cout << sum << endl;
	return 0;
}

