#include <bits/stdc++.h>
using namespace std;
#define int long long

bool is_integer(long double x) {
    if (x < 0)
        return false;
    long double y = round(x);
    return abs(x - y) < 1e-9;
}


bool check(int d, int n)
{
    if (is_integer((-d + sqrt(d * d + 4 * n)) / 2)) {
        //cout << d << ' ' << 1 << '\n';
        return true;
    }
    if (is_integer(((-d+0.5) + sqrt((d - 0.5) * (d - 0.5) + 4 * n)) / 2)) {
        //cout << d << ' ' << 2 << '\n';
        return true;
    }
    if (is_integer(((-d+0.5) + sqrt((d - 0.5) * (d - 0.5) + 4 * (n + 0.5))) / 2)) {
        //cout << d << ' ' << 3 << '\n';
        return true;
    }
    if (is_integer(((-d+0.5) + sqrt((d - 0.5) * (d - 0.5) + 4 * (n - 0.5))) / 2)) {
        //cout << d << ' ' << 4 << '\n';
        return true;
    }

    return false;
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for (int d = 0; d < 1e7; d++) {
        if (check(d, n) || check(-d, n)) {
            cout << d;
            return 0;
        }
    }


    return 0;
}
