#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "---"; cerr.flush()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)2e5 + 5;
const ll mod = (ll)1e9 + 7;

void operator delete(void*);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n, l;

vector<ld> vc;

ll ans;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> l;
    vc.resize(n);
    for (ld& i : vc) cin >> i;
    sort(all(vc));
    ans = (n - 1) * (n - 2) * n / 3;
    for (ll i = 0; i < n; i++) {
        ld x = vc[i] + ld(l / 2.0);
        if (x >= l) x -= l;
        ll pts = 0;
        if (vc[i] < x) {
            pts = upper_bound(all(vc), x) - lower_bound(all(vc), vc[i]);
        }
        else {
            pts = upper_bound(all(vc), vc[i]) - lower_bound(all(vc), x);
        }
        pts--;
        if (lower_bound(all(vc), x) != vc.end() && *lower_bound(all(vc), x) == x) pts--;
        ans -= (pts - 1) * pts / 2;
        pts = n - pts;
        if (lower_bound(all(vc), x) != vc.end() && *lower_bound(all(vc), x) == x) pts--;
        pts--;
        ans -= (pts - 1) * pts / 2;
    }
    cout << ans / 2;
    return 0;
}