#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define ar array
#define all(v) v.begin(),v.end()

using namespace std;
const int MAXN = 2e5 + 20, blocksz = 300;
const ld INF = 5e14;

struct block {
  bool flag;
  int make, begpl, step, L, R;
} xb[MAXN / blocksz + 10], yb[MAXN / blocksz + 10];

int x[MAXN], y[MAXN], numx[MAXN], numy[MAXN], Lx[MAXN], Rx[MAXN], Ly[MAXN], Ry[MAXN], szx, szy;
int n, q;

void buildx() {
  for (int i = 1; i <= n; i++)
    x[i] = i;
  for (int i = 1; i <= n; i++)
    numx[i] = (i - 1) / blocksz;
  for (int i = 1; i <= n; i++)
    Rx[numx[i]] = i;
  for (int i = n; i >= 1; i--)
    Lx[numx[i]] = i;
  szx = numx[n] + 1;
  for (int i = 0; i < szx; i++) {
    xb[i].flag = false;
    xb[i].make = -1;
    xb[i].begpl = 0;
    xb[i].step = 0;
    xb[i].L = Lx[i];
    xb[i].R = Rx[i];
  }
}

void updx(int id) {
  if (xb[id].flag) {
    for (int i = xb[id].L; i <= xb[id].R; i++)
      x[i] = xb[id].make;
    xb[id].flag = false; xb[id].make = -1;
  }
  int cur = xb[id].begpl;
  for (int i = xb[id].L; i <= xb[id].R; i++) {
    x[i] += cur;
    cur += xb[id].step;
  }
  xb[id].begpl = 0;
  xb[id].step = 0;
}

void make_all_x(int l, int r, int tox) {
  for (int i = numx[l]; i <= numx[r]; i++) {
    if (l <= xb[i].L && xb[i].R <= r) {
      xb[i].flag = true;
      xb[i].make = tox;
      xb[i].begpl = xb[i].step = 0;
    } else {
      updx(i);
      for (int j = max(l, xb[i].L); j <= min(r, xb[i].R); j++)
        x[j] = tox;
    }
  }
}

void make_plus_x(int l, int r) {
  for (int i = numx[l]; i <= numx[r]; i++) {
    if (l <= xb[i].L && xb[i].R <= r) {
      xb[i].begpl += xb[i].L - l + 1;
      xb[i].step++;
    } else {
      updx(i);
      for (int j = max(l, xb[i].L); j <= min(r, xb[i].R); j++)
        x[j] += j - l + 1;
    }
  }
}

int getx(int i) {
  int id = numx[i];
  if (xb[i].flag)
    return xb[i].make + xb[i].begpl + xb[i].step * (i - xb[i].L);
  return x[i] + xb[i].begpl + xb[i].step * (i - xb[i].L);
}

void buildy() {
  for (int i = 1; i <= n; i++)
    y[i] = 0;
  for (int i = 1; i <= n; i++)
    numy[i] = (i - 1) / blocksz;
  for (int i = 1; i <= n; i++)
    Ry[numy[i]] = i;
  for (int i = n; i >= 1; i--)
    Ly[numy[i]] = i;
  szy = numy[n] + 1;
  for (int i = 0; i < szx; i++) {
    yb[i].flag = false;
    yb[i].make = -1;
    yb[i].begpl = 0;
    yb[i].step = 0;
    yb[i].L = Ly[i];
    yb[i].R = Ry[i];
  }
}

void updy(int id) {
  if (yb[id].flag) {
    for (int i = yb[id].L; i <= yb[id].R; i++)
      y[i] = yb[id].make;
    yb[id].flag = false; yb[id].make = -1;
  }
  int cur = yb[id].begpl;
  for (int i = yb[id].L; i <= yb[id].R; i++) {
    y[i] += cur;
    cur += yb[id].step;
  }
  yb[id].begpl = 0;
  yb[id].step = 0;
}

void make_all_y(int l, int r, int toy) {
  for (int i = numy[l]; i <= numy[r]; i++) {
    if (l <= yb[i].L && yb[i].R <= r) {
      yb[i].flag = true;
      yb[i].make = toy;
      yb[i].begpl = yb[i].step = 0;
    } else {
      updx(i);
      for (int j = max(l, yb[i].L); j <= min(r, yb[i].R); j++)
        y[j] = toy;
    }
  }
}

void make_plus_y(int l, int r) {
  for (int i = numy[l]; i <= numy[r]; i++) {
    if (l <= yb[i].L && yb[i].R <= r) {
      yb[i].begpl += yb[i].L - l + 1;
      yb[i].step++;
    } else {
      updx(i);
      for (int j = max(l, yb[i].L); j <= min(r, yb[i].R); j++)
        y[j] += j - l + 1;
    }
  }
}

int gety(int i) {
  int id = numy[i];
  if (yb[i].flag)
    return yb[i].make + yb[i].begpl + yb[i].step * (i - yb[i].L);
  return y[i] + yb[i].begpl + yb[i].step * (i - yb[i].L);
}

main() {
    // freopen("input1.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q;
    buildx();
    buildy();
    int type, l, r, j;
    for (int i = 1; i <= q; i++) {
      cin >> type;
      if (type == 1) {
        cin >> l >> r;
        pair<int, int> beg = {getx(l), gety(l)};
        pair<int, int> endd = {getx(r), gety(r)};
        // cout << l << " " << r << " " << beg.fi << " " << beg.se << " " << endd.fi << " " << endd.se << endl;
        if (beg.se == endd.se) {
          make_all_x(l, r, beg.fi);
          make_all_y(l, r, beg.se);
          make_plus_y(l + 1, r);
        } else {
          make_all_y(l, r, beg.se);
          make_all_x(l, r, beg.fi);
          make_plus_x(l + 1, r);
        }
      } else {
        cin >> j;
        pair<int, int> cur = {getx(j), gety(j)};
        cout << cur.fi << " " << cur.se << "\n";
      }
    }
    return 0;
}
