#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define f first
#define s second
#define forn(j, i, n) for(int i = j; i <= n; ++i)
#define mp make_pair
int const maxn = 2e5+100;
const int N = 2e5 + 10;

#define pii pair <int, int>

int n,q;
int tx[N * 4];
int ty[N * 4];
int tsx[N * 4];
int tsy[N * 4];
int tpx[N * 4];
int tpy[N * 4];
int tdx[N * 4];
int tdy[N * 4];
void build(int v,int tl,int tr)
{
    if(tl == tr)
    {
        tx[v] = tl;
        ty[v] = 1;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v + v,tl,tm);
    build(v + v + 1,tm + 1,tr);
}
void push(int v)
{
    if(tsx[v] != 0)
    {
        int val = tsx[v];
        tx[v + v] = val;
        tx[v + v + 1] = val;
        tsx[v + v] = val;
        tsx[v + v + 1] = val;
        tpx[v + v] = 0;
        tpx[v + v + 1] = 0;
        tdx[v + v] = 0;
        tdx[v + v + 1] = 0;
        tsx[v] = 0;
    }
    int val = tpx[v];
    tx[v + v] += val;
    tx[v + v + 1] += val;
    tpx[v + v] += val;
    tpx[v + v + 1] += val;
    val = tdx[v];
    tdx[v + v] += val;
    tdx[v + v + 1] += val;
    tpx[v] = 0;
    tdx[v] = 0;
    if(tsy[v] != 0)
    {
        val = tsy[v];
        ty[v + v] = val;
        ty[v + v + 1] = val;
        tsy[v + v] = val;
        tsy[v + v + 1] = val;
        tpy[v + v] = 0;
        tpy[v + v + 1] = 0;
        tdy[v + v] = 0;
        tdy[v + v + 1] = 0;
        tsy[v] = 0;
    }
    val = tpy[v];
    ty[v + v] += val;
    ty[v + v + 1] += val;
    tpy[v + v] += val;
    tpy[v + v + 1] += val;
    val = tdy[v];
    tdy[v + v] += val;
    tdy[v + v + 1] += val;
    tpy[v] = 0;
    tdy[v] = 0;
}
void addx(int v,int tl,int tr,int l,int r,int x)
{
    if(tl > r || tr < l)return;
    if(tl >= l && tr <= r)
    {
        tx[v] += x;
        tpx[v] += x;
        tdx[v]++;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    addx(v + v,tl,tm,l,r,x);
    addx(v + v + 1,tm + 1,tr,l,r,x);
}
void addy(int v,int tl,int tr,int l,int r,int x)
{
    if(tl > r || tr < l)return;
    if(tl >= l && tr <= r)
    {
        ty[v] += x;
        tpy[v] += x;
        tdy[v]++;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    addy(v + v,tl,tm,l,r,x);
    addy(v + v + 1,tm + 1,tr,l,r,x);
}
void setx(int v,int tl,int tr,int l,int r,int x)
{
    if(tl > r || tr < l)return;
    if(tl >= l && tr <= r)
    {
        tx[v] = x;
        tpx[v] = 0;
        tdx[v] = 0;
        tsx[v] = x;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    setx(v + v,tl,tm,l,r,x);
    setx(v + v + 1,tm + 1,tr,l,r,x);
}
void sety(int v,int tl,int tr,int l,int r,int x)
{
    if(tl > r || tr < l)return;
    if(tl >= l && tr <= r)
    {
        ty[v] = x;
        tpy[v] = 0;
        tdy[v] = 0;
        tsy[v] = x;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    sety(v + v,tl,tm,l,r,x);
    sety(v + v + 1,tm + 1,tr,l,r,x);
}
pii get(int v,int tl,int tr,int pos)
{
    if(tl == tr)
    {
        if(tdx[v])
        {
            tx[v] += tdx[v] * tl;
        }
        if(tdy[v])
        {
            ty[v] += tdy[v] * tl;
        }
        return mp(tx[v],ty[v] - 1);
    }
    push(v);
    int tm = (tl + tr) / 2;
    if(pos <= tm)
    {
        return get(v + v,tl,tm,pos);
    }else {
        return get(v + v + 1,tm + 1,tr,pos);
    }
}
int main()
{
    cin >> n >> q;
    build(1, 1, n);
    forn(1, i, q)
    {
        int ty;
        cin >> ty;
        if(ty == 1)
        {
            int l, r;
            cin >> l >> r;
            if(l == r)continue;
            pii val = get(1,1,n,l);
            pii val1 = get(1,1,n,r);
            val.s++;
            val1.s++;
            if(val.f == val1.f)
            {
                sety(1,1,n,l,r,val.s);
                setx(1,1,n,l,r,val.f);
                addx(1,1,n,l,r,-l);
            }else {
                setx(1,1,n,l,r,val.f);
                sety(1,1,n,l,r,val.s);
                addy(1,1,n,l,r,-l);
            }
        }
        else
        {
            int x;
            cin >> x;
            pii val = get(1,1,n,x);
            cout << val.f << " " << val.s << "\n";
        }
    }
}
