#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

const long long INF = (long long)(3e18) + 33ll;
long long n, ans = INF;

int main() {

	cin >> n;

	for (long long x = 1ll; x * x <= n; x++) 
		if (n % x == 0ll) {
			long long y = n / x;
			ans = min(ans, abs(x - y));
		}

	int N = (int)(4e6) + 13;
	for (long long x = 1ll; x <= N; x++) {
		if ((n - 1ll + x) % (2ll * x - 1ll) == 0ll) {
			long long k = (n - 1ll + x) / (2ll * x - 1ll);
			ans = min(ans, abs(2ll * k - 1ll - x));
		}
		if ((n + 1ll - x) % (2ll * x - 1ll) == 0ll) {
			long long k = (n + 1ll - x) / (2ll * x - 1ll);
			ans = min(ans, abs(2ll * k + 1ll - x));
		}
		if (n % (2ll * x - 1ll) == 0ll) {
			long long k = n / (2ll * x - 1ll);
			ans = min(ans, abs(2ll * k - x));
		}
	}

	cout << ans;
	return 0;
}