#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 5;
map< pair< int, int >, bool > is_edge;
vector< int > g[3 * N];
int ans;

void dfs(int v, int p, int kol) {
//    cout << v << " " << p << " " << kol << "\n";
    if (!kol) {
        if (is_edge[{v, 1}] || is_edge[{1, v}])
            ans++;
        return;
    }
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i];
        if (to != p)
            dfs(to, v, kol - 1);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    int n;
    int m;
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x;
        int y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
        is_edge[{x, y}] = is_edge[{y, x}] = true;
    }
    dfs(1, 1, 3);
    cout << ans;
    return 0;
}
