#include <cstring>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <queue>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <iterator>

#define ios ios_base::sync_with_stdio(0), cout.tie(0), cin.tie(0);
#define S second
#define F first
#define pb push_back
#define nl '\n'
#define NL cout << '\n';
#define EX exit(0)
#define all(s) s.begin(), s.end()
#define no_answer {cout << "NO"; exit(0);}
#define FOR(i, start, finish, k) for(llong i = start; i <= finish; i += k)

const long long MXN = 1e5 + 500;
const long long MNN = 1e2 + 1;
const long long MOD = 1e9 + 7;
const long long INF = 1e18;
const long long OO = 1e9;

typedef long long llong;
typedef unsigned long long ullong;

using namespace std;

int n, m, clr[MXN], nw;
int used[MXN];
vector<int> g[MXN];
vector<int> cv[MXN];
vector<pair<int, int> > edges;

void dfs(int x, int p){
    used[x] = 1;
    for(int i = 0; i < g[x].size(); i++){
        int to = g[x][i];
        if(used[to] == 0){
            edges.push_back({x, to});
            used[to] = 1;
            dfs(to, x);
        }else if(used[to] == 1){
            continue;
        }else{
            nw++;
            edges.push_back({nw, x});
            clr[nw] = clr[to];
        }
    }
    used[x] = 2;
}

int main() {
    cin >> n >> m;
    nw = n;
    for(int i = 1; i <= n; i++){
        clr[i] = i;
    }
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    dfs(1, 0);
    cout << nw << nl;
    for(int i = 1; i <= nw; i++){
        cout << clr[i] << ' ';
    }
    cout << nl;
    for(int i = 0; i < edges.size(); i++){
        cout << edges[i].F << ' ' << edges[i].S << nl;
    }
}
