#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <cstdio>

using namespace std;

struct A {
    int v;
    int dpt;
    int pr;
};

queue<A> q;
vector<vector<int>> graph(100000);

int main()
{
  int n=0,m=0;

  cin >> n >> m;
  int u=0, v=0;

  for (int i = 0; i < m; i++) {
    cin >> u >> v;
    u--;
    v--;
    graph[u].push_back(v);
    graph[v].push_back(u);
  }

  q.push({0, 0, 0});
  int c = 0;
  int res = 0;

  vector<int> p;

  while (!q.empty()) {
    A u = q.front();
    q.pop();

    if (u.dpt == 3) {
        p.push_back(u.v);
    } else {
        for (int i : graph[u.v]) {
            if (i != u.pr) {
                q.push({i, u.dpt + 1, u.v});
            }
        }
    }
  }

  for (int i : p) {
    for (int j : graph[i]) {
        if (j == 0) {
            res++;
            break;
        }
    }
  }

  cout << res;

  return 0;
}
