#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <cstdio>

using namespace std;

struct A {
    int v;
    int dpt;
    int pr;
};

vector<vector<int>> graph(100000);

bool dist3(int u) {
    queue<A> q;
    q.push({u,0,-1});
    
    while (!q.empty()) {
        auto u = q.front();
        q.pop();
        
        if (u.v == 0 && u.dpt == 3) {
            return true;
        }
        
        if (u.dpt < 3) {
            for(int i : graph[u.v]) {
                if (i != u.pr) {
                    q.push({i, u.dpt + 1, u.v});
                }
            }
        }
    }
    
    return false;    
}

int main()
{
  int n=0,m=0;

  cin >> n >> m;
  int u=0, v=0;

  for (int i = 0; i < m; i++) {
    cin >> u >> v;
    u--;
    v--;
    graph[u].push_back(v);
    graph[v].push_back(u);
  }

  int c = 0;
  int res = 0;
  
  for (int i : graph[0]) {
      if (dist3(i)) {
          res++;
      }
  }

  cout << res;

  return 0;
}
