//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt")
//#pragma GCC target("avx,avx2")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<unordered_set>
#include<unordered_map>
#include<algorithm>
#include<iostream>
#include<string.h>
#include<iomanip>
#include<cstring>
#include<fstream>
#include<vector>
#include<string>
#include<memory>
#include<chrono>
#include<random>
#include<cmath>
#include<ctime>
#include<queue>
#include<stack>
#include<map>
#include<set>
using namespace std;
//no more #define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for(int i = 0; i < (n); i++)
#define cmn(a, b) (a) = min((a), (b))
#define cmx(a, b) (a) = max((a), (b))
typedef long long ll;
typedef long double ld;
void Start() {
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
}
bool endline = false;
bool endlineA = false;
template<class T>
istream& operator >> (istream& in, vector<T>& v) {
    for (auto& i : v) {
        in >> i;
    }
    return in;
}
template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto i : v) {
        out << i;
        if (!endline) {
            out << ' ';
        }
        else {
            out << '\n';
        }
    }
    if (!endline && endlineA) {
        out << '\n';
    }
    return out;
}
template<class T, class U>
istream& operator >> (istream& in, pair<T, U>& p) {
    in >> p.first >> p.second;
    return in;
}
template<class T, class U>
ostream& operator<<(ostream& out, const pair<T, U>& p) {
    out << p.first << ' ' << p.second;
    return out;
}
long long gettime() {
    return chrono::high_resolution_clock::now().time_since_epoch().count() / 1000000;
}
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
long long randnum(long long l, long long r) {
    return l + rnd() % (r - l + 1);
}
struct node {
    int l, r;
    ll pusha, pushd;
    ll x;
    node() {}
    node(int _l, int _r) :l(_l), r(_r), pusha(0), pushd(0), x(0) {}
    node operator+(const node& n)const {
        node res(l, n.r);
        return res;
    }
};
struct segment_tree {
    int n;
    vector<node>t;
    void build(int k) {
        n = 1;
        while (n < k)n *= 2;
        n *= 2;
        t.resize(n);
        for (int i = n / 2; i < n; i++)t[i] = node(i - n / 2, i - n / 2);
        for (int i = n / 2 - 1; i >= 1; i--)t[i] = t[2 * i] + t[2 * i + 1];
    }
    void push(int v) {
        if (t[v].l == t[v].r) {
            t[v].x += t[v].pusha;
            t[v].pusha = 0;
            return;
        }
        if (t[v].pusha == 0 && t[v].pushd == 0)return;
        t[2 * v].pusha += t[v].pusha;
        t[2 * v].pushd += t[v].pushd;
        t[2 * v + 1].pusha += t[v].pusha + t[v].pushd * (t[2 * v].r - t[2 * v].l + 1);
        t[2 * v + 1].pushd += t[v].pushd;
        t[v].pusha = 0;
        t[v].pushd = 0;
    }
    void add(int v, int l, int r, int a, int d) {
        push(v);
        if (l <= t[v].l && t[v].r <= r) {
            t[v].pusha = a;
            t[v].pushd = d;
            push(v);
            return;
        }
        if (r < t[v].l || t[v].r < l)return;
        add(2 * v, l, r, a, d);
        add(2 * v + 1, l, r, a + (ll)(t[2 * v + 1].l - l) * d, d);
    }
    void add(int l, int r, int d) {
        add(1, l, r, 0, d);
    }
    ll get(int v, int pos) {
        push(v);
        if (t[v].l == t[v].r) {
            return t[v].x;
        }
        if (pos <= t[2 * v].r) {
            return get(2 * v, pos);
        }
        else {
            return get(2 * v + 1, pos);
        }
    }
    ll get(int pos) {
        return get(1, pos);
    }
};
signed main() {
    Start();
    int n, q;
    cin >> n >> q;
    segment_tree st;
    st.build(n);
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            if (l == r)continue;
            ll a0 = st.get(l), a1 = st.get(l + 1);
            if (a0 == a1) {
                st.add(l, r, 1);
            }
            else {
                st.add(l, r, -1);
            }
        }
        else {
            int pos;
            cin >> pos;
            pos--;
            cout << pos - st.get(pos) + 1 << ' ' << st.get(pos) << '\n';
        }
    }
    return 0;
}