﻿#include <iostream>
#include <cmath>
#include <algorithm>
#include <queue>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <iomanip>
#include <cstring>
#include <cstdio>
// #include <bits/stdc++.h>

#pragma GCC push_options
#pragma GCC optimize ("O0")

using namespace std;

typedef string str;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef ll var;
typedef pair <var, var> pvv;

#define start ios_base::sync_with_stdio(false)
#define updiv(ad, bd) (((ad - 1) / bd ) + 1)
#define mod(ad, bd) ((((ad) % (bd)) + (bd)) % (bd))
#define mxz(ad, bd) ad = max( ad, bd )
#define mnz(ad, bd) ad = min( ad, bd )
#define maxx(ad, bd, c) max(ad, max(bd, c))
#define minn(ad, bd, c) min(ad, min(bd, c))
#define np(ad) next_permutation(all(ad))
#define arr( ad, bd, cd ) (ad + bd), (ad + bd +cd)
#define all( ad ) ad.begin(), ad.end()
#define gl(ad) getline(cin, ad)
#define wfloat(ad)  fixed << setprecision(ad)

// /*horse*/ pii dr[8] = { mp(2, 1), mp(2, -1), mp(-2, 1), mp(-2, -1), mp(1, 2),
// mp(1, -2), mp(-1, 2), mp(-1, -2) };

#define rv reverse
#define nl endl
#define pb push_back
#define in insert
#define sz size
#define mp make_pair
#define pr pair
#define tp top
#define ft front
#define et empty
#define op operator
#define f first
#define s second
#define x first
#define y second
#define y1 yyyyy
#define cont continue

// freopen("smth.in", "r", stdin);
// freopen("smth.out", "w", stdout);

const int dx[] = {0, 1, 0, -1, 1, -1, -1, 1};
const int dy[] = {1, 0, -1, 0, 1, -1, 1, -1};

const ll B = 47 ; //hashbase
const double PI = 3.14159;
const ll LINF = 1e18; //infinity
const ll N = 1e6+9; //maxn
const ll M = 998244353; //mod
const ll INF = 1e9; //infinity

ll n, l;
pii p[N];

bool inner(pii a, pii b) {
    // cout << '#' << a.x << ' ' << a.y << ',' << b.x << ' ' << b.y << ':' << a.x * b.y - a.y * b.x << '\n';
    return a.x * b.y - a.y * b.x >= 0;
}

ld dist(pii a, pii b) {
    ld c = a.x - b.x;
    ld d = a.y - b.y;
    return sqrt(c*c + d*d);
}

ld solve() {
    ld ans = 0.0;
    vector <pii> dots;
    for (ll i = 1; i <= n; ++i) {
        ll j, k;
        if (i > 1)
            j = i-1;
        else
            j = n;
        if (i < n)
            k = i+1;
        else
            k = 1;
        // cout << '?' << i << ':' << j << ' ' << k << '\n';
        pii a = mp(p[k].f - p[i].f, p[k].s - p[i].s);
        pii b = mp(p[j].f - p[i].f, p[j].s - p[i].s);
        if (!inner(a, b)) {
            // cout << '\t' << '$' << '\n';
            pii c, d;
            if (a.f == 0)
                if (a.s > 0)
                    c = mp(p[i].f, p[i].s - l);
                else
                    c = mp(p[i].f, p[i].s + l);
            else
                if (a.f > 0)
                    c = mp(p[i].f - l, p[i].s);
                else
                    c = mp(p[i].f + l, p[i].s);

            if (b.f == 0)
                if (b.s > 0)
                    d = mp(p[i].f, p[i].s - l);
                else
                    d = mp(p[i].f, p[i].s + l);
            else
                if (b.f > 0)
                    d = mp(p[i].f - l, p[i].s);
                else
                    d = mp(p[i].f + l, p[i].s);
            dots.pb(c);
            dots.pb(d);
            // cout << '\t' << c.x << ' ' << c.y << '\n';
            // cout << '\t' << d.x << ' ' << d.y << '\n';
        }
    }
    for (ll i = 0; i < dots.sz(); ++i) {
        ll j, k;
        if (i > 0)
            j = i-1;
        else
            j = dots.sz()-1;
        // cout << '!' << i << ' ' << j << ':' << dist(dots[i], dots[j]) << '\n';
        // cout << '\t' << dots[j].f << ' ' << dots[j].s << ',' << dots[i].f << ' ' << dots[i].s << '\n';
        ans += dist(dots[i], dots[j]);
    }
    return ans;
}

int main() {
    cin >> n >> l;
    for (ll i = 1; i <= n; ++i) {
        cin >> p[i].f >> p[i].s;
    }
    // for (ll i = 1; i <= n; ++i) {
    //
    // }
    ld a = 0, b = 0;
    a = solve();
    rv(p + 1, p + 1 + n);
    // cout << "\n \n \n \n";
    b = solve();
    cout << wfloat(9) << max(a, b) << '\n';
}