﻿#include <iostream>
#include <cmath>
#include <algorithm>
#include <queue>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <iomanip>
#include <cstring>
#include <cstdio>
// #include <bits/stdc++.h>

#pragma GCC push_options
#pragma GCC optimize ("O0")

using namespace std;

typedef string str;
typedef long long ll;
typedef double db;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <db, db> pdd;
typedef pair <ld, ld> pld;
typedef ll var;
typedef pair <var, var> pvv;

#define start ios_base::sync_with_stdio(false)
#define updiv(ad, bd) (((ad - 1) / bd ) + 1)
#define mod(ad, bd) ((((ad) % (bd)) + (bd)) % (bd))
#define mxz(ad, bd) ad = max( ad, bd )
#define mnz(ad, bd) ad = min( ad, bd )
#define maxx(ad, bd, c) max(ad, max(bd, c))
#define minn(ad, bd, c) min(ad, min(bd, c))
#define np(ad) next_permutation(all(ad))
#define arr( ad, bd, cd ) (ad + bd), (ad + bd +cd)
#define all( ad ) ad.begin(), ad.end()
#define gl(ad) getline(cin, ad)
#define wfloat(ad)  fixed << setprecision(ad)

// /*horse*/ pii dr[8] = { mp(2, 1), mp(2, -1), mp(-2, 1), mp(-2, -1), mp(1, 2),
// mp(1, -2), mp(-1, 2), mp(-1, -2) };

#define rv reverse
#define nl endl
#define pb push_back
#define in insert
#define sz size
#define mp make_pair
#define pr pair
#define tp top
#define ft front
#define et empty
#define op operator
#define f first
#define s second
#define x first
#define y second
#define y1 yyyyy
#define cont continue

// freopen("smth.in", "r", stdin);
// freopen("smth.out", "w", stdout);

const int dx[] = {0, 1, 0, -1, 1, -1, -1, 1};
const int dy[] = {1, 0, -1, 0, 1, -1, 1, -1};

const ll B = 47 ; //hashbase
const double PI = 3.14159;
const ll LINF = 1e18; //infinity
const ll N = 1e6+9; //maxn
const ll M = 998244353; //mod
const ll INF = 1e9; //infinity

ll n, l;
pld p[N];

bool inner(pld a, pld b) {
    // cout << '#' << a.x << ' ' << a.y << ',' << b.x << ' ' << b.y << ':' << a.x * b.y - a.y * b.x << '\n';
    return a.x * b.y - a.y * b.x >= 0;
}

ld dist(pld a, pld b) {
    ld c = a.x - b.x;
    ld d = a.y - b.y;
    return sqrt(c*c + d*d);
}

pair <ld, ll> solve() {
    ld ans = 0.0;
    ll cnt = 0;
    vector <pld> dots;
    for (ll i = 1; i <= n; ++i) {
        ll j, k;
        if (i > 1)
            j = i-1;
        else
            j = n;
        if (i < n)
            k = i+1;
        else
            k = 1;
        // cout << '?' << i << ':' << j << ' ' << k << '\n';
        pld a = mp(p[k].f - p[i].f, p[k].s - p[i].s);
        pld b = mp(p[j].f - p[i].f, p[j].s - p[i].s);
        if (!inner(a, b)) {
            // cout << '\t' << '$' << '\n';
            pld c, d;
            if (a.f == 0)
                if (a.s > 0)
                    c = mp(p[i].f, p[i].s - l);
                else
                    c = mp(p[i].f, p[i].s + l);
            else
                if (a.f > 0)
                    c = mp(p[i].f - l, p[i].s);
                else
                    c = mp(p[i].f + l, p[i].s);

            if (b.f == 0)
                if (b.s > 0)
                    d = mp(p[i].f, p[i].s - l);
                else
                    d = mp(p[i].f, p[i].s + l);
            else
                if (b.f > 0)
                    d = mp(p[i].f - l, p[i].s);
                else
                    d = mp(p[i].f + l, p[i].s);
            dots.pb(c);
            dots.pb(d);
            // cout << '\t' << c.x << ' ' << c.y << '\n';
            // cout << '\t' << d.x << ' ' << d.y << '\n';
        } else {
            cnt++;
        }
    }
    for (ll i = 0; i < dots.sz(); ++i) {
        ld j, k;
        if (i > 0)
            j = i-1;
        else
            j = dots.sz()-1;
        // cout << '!' << i << ' ' << j << ':' << dist(dots[i], dots[j]) << '\n';
        // cout << '\t' << dots[j].f << ' ' << dots[j].s << ',' << dots[i].f << ' ' << dots[i].s << '\n';
        ans += dist(dots[i], dots[j]);
    }
    return mp(ans, cnt);
}

int main() {
    cin >> n >> l;
    for (ll i = 1; i <= n; ++i) {
        cin >> p[i].f >> p[i].s;
    }
    // for (ld i = 1; i <= n; ++i) {
    //
    // }
    pair <ld, ll> a, b;
    a = solve();
    rv(p + 1, p + 1 + n);
    b = solve();
    ld ans;
    if (a.s < b.s)
        ans = a.f;
    else
        ans = b.f;
    cout << wfloat(9) << ans << '\n';
}