import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class I {
    private static StringTokenizer st = null;
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        PrintWriter out = new PrintWriter(System.out);
        int n = nextInt();
        int m = nextInt();
        LinkedList<Integer>[] graph = new LinkedList[n];
        for (int i = 0; i < n; i++) graph[i] = new LinkedList<>();
        for (int i = 0; i < m; i++) {
            int a = nextInt(), b = nextInt();
            graph[a - 1].add(b - 1);
            graph[b - 1].add(a - 1);
        }
        boolean[] met;
        boolean[] da = new boolean[n];
        for (int u : graph[0]) da[u] = true;
        for (int u : graph[0]) {
            met = new boolean[n];
            met[0] = true;
            dfs(graph, u, 1, met, da);
        }
        out.println(g);
        out.close();
    }

    private static int g = 0;

    private static void dfs(LinkedList<Integer>[] graph, int v, int depth, boolean[] met, boolean[] da) {
        met[v] = true;
        if (depth == 3) {
            if (da[v]) g++;
            return;
        }
        for (int u : graph[v]) {
            if (!met[u]) {
                dfs(graph, u, depth + 1, met, da);
            }
        }
    }
}
