﻿#include <iostream>
#include <vector>
#include <cmath> 
#include <random>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>

#define kak_zhe_hochetsya_tyanochku ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define in(i, a) for(auto i : a)
#define inl(i, a) for(auto& i : a)

using namespace std;

using ll = long long;

const ll INF = 1e18 + 7, MOD = 1e9 + 7;

template <class T> void print(vector<T>& a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << "\n";
}

ll l[112];
int n;

vector <vector <bool>> dp(2, vector <bool>(1000000, false));

int main() {
    kak_zhe_hochetsya_tyanochku;
    cin >> n;
    rep(i, n) {
        cin >> l[i];
    }
    dp[0][0] = true;
    rep(i, n) {
        rep(j, 1000000) {
            if (dp[i % 2][j]) {
                dp[(i + 1) % 2][j] = true;
            }
            else if (j >= l[i] && dp[i % 2][j - l[i]]) {
                dp[(i + 1) % 2][j] = true;
            }
        }
    }
    ll count = 0, t = 0;
    rep(i, 1000000) {
        if (dp[n % 2][i]) {
            count += i + 1;
            ++t;
        }
    }
    cout << 2 * count - t * (t + 1) / 2;
}

