#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <bitset> 
#include <vector>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>


#define int long long
#define ll long long 
bool FLAG = 0;
#define debug(x) if (FLAG) { 	cerr << #x << " = " << x << endl;}
#define debug_vec(x) if (FLAG) {cerr << #x << " = {"; for (auto to x) cout << to << ", "; cout << "}" << endl}
#define F first
#define S second                               
#define sqr(x) ((x) * (x))
#define make make_pair
#define pb push_back
#define sz(x) (int)(x.size()) 
#define all(x) x.begin (), x.end ()

using namespace std;
                        
typedef unsigned long long ull;
typedef long double ld;                                            

const int MOD = 1e9 + 7, N = (int)2e6+ 222;
const int INF = (int)1e18;
const ld eps = (ld)1e-6;

int dx[] = {0, -1, 0, 1, 0};
int dy[] = {0, 0, 1, 0, -1};
                          
int n, m, pain[N], color[N], used[N], l[N], r[N], T;
vector < pair <int, int> > g[N], res;
vector <int> g1[N];

void dfs (int x = 1, int pr = -1) {
 	used[x] = 1;
 	for (auto to : g[x]) {
 		if (to.F == pr) continue;
 		if (used[to.F] == 1) {
 			T++;
 			g1[x].pb(T);
 			g1[T].pb(x);
 			color[T] = color[to.F];
 			pain[to.S] = 1;
  		}
  		if (used[to.F] == 0) {
  			dfs(to.F, x);
  		} 
 	}
 	used[x] = 2;
}
void ans (int x = 1, int pr = -1) {
	for (auto to : g1[x]) {
		if (to == pr) continue;
		res.pb({x, to});
		ans(to, x);
	}
} 

inline void solve () {
	cin >> n >> m;
	T = n;
	for (int i = 1; i <= n; ++i) color[i] = i;
	for (int i = 1; i <= m; ++i) {
		cin >> l[i] >> r[i];
		g[l[i]].pb({r[i], i});
		g[r[i]].pb({l[i], i});
   	}
   	dfs();

   	for (int i = 1; i <= m; ++i) {
   		 if (pain[i] == 0) {
   		 	g1[l[i]].pb(r[i]);
   		 	g1[r[i]].pb(l[i]);
   		 }
   	}

   	cout << T << endl;
   	for (int i = 1; i <= T; ++i) cout << color[i] << " ";
   	ans();
   	cout << endl;
   	for (int i = 0; i < sz(res); ++i) {
   		cout << res[i].F << " " << res[i].S << endl;		
   	}
   	
	
}	
	    

signed main () {
	#ifdef Maga
		freopen("input", "r", stdin);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);	
	int t = 1;
//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}