#include <bits/stdc++.h>

#define F first
#define S second
#define mp make_pair

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()

#define bpp __builtin_popcount
#define dbg(var) cout << #var << "=" << var << endl;

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef pair<int,int> pii;
typedef double db;

ll binpow(ll a,ll b){ 
	ll res = 1; 
	while(b > 0){
		if(b & 1) 
			res *= a;
		a *= a;
		b >>= 1;
	}
	return res;
}

ll powmod(ll a,ll b,ll m){
	ll res = 1;
	while(b > 0){
		if(b & 1)
			res = (res * a) % m;
		a = (a * a) % m;
		b >>= 1;
	}
	return res;
}

ll gcd(ll a,ll b){ 
	return (b > 0 ? gcd(b,a % b) : a); 
}

const int N = (int)5e5 + 5;
const int mod = (int)1e9 + 7;
const long long inf = (long long)1e18 + 18;

int n,m;

int ok[N],ok2[N],ok3[N];

vector<int> g[N];

queue<int> q;



void solve(){
	cin >> n >> m;
	for(int i = 1; i <= m; i++){
		int x,y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
	}	
	for(int to : g[1]) ok[to] = 1;
	for(int i = 1; i <= n; i++){
		if(ok[i] == 1) 
			for(int to : g[i]) ok2[to] += 1;
	}
	for(int i = 1; i <= n; i++){
		if(ok2[i])
			for(int to : g[i]) ok3[to] += ok2[i];
	}
	int cnt = 0;                       
	for(int to : g[1]){
		cnt += ok3[to];	
	}
	for(int to : g[1]) {
		cnt -= ok2[1];
	}
	for (int to : g[1]) {
		cnt -= sz(g[to]) - 1;
	}
	cout << cnt;
}

int main(){
	ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);
	int tt = 1;
	//cin >> tt;
	while(tt--) solve();
	return 0;
}