#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<set<int>> park;
int ans = 0;

void DFS(int currentVertex, int counter, int pred);

int main() {
	int n, m, p1, p2;
	cin >> n >> m;

	park.resize(n);

	for (int i = 0; i < m; i++) {
		cin >> p1 >> p2;

		park[--p1].emplace(--p2);
		park[p2].emplace(p1);
	}

	DFS(0, 0, -1);

	cout << ans;
	return 0;
}

void DFS(int currentVertex, int counter, int pred) {
	
	vector<int> visited;

	if (counter == 3) {
		if (park[currentVertex].find(0) != park[currentVertex].end()) {
			ans++;
		}
		return;
	}

	for (auto& i : park[currentVertex]) {
		if (i != pred) {
			DFS(i, counter + 1, currentVertex);
			visited.push_back(i);
		}
	}
}
