#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;

template<typename T1, typename T2>
bool chkmax(T1 &a, T2 b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chkmin(T1 &a, T2 b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

int max(int a, int b) { return a > b ? a : b; }

ld sqr(ld a) { return a * a; }

const int INF = 1e18;

#define endl "\n"
#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    vector <int> can(sum + 1, 0);
    can[0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = sum; j >= a[i]; --j) {
            if (can[j - a[i]]) {
                can[j] = 1;
            }
        }
    }
    int k = 0;
    for (int i = 0; i <= sum; ++i) {
        if (can[i]) {
            ++k;
        }
    }
    int ans = 0;
    for (int i = 0; i <= sum; ++i) {
        if (can[i]) {
            ans += sum + 1 - i;
        }
    }
    --ans;
    //--k;
    ans *= 2;
    ans -= k * (k + 1) / 2 - 2;
    cout << ans << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}