﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <string>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <ctime>  

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else return bin_pow(a, n - 1) * a;
}
ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}



int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	long double n, v, u;
	cin >> n >> v >> u;
	long double t = 0;
	vector<long double>a;
	for (int i = 0; i < n; i+=1)
	{
		int q;
		cin >> q;
		a.push_back(q);
	}
	sort(a.rbegin(), a.rend());
	long double count = 1;

	while (true)
	{
		
		if (count == n)
		{
			cout <<fixed<<setprecision(7)<< (t + max((a[count - 1] - t * v) / (u/count + v), (long double)0))*u;
			return 0;
		}
		if (a[count - 1] == a[count])
		{
			count++;
			continue;
		}
		if (((a[count - 1] - a[count]) / (u / count) + t) * v > a[count])
		{
			cout <<fixed<<setprecision(7)<< (t + ((a[count-1] - t * v) / (u/count+v)))*u;
			return 0;
		}
		t += (a[count - 1] - a[count]) / (u / count);
		count += 1;
	}
	return 0;
}