#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 300001;
const double e = 1e-6;

ll A[N];
ll n, u, v;
double res = 1e15;

bool good(double x) {
    double t = 0;
    for (ll i = 0; i < n; i++) {
        t += max((double)(0), ((double)(A[i]) - x * v));
    }
    if (t > x* u) {
        return 0;
    }
    res = t;
    return 1;
}
int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    cin >> n >> v >> u;
    for (ll i = 0; i < n; i++) {
        cin >> A[i];
    }
    double l = 0, r = 1e9;
    while ((r - l) > e) {
        double m = (r + l) / 2;
        if (good(m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    cout << fixed << setprecision(7) << res;
}