#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
#include <map>
#include <set>

#define INF 100

using namespace std;

vector <set <int> > g;
vector <int> k;

vector <int> u;

int nv;

int dfs(int v, int p) {
    u[v] = 1;
    
    vector <int> delt;
    vector <int> add;
    
    for (set<int>::iterator it = g[v].begin(); it != g[v].end(); ++it) {
        int to = *it;
        
        if (!u[to]) {
            dfs(to, v);
        }
        else if (to != p) {
            g[to].erase(v);
            delt.push_back(to);
            add.push_back(nv);
            
            g[nv].insert(v);
            k.push_back(to + 1);
            u.push_back(1);
            
            ++nv;
        }
    }
    
    for (int i = 0; i < delt.size(); ++i) {
        g[v].erase(delt[i]);
    }
    
    for (int i = 0; i < add.size(); ++i) {
        g[v].insert(add[i]);
    }
    
    return 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    
    int n, m;
    cin >> n >> m;
    
    g.resize(n * 2, set <int> ());
    k.resize(n);
    
    u.resize(n, 0);
    
    for (int i = 0; i < n; ++i) {
        k[i] = i + 1;
    }
    
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        
        g[u - 1].insert(v - 1);
        g[v - 1].insert(u - 1);
    }
    
    /*
    for (int i = 0; i < n; ++i) {
        cout << i + 1 << ": ";
        
        for (set<int>::iterator it = g[i].begin(); it != g[i].end(); ++it) {
            cout << *it + 1 << ' ';
        }
        
        cout << '\n';
    }
    
    cout << '\n';
     */
    
    nv = n;
    
    dfs(0, -1);
    
    /*
    for (int i = 0; i < nv; ++i) {
        cout << i + 1 << ": ";
        
        for (set<int>::iterator it = g[i].begin(); it != g[i].end(); ++it) {
            cout << *it + 1 << ' ';
        }
        
        cout << '\n';
    }
     */
    
    cout << nv << '\n';
    
    for (int i = 0; i < nv; ++i) {
        cout << k[i] << ' ';
    }
    
    cout << '\n';
    
    for (int i = 0; i < nv; ++i) {
        for (set<int>::iterator it = g[i].begin(); it != g[i].end(); ++it) {
            cout << i + 1 << ' ' << *it + 1 << '\n';
            g[*it].erase(i);
        }
    }
    
    return 0;
}
