#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const int N = 3e5 + 5;

long double a[N];

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    long double v, u;
    cin >> n >> v >> u;
    long double sum = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        sum += a[i];
    }
    sort(a, a + n);
    long double l = 0;
    long double r = sum;
    while (r - l >= 5e-7)
    {
        long double s = (l + r) / 2;
        long double m;
        long double s1 = s;
        for (int i = 0; i < n; i++)
        {
            if (s1 / (n - i) <= a[i])
            {
                m = s1 / (n - i);
                break;
            }
            else
            {
                s1 -= a[i];
            }
        }
        if ((sum - s) / m >= u / v)
        {
            l = s;
        }
        else
        {
            r = s;
        }
    }
    cout << fixed << setprecision(6) << (sum - l);
}
