#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const ll Base = 2e5 + 9;

int n, m;
vector<int> e[Base];
ll correctE[Base];
pair<int, int> allE[Base];
bool close[Base];
ll ans = 0;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		e[a].push_back(b);
		e[b].push_back(a);
		allE[i] = make_pair(a, b);
	}

	for (auto v : e[0])
	{
		close[v] = true;
	}

	correctE[0] = 0;
	for (int i = 1; i < n; i++)
	{
		correctE[i] = 0;
		for (auto v : e[i])
		{
			if (close[v])
			{
				correctE[i]++;
			}
		}
		ll k = correctE[i];
		ans += k * (k - 1);
	}

	cout << ans << endl;

	return 0;
}