#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
#ifdef LOCALRUN
    freopen("C++/input.txt", "r", stdin);
    freopen("C++/output.txt", "w", stdout);
#endif
    
#ifndef LOCALRUN
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

vector<int> vec[100000];
bool used[100000];
int arr[100000];
int ans[200000];
int parent[100000];

inline void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vec[a].push_back(b);
        vec[b].push_back(a);
    }

    for (int i = 0; i < n; i++) {
        ans[i] = i;
    }

    int arrPos = n;

    int pos = 1;
    used[0] = true;
    while (pos != 0) {
        int node = arr[--pos];
        for (int i = 0; i < vec[node].size(); i++) {
            if (!used[i]) {
                used[i] = true;
                arr[pos++] = i;
                parent[i] = node;
            } else {
                if (parent[node] != i) {
                    ans[arrPos] = vec[node][i];
                    vec[node][i] = arrPos;
                    arrPos++;
                }
            }
        }
    }

    cout << arrPos << nl;
    for (int i = 0; i < arrPos; i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << nl;
    for (int i = 0; i < n; i++) {
        for (int j: vec[i]) {
            if (i < j) {
                cout << i + 1 << ' ' << j + 1 << nl;
            }
        }
    }
}

int main()
{
    prepare();
    once
    return 0;
}
