#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
#ifdef LOCALRUN
    freopen("C++/input.txt", "r", stdin);
    freopen("C++/output.txt", "w", stdout);
#endif
    
#ifndef LOCALRUN
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

ld arr[300000];

inline void solve() {
    int n, v, u;
    cin >> n >> v >> u;

    ld sm = 0;
    
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        sm += arr[i];
    }

    sort(arr, arr + n);

    ld ans = 0;
    for (int i = 0; i < n; i++) {
        ld newTime = sm / ((n - i) * v + u);
        if (newTime > arr[i]) {
            newTime = arr[i];
        }
        ans += newTime;
        sm -= newTime * ((n - i) * v + u);
    }

    cout << ans * u;
}

int main()
{
    prepare();
    once
    return 0;
}
