#include <bits/stdc++.h>
#define all(x) x.begin(),x.end()

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
typedef long long ll;

const int N = (ll) 1e6 + 1;
const int inf = (ll) 1e9 + 1;

ll n, m, x, y, cnt, ans, visited[N];

vector<ll> g[N];
multiset <ll> st;

void dfs(ll v, ll cnt) {
	visited[v] = true;
	cnt++;
	if(cnt == 4) {
		for(ll i = 0; i < g[1].size(); i++) {
			ll to = g[1][i];
			if(to == v) {
				st.insert(to);
			}
		}
		return;
	}
	for(ll i = 0; i < g[v].size(); i++) {
		ll to = g[v][i];
		if(visited[to] == false) {
			dfs(to, cnt);
			visited[to] = false;
		}
	}
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for(ll i = 1; i <= m; i++) {
    	cin >> x >> y;
    	g[x].push_back(y);
    	g[y].push_back(x);
	}
	dfs(1, 0);
	cout << st.size();
    return 0;
}
