﻿#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <math.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9, MAXN = 1e5 + 1;

vector<ll> ans1;
vector<pair<ll,ll>> g[MAXN], ans2;
ll used[MAXN];

void dfs(ll v, ll p = -1) {

    used[v] = 1;

    for (ll i = 0; i < g[v].size(); ++i) {
        ll to = g[v][i].first;

        if (to == p) continue;

        if (used[to] != 2) {
            ans1.push_back(to);
            ans2.push_back({ans1.size() - 1, ans1.size()});
            if (!used[to]) dfs(to, v);
        }
    }

    used[v] = 2;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    ll n, m, v, u;
    cin >> n >> m;
    for (ll i = 0; i < m; ++i) {
        cin >> v >> u;
        g[v].push_back({u, i});
        g[u].push_back({v, i});
    }

    fill (used, used + MAXN, 0);
    ans1.push_back(1);
    dfs(1);

    cout << ans1.size() << '\n';
    for (ll i = 0; i < ans1.size(); ++i) cout << ans1[i] << ' ';
    for (ll i = 0; i < ans2.size(); ++i) cout << '\n' << ans2[i].first << ' ' << ans2[i].second;

    return 0;
}
