//Team: Bermud
//Coder: Emin

#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define pii pair <int, int>
#define pb push_back
#define F first
#define S second
#define ll long long
#define io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define M_PI 3.14159265358979323846

const int N = 200005;
const int mod = 1e9 + 7;

int n, m;
vector <int> a[N];
int len[N], used[N];
queue <int> q;

void BFS(int node){
    used[node] = 1;
    q.push(node);
    while(!q.empty()){
        int s = q.front();
        q.pop();
       // if(len[s] == 2) continue;
        for(int i : a[s]){
            if(!used[i]){
                used[i] = s;
                len[i] = len[s] + 1;
                q.push(i);
            }
        }
    }
}

int main() {
    io;
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        a[x].pb(y);
        a[y].pb(x);
    }
    BFS(1);
    int ans = 0;
    for(int i = 1; i <= n; i++){
        if(len[i] != 1) continue;
        for(int j : a[i]){
            if(len[j] == 2 && used[j] != i){
                ans += 2;
                //cout << j << " ";
            }
        }
    }
    cout << ans;
}
/*
10 14
1 5
2 5
5 6
2 3
1 3
2 4
4 6
1 6
1 7
7 8
8 1
1 10
9 10
9 8
*/
