﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define pint pair<int, int>
#define pll pair<ll, ll>

const ll inf = 1e9;
const ll INF = 1e18;
const ll M = 998244353;
const double eps = 1e-10;

//#define int ll

int n;
double v, u;
vector<int> a;
bool ok(double t)
{
    double f = 0.0;
    for (int i = 0; i < n; ++i)
    {
        if (a[i] >= t * v)
        {
            f += (a[i] - t * v) / u;
        }
    }
    return (f - eps <= t);
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    
    cin >> n >> v >> u;
    a.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    double l = 0, r = 1e18;
    for (int i = 0; i < 300; ++i)
    {
        double c = (l + r) / 2;
        if (ok(c))
            r = c;
        else
            l = c;
    }
    cout << fixed << setprecision(10) << r * u << '\n';
}