﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define pint pair<int, int>
#define pll pair<ll, ll>

const ll inf = 1e9;
const ll INF = 1e18;
const ll M = 998244353;

void solve()
{
    /*ll n; cin >> n;
    ll sn = sqrt(n);
    ll ans = inf;
    for (int d = 1; d <= 2 * sqrt(n); ++d)
    {
        int k = n % d;
        if (k && (k == n / d || k == ((n + d - 1) / d)))
        {
            ans = min(ans, abs(d - (n + d - 1) / d));
        }
    }
    cout << ans << '\n';*/
    int n, m;
    cin >> n >> m;
    vector <vector <int>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector <int> cnt(n, 0);
    for (auto& v : g[0]) {
        for (auto& u : g[v]) {
            cnt[u]++;
        }
    }
    int ans = 0;
    for (int i = 1; i < n; ++i) {
        ans += cnt[i] * (cnt[i] - 1);
    }
    cout << ans;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    ll t = 1; //cin >> t;
    while (t--)
    {
        solve();
    }
}