#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <climits>
#include <queue>
#include <string>
using namespace std;
typedef long long ll;

const int INF = INT_MAX;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    ll n, L, ans;
    ll kans = 0;
    cin >> n >> L;
    set<ll> dots;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        dots.insert(x);
    }
    ll di = 0, dj = 0;
    for (auto i : dots)
    {
        di++;
        for (auto j : dots)
        {
            dj++;
            // cout << "di = " << di << " dj = " << dj << endl;
            // cout << "kans = " << kans << endl; 
            if (j <= i)
                continue;
            if (j - i < L / 2)
            {
                kans += dj - di - 1;
            }
            else if (j - i > L/2)
            {
                kans += n - dj + di - 1;
            }
            // cout << "kans = " << kans << endl << endl;
        }
        dj = 0;
    }

    cout << (n * (n - 1) * (n - 2) / 6) - kans;
    return 0;
}