/// two to the one from the one to the three 

#pragma GCC optimize("O3")
//#pragma comment(linker, "/STACK:36777216")

#include<bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(x) (int) x.size()
#define all(z) (z).begin(), (z).end()
 
using namespace std;

using ll = long long;
using pii = pair<int, int>;                                   

const int MOD = 1e9 + 7;
const int INF = 1e9 + 1e2;
  
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fin() {
#ifdef AM
    freopen(".in", "r", stdin);
#endif        
}                   

const bool flag = 0;

const int N = 1e6+10;

int min(int x, int y, int z) { 
    return min(min(x, y), z); 
} 

int editDistDP(string str1, string str2) { 
    int m = str1.size();
    int n = str2.size();
    vector<vector<int>> dp(m + 1, vector<int>(n + 1, INF));    
    for (int i = 0; i <= m; i++) { 
        for (int j = 0; j <= n; j++) { 
            if (i == 0) 
                dp[i][j] = j; 
            else if (j == 0) 
                dp[i][j] = i; 
            else if (str1[i - 1] == str2[j - 1]) 
                dp[i][j] = dp[i - 1][j - 1]; 
            else
                dp[i][j] = 1 + min(dp[i][j - 1], 
                                   dp[i - 1][j], 
                                   dp[i - 1][j - 1]); 
        } 
    } 
    return dp[m][n]; 
} 

void ma1n() {
    string s;
    string t;
    cin >> s >> t;
    int n;
    cin >> n;
    n += 2;
    vector<string> w(n);
    w[0] = s;
    w[n - 1] = t;
    for (int i = 1; i < n - 1; i++) {
        cin >> w[i];
    }
    vector<vector<int>> c(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            c[i][j] = editDistDP(w[i], w[j]);
        }
    }
    vector<int> k(n);
    vector<int> e(n, INF);
    vector<int> p(n, -1);
    set<pair<pii, int>> q;
    e[0] = 0;
    q.insert({{e[0], k[0]}, 0});
    while (!q.empty()) {
        int u = q.begin()->second;
        q.erase(q.begin());

        for (int v = 1; v < n; v++) {
            if (v == u)
                continue;
            if ((e[v] > e[u] + c[u][v]) || (e[v] == e[u] + c[u][v] && k[v] < k[u] + 1)) {
                q.erase({{e[v], -k[v]}, v});
                e[v] = e[u] + c[u][v];
                p[v] = u;
                k[v] = k[u] + 1;
                q.insert({{e[v], -k[v]}, v});
            }
        }
    }    
    cout << e[n - 1] << ' ' << k[n - 1] - 1 << '\n';
    int cur = n - 1;
    vector<string> path;
    while (cur >= 0) {
        if (cur != n - 1 && cur)
            path.pb(w[cur]);
        cur = p[cur];
    }
    reverse(path.begin(), path.end());
    for (auto word : path)
        cout << word << '\n';            
}                                                      

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr), fin();
    int ts = 1;
    if (flag) {
        cin >> ts;
    }
    while (ts--) {
        ma1n(); 
    }
    return 0;
}