#include <bits/stdc++.h>
using namespace std;
typedef long long s64;

template<typename T>
T epow(T a, T n){
    if(n == 0){
        return 1;
    }
    else{
        T z = epow(a, n / 2);
        z *= z;
        return n % 2 == 0 ? z : a * z;
    }
}

template<typename T>
T gcd(T a, T b){
    if(a > b){
        swap(a, b);
    }
    while(a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}



int main() {
    //ifstream cin("input.txt");
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    s64 n, ans, a, b;
    cin >> n;
    ans = n;
    for(s64 h = 2*sqrt(n); h >= 1; --h){
        if(n % h == 0){
            s64 w = n / h;
            ans = min(ans, abs(w-h));
        }
        s64 w = (2*n-h)/(2*h);
        if (w*(h/2) + (w+1)*(h/2) == n) ans = min(ans, abs(w+1-(h/2)-(h/2)));
        w = (2*n-h)/(2*h+2);
        if (w*(h/2+1) + (w+1)*(h/2) == n) ans = min(ans, abs(w+1-(h/2+1)-(h/2)));
        w = (2*n-2-h)/(2*h+2);
        if (w*(h/2) + (w+1)*(h/2+1) == n) ans = min(ans, abs(w+1-(h/2)-(h/2+1)));
    }
    cout << ans << '\n';
    return 0;
}
