﻿#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <stack>
#include <unordered_set>
using namespace std;

const int N = 1000002;

void solve() {
    long long n;
    cin >> n;
    if ((long long)sqrt(n) * (long long)(sqrt(n)) == n) {
        cout << 0 << endl;
    }
    else {
        long long i = 1, sum;
        for (; i <= N; i++) {
            sum = i * i + (i + 1) * (i + 1);
            if (sum > n) {
                break;
            }
        }
        long long c = 2 * i + 1;
        bool q = 1;
        while (sum != n) {
            if (sum > n) {
                sum -= i + q;
                c--;
            }
            else {
                sum += i + q;
                c++;
            }
            q = !q;
        }
        long long ans = abs(i + 1 - c);
        for (long long j = sqrt(n); j >= 1; j--) {
            if (n % j == 0) {
                cout << min(ans, n / j - j) << endl;
                return;
            }
        }
    }
}

int main(){
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}