﻿#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <stack>
#include <unordered_set>
using namespace std;

const int N = 100002;

int n, m;
vector<int> g[N];
int trap[2 * N];
bool u[2 * N];
long long ans = 0;

void backtrack(int ind, int v) {
    if (ind == 3) {
        for (int i = 0; i < g[v].size(); i++) {
            if (trap[g[v][i]] == v + 1) {
                ans++;
                return;
            }
        }
        return;
    }
    for (int i = 0; i < g[v].size(); i++) {
        if (!u[g[v][i]]) {
            u[g[v][i]] = true;
            backtrack(ind + 1, trap[g[v][i]] - v);
            u[g[v][i]] = false;
        }
    }

}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(i);
        g[b].push_back(i);
        trap[i] = { a + b };
    }
    backtrack(0, 1);
    cout << ans << endl;
}

int main(){
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}