#include <bits/stdc++.h>

using namespace std;

int cnt = 0;

vector<vector<int>> graph;
vector<int> used;

void DFS(int v, int move_amount, int prev = -1, int prev2 = -1, int prev3 = -1) {
    for (int u : graph[v]) {
        if (move_amount == 0) {
            if (u == 0) {
                cnt++;
                return;
            }
        } else {
            if (u != prev && u != prev2 && u != prev3 && used[u] <= 2) {
                DFS(u, move_amount - 1, v, prev, prev2);
            }
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a - 1].push_back(b - 1);
        graph[b - 1].push_back(a - 1);
    }
    int s = 0;
    queue<int> q;
    used.resize(n, -1);
    q.push(s);
    used[s] = 0;
    while (!q.empty()) {
        int v = q.back();
        q.pop();
        for (int u : graph[v]) {
            if (used[u] == -1) {
                used[u] = used[v] + 1;
                q.push(u);
            }
        }
    }
    DFS(0, 3);
    cout << cnt << endl;
}
