//mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("avx,avx2,fma")

#include <bits/stdc++.h>
using namespace std;

#define all(s) s.begin(), s.end()
#define ok puts("ok")
#define ll long long
#define pb push_back
#define mk make_pair
#define fr first
#define sc second
#define vi vector < int >
#define pl pair < ll, ll >
#define pi pair < int, int >
#define pii pair < int, pi >
#define next next123
#define left left123

const int N = 2e5 + 7;
const ll mod = 998244353;

int p[N];
int n, m;
vector < pi > e, t;
vi ans;

int findp (int x){
    if (p[x] < 0)
        return x;
    return p[x] = findp(p[x]);
}

bool unite (int u, int v){
    u = findp(u);
    v = findp(v);
    if (u != v){
        if (p[u] > p[v])
            swap(u, v);
        p[u] += p[v];
        p[v] = u;
        return true;
    }
    return false;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    memset(p, -1, sizeof(p));
    cin >> n >> m;
    for (int i = 1; i <= m; i++){
        int a, b;
        cin >> a >> b;
        e.pb({a, b});
    }
    for (int i = 1; i <= n; i++)
        ans.pb(i);
    int c = n;
    for (auto it : e){
        if (unite(it.fr, it.sc))
            t.pb({it.fr, it.sc});
        else {
            ans.pb(it.fr);
            t.pb({++c, it.sc});
        }
    }
    cout << ans.size() << endl;
    for (int it : ans)
        cout << it << ' ';
    cout << endl;
    for (auto it : t)
        cout << it.fr << ' ' << it.sc << endl;
}
