#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;

const int INF = 1e9;
const int len = 1000001;

signed main() {
    int n, sum = 0;
    cin >> n;
    vector<int> arr(n);
    vector<bool> dp(len);

    for (int i = 0; i < n; ++i){
        cin >> arr[i];
        sum += arr[i];
    }

    dp[sum] = true;

    for (int i = 0; i < n; ++i){
        for (int j = 0; j < len - arr[i]; ++j)
            dp[j] = dp[j] || dp[j + arr[i]];
    }

    int res = 0, d = 0;
    for (int i = 0; i < len; ++i){
        if (dp[i]){
            ++d;
            res += i + 1;
        }
    }
    res *= 2;
    int k = d * (d - 1) / 2 + d;
    res -= k;
    cout << res;

}

