#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> used;

int n, m;

vector<int> ans;
vector<pair<int, int>> t;

void dfs(int u){
    used[u] = u;
    ans.push_back(used[u]);

    for (int v : g[u]) {
        if (ans.back() != used[u])
            ans.push_back(used[u]);

        t.push_back({ans.size(), ans.size() + 1});

        if (used[v] == -1)
            dfs(v);
        else
            ans.push_back(used[v]);
    }

}

signed main() {
    cin >> n >> m;
    g.resize(n + 1);
    used.resize(n + 1, -1);
    for (int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        //g[v].push_back(u);
    }
    dfs(1);
    cout << ans.size() << "\n";
    for (int i : ans)
        cout << i << " ";
    cout << "\n";
    for (auto p : t)
        cout << p.first << " " << p.second << "\n";
}

