#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
    cout.precision(10);
    int n;
    double v, u;
    double sum = 0;
    cin >> n >> v >> u;

    vector<double > arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        sum += arr[i];
    }

    double l = 0, r = sum / u + 1.0;
    while (r - l > 1e-8){
        double mid = (l + r) / 2.0;
        double p = 0;
        for (int i = 0; i < n; ++i)
            p += max(.0, arr[i] - v * mid);
        if (p > mid * u)
            l = mid;
        else
            r = mid;
    }
    cout << r * u;
}

