#include <cstdio>
#include <cmath>

#define min(a, b) ((a) > (b) ? (b) : (a))

int res = 0;

void Rec( int *A, int *B, int dep, int n, int N )
{
  B[n * 2] = 1;

  if (dep == 2)
  {
    res -= B[n * 2 + 1] * (B[n * 2 + 1] - 1);
    B[n * 2 + 1]++;
    res += B[n * 2 + 1] * (B[n * 2 + 1] - 1);
    return;
  }

  for (int i = 0; i < N; i++)
    if (A[i * 2] == n && A[i * 2 + 1] != 0)
      Rec(A, B, dep + 1, A[i * 2 + 1], N);
    else if (A[i * 2 + 1] == n && A[i * 2] != 0)
      Rec(A, B, dep + 1, A[i * 2], N);
}

int main()
{
  int n, m;

  // Read data
  scanf("%d", &n);
  scanf("%d", &m);
  int *A = new int[2 * m];

  for (int i = 0; i < m; i++)
    for (int j = 0; j < 2; j++)
      A[i * 2 + j] = 0;

  for (int i = 0; i < m; i++)
  {
    int a, b;
    scanf("%d", &a);
    scanf("%d", &b);
    A[i * 2] = a - 1;
    A[i * 2 + 1] = b - 1;
  }

  int *B = new int[2 * n];
  for (int i = 0; i < n; i++)
    B[i * 2] = B[i * 2 + 1] = 0;

  for (int i = 0; i < m; i++)
    if (A[i * 2] == 0)
      Rec(A, B, 1, A[i * 2 + 1], m);
    else if (A[i * 2 + 1] == 0)
      Rec(A, B, 1, A[i * 2], m);

  printf("%d", res);

  // Free everything
  delete[] B;
  delete[] A;

  /*
  int n, u, v;
  long long S = 0;

  scanf("%d", &n);
  scanf("%d", &v);
  scanf("%d", &u);

  for (int i = 0; i < n; i++)
  {
    int a_i;
    scanf("%d", &a_i);
    S += a_i;
  }

  printf("%.6lf", (double)u * S / ((double)n * v + u));
  */

  return 0;
}
