//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

#define x first
#define y second
#define int long long
#define ll long long
#define ld long double
#define pb push_back

pair<int, int> operator-(pair<int, int> a, pair<int, int> b) {
    return {a.x - b.x, a.y - b.y};
}

int cross(pair<int, int> a, pair<int, int> b) {
    return a.x * b.y - a.y * b.x;
}

int dist(pair<int, int> a, pair<int, int> b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, l;
    cin >> n >> l;
    vector<pair<int, int>> pp;
    while (n--) {
        int x, y;
        cin >> x >> y;
        pp.pb({x - l, y});
        pp.pb({x + l, y});
        pp.pb({x, y - l});
        pp.pb({x, y + l});
    }
    sort(pp.begin(), pp.end());
    pp.erase(unique(pp.begin(), pp.end()), pp.end());
    sort(pp.begin() + 1, pp.end(), [&](pair<int, int> a, pair<int, int> b) {
        return cross(a - pp[0], b - pp[0]) > 0 || (cross(a - pp[0], b - pp[0]) == 0 && dist(a, pp[0]) < dist(b, pp[0]));
    });
    vector<pair<int, int>> hull;
    for (auto p : pp) {
        while (hull.size() >= 2 && cross(hull.back() - hull[(int)hull.size() - 2], p - hull[(int)hull.size() - 2]) <= 0) hull.pop_back();
        hull.pb(p);
    }
    ld ans = 0;
    for (int i = 0; i < hull.size(); i++) ans += sqrt(dist(hull[i], hull[(i + 1) % hull.size()]));
    cout << setprecision(15) << fixed << ans;
    return 0;
}
