# Stars:
import math

from typing import *

n = int(input())

## K is maximal k

def get_l_by_k_first(k: int) -> Optional[int]:
	l = n // k
	return l if l * k == n else None


def get_l_by_k_second(k: int) -> Optional[int]:
	l = (2 * n) // (2 * k - 1)

	return l if l * (2*k - 1) == n * 2 else None


def get_l_by_k_third(k: int) -> Optional[int]:
	l = (2 * n + 1) // (2 * k - 1)
	return l if 2 * n == 2 * k * l - l - 1 else None # k - 1 + (l - 1) / 2 * (2 * k - 1) == n else None


def get_l_by_k_fourth(k: int) -> Optional[int]:
	l = (2 * n - 1) // (2 * k - 1)
	return l if 2 * n == 2 * k * l - l + 1 else None # k + (l - 1) * (2 * k - 1) == 2 * n else None



handlers = [
	get_l_by_k_first,
	get_l_by_k_second,
	get_l_by_k_third,
	get_l_by_k_fourth,
]

sqrt = math.sqrt(n)
sqrt_c = math.ceil(sqrt)

best_res = None
best_case = None

for poss_k in range(1, min(n + 1, sqrt_c * 2 + 1)):  # min(n + 1, 3 * sqrt_c + 10)):
	# All the [1; 4] cases
	for variant_index in range(4):
		this_l = handlers[variant_index](poss_k)
		if this_l is None:
			continue

		this_value = abs(this_l - poss_k)

		if best_res is None or this_value < best_res:
			# print(poss_k, this_l, variant_index + 1)
			best_res = this_value
			best_case = variant_index


if best_res is None:
	raise RuntimeError()

# print(best_case)
print(best_res)

# print("__________________")

# print(get_l_by_k_second(2))
