import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class s {
    public static void dfs(int node, int p){
        used[node] = 1;
        for(Integer to : g[node]){
            if(used[to] == 0){
                edges.add(to + 1 + " " + (node + 1));
                dfs(to, node);
            }
            else if(used[to] == 1 && p != to){
                edges.add((ans.size() + 1) + " " + (node + 1));
                ans.add(to + 1);
            }
        }
        used[node] = 2;
    }
    public static int[] used;
    public static ArrayList<Integer>[] g;
    public static ArrayList<Integer> ans = new ArrayList<>();
    public static ArrayList<String> edges = new ArrayList<>();
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        int m = Integer.parseInt(st.nextToken());
        g = new ArrayList[n];
        for(int i = 0; i < n; ++i){
            g[i] = new ArrayList<>();
        }
        for(int i = 0; i < m; ++i){
            st = new StringTokenizer(reader.readLine());
            int x = Integer.parseInt(st.nextToken()) - 1;
            int y = Integer.parseInt(st.nextToken()) - 1;
            g[y].add(x);
            g[x].add(y);
        }
        used = new int[n];
        for(int i = 0; i < n; ++i){
            ans.add(i + 1);
        }
        dfs(0, - 1);
        writer.println(ans.size());
        StringBuilder s = new StringBuilder();
        for(Integer k : ans){
            s.append(k);
            s.append(" ");
        }
        writer.println(s);
        for(String ss : edges){
            writer.println(ss);
        }
        writer.close();
    }
}
