import java.io.*;
import java.security.PrivilegedExceptionAction;
import java.util.*;


public class MainClass {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        double v = Integer.parseInt(st.nextToken());
        double u = Integer.parseInt(st.nextToken());
        ArrayList<Double> arr = new ArrayList<>();
        st = new StringTokenizer(reader.readLine());
        double sum = 0;
        for (int i = 0; i < n; ++i) {
            arr.add((double)Integer.parseInt(st.nextToken()));
        }
        double answer = 0;
        Collections.sort(arr);
        double T1 = arr.get(n - 1) / (u + v);
        double T2 = 0;
        for(int i = n - 2 ; i >= 0; --i){
            if(arr.get(i) / v <= T1 + T2){
                break;
            }
            double l = 0 ;
            double r = arr.get(i) / (v + u);
            double ans = 0;
            while(l + 0.0000001 <= r){
                double mid = (l + r) / 2;
                double s2 =  mid;
                double f2 = (arr.get(i) - mid * (v + u)) / v;
                double t2 = T2 + mid;
                double t1 = (arr.get(n - 1)  - t2 * v) / (v + u);
                if(t1 + t2 + 0.0000001 >= f2 + s2){
                    ans = mid;
                    r = mid - 0.0000001;
                }
                else{
                    l = mid + 0.0000001;
                }
            }
            T2 += ans;
            T1 = (arr.get(n - 1)  - T2 * v) / (v + u);
            answer += ans;
        }
        System.out.println(T1 * u + T2 * u);
    }
}