#include "bits/stdc++.h"

using namespace std;

typedef long double ld;
typedef long long unsigned llu;
typedef long long ll;
typedef pair<ld, ld> pt;

#define fi first
#define se second
//#define lson (p<<1)+1
//#define rson (p<<1)+2
#define dump(x) cout << #x << " = " << x << endl
#define pa system("pause");
#define fastIO ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);

const
  long MaxN = 5e5;


struct TPoint{
  ld x,y;
};


TPoint a[MaxN];
stack<long> st;

ld VectorProd(TPoint v, TPoint v1) {
  return v.x * v1.y - v.y * v1.x;
}

ld CrosProd(TPoint v, TPoint v1) {
  return v.x*v1.x + v.y * v1.y;
}

TPoint MakeVector(TPoint a, TPoint b) {
  TPoint res;
  res.x = b.x - a.x;
  res.y = b.y - a.y;
  return res;
}

ld Len(TPoint a, TPoint b) {
    TPoint v = MakeVector(a,b);
    return sqrt(CrosProd(v,v));
}

bool cmp(TPoint p1, TPoint p2) {
    TPoint v,v1;
    v.x = p1.x - a[0].x;
    v.y = p1.y - a[0].y;

    v1.x = p2.x - a[0].x;
    v1.y = p2.y - a[0].y;

    if (VectorProd(v,v1) == 0) return (CrosProd(v,v) > CrosProd(v1,v1));
    else return VectorProd(v,v1) > 0;
}


bool mpoint(TPoint cur) {
  if (cur.x < a[0].x) return true;
  if (cur.x == a[0].x && cur.y < a[0].y) return true;
  return false;
}


int main() {
    fastIO;
    ll n,l;
    cin >> n >> l;
    n*= 4;
    for (long i=0; i<n; i+=4) {
        TPoint cur;
        cin >> cur.x >> cur.y;

        // left
        a[i].x = cur.x - l;
        a[i].y = cur.y;

        //top
        a[i+1].x = cur.x;
        a[i+1].y = cur.y + l;

        // right
        a[i+2].x = cur.x + l;
        a[i+2].y = cur.y;

        // bot
        a[i+3].x = cur.x;
        a[i+3].y = cur.y - l;
    }



    for (long i=0; i<n; i++) {
        if (mpoint(a[i])) swap (a[i],a[0]);
    }

    sort(a+1,a+n,cmp);


    st.push(0);
    st.push(1);

    for (long i=2; i<n; i++) {
        if (a[i].x == a[i-1].x && a[i].y == a[i-1].y) continue;

        TPoint v,v1;
        v.x = a[i].x - a[st.top()].x;
        v.y = a[i].y - a[st.top()].y;
        long tmp = st.top();
        st.pop();
        v1.x = a[tmp].x - a[st.top()].x;
        v1.y = a[tmp].y - a[st.top()].y;
        st.push(tmp);

        while (st.size() > 2 && VectorProd(v1,v) <= 0) {
            st.pop();

            v.x = a[i].x - a[st.top()].x;
            v.y = a[i].y - a[st.top()].y;
            tmp = st.top();
            st.pop();
            v1.x = a[tmp].x - a[st.top()].x;
            v1.y = a[tmp].y - a[st.top()].y;
            st.push(tmp);
        }

        st.push(i);
    }


    TPoint fir = a[st.top()];

    ld res = 0;
    while (st.size()>1) {


        TPoint p1 = a[st.top()];
        st.pop();
        TPoint p2 = a[st.top()];
        res += Len(p1,p2);
    }
    res += Len(a[st.top()], fir);
    cout << fixed << setprecision(9) << res;

    return 0;
}
