#include <bits/stdc++.h>

using namespace std;

int answer = 0;

void dfs(int x, vector<vector<int>> mass, vector<bool> good, int step, vector <bool> visited, vector <int> sizes)
{
    visited[x] = true;
    if (step == 3) {
        if (good[x]) {
            answer += 1;
        }
        return;
    }
    for (int i = 0; i < sizes[x]; i++)
    {
        if (!visited[mass[x][i]])
        {
            dfs(mass[x][i], mass, good, step + 1, visited, sizes);
        }
    }
}

signed main() {
    int n, m, x, y;
    scanf("%d %d", &n, &m);
    vector <bool> good(n);
    vector <vector<int>> mass(n);
    vector <bool> visited(n);
    vector <int> sizes(n);

    for (int i = 0; i < m; i++)
    {
        scanf("%d %d", &x, &y);
        x -= 1;
        y -= 1;
        mass[x].push_back(y);
        mass[y].push_back(x);
        sizes[x] += 1;
        sizes[y] += 1;
        if (x == 0)
        {
            good[y] = true;
        }
        if (y == 0)
        {
            good[x] = true;
        }
    }

    dfs(0, mass, good, 0, visited, sizes);

    cout << answer;

}
