#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")
#pragma optimize("O3")

typedef tree<
    int,
    null_type,
    less <int>,
    rb_tree_tag,
    tree_order_statistics_node_update
> ordered_set;

int n, m;
vector < vector <int> > a;
vector <int> used, k;
set <int> s;

void dfs1(int v){
    used[v] = 1;
    for(auto to : a[v]){
        if(s.find(to) != s.end()){
            k[v]++;
        }
        if(!used[to]){
            dfs1(to);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;

    cin >> n >> m;
    a.resize(n);
    used.resize(n);
    k.resize(n);

    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        a[--x].push_back(--y);
        a[y].push_back(x);
    }

    for(auto to : a[0]){
        s.insert(to);
    }

    dfs1(0);

    int otv = 0;
    for(auto v : a[0]){
        for(auto u : a[v]){
            if(u != 0){
                otv += k[u] - 1;
            }
        }
    }
    /*for(int i = 0; i < n; ++i){
        cout << k[i] << " ";
    }
    cout << '\n';*/
    cout << otv;
}

