#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(0)

#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define sqr(a) ((a) * (a))
#define vout(v) cout << #v << ": " << (v) << '\n';

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = 0x7fffffff;
const ll MOD = (1 << 30) + 1;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const int MAXN = 1e5 + 1000;

int dp[MAXN];
vector <int> g[MAXN];
bool used[MAXN];
vector <int> q;

int main() {
	fast();
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
	}
	dp[1] = 0;
	used[1] = 1;
	q.push_back(1);
	while (!q.empty()){
        int v = q[0];
        for (int i = 0; i < g[v].size(); i++){
            if (!used[g[v][i]]){
                used[g[v][i]] = 1;
                q.push_back(g[v][i]);
                dp[g[v][i]] = dp[v] + 1;
            }
        }
        q.erase(q.begin());
	}
	long long ans = 0;
	for (int i = 2; i <= n; i++){
        if (dp[i] == 2 || dp[i] == 1){
            long long chldrn = 0;
            for (int j = 0; j < g[i].size(); j++)
                if (dp[g[i][j]] == 1)
                    chldrn++;
            ans += chldrn * (chldrn - 1);
        }
	}
	cout << ans << '\n';
	return 0;
}
