#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define deb(a) cerr << #a << " = " << a << '\n'
#define FIO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define deb2(a, b) cerr << #a << " = " << a << ", " << #b << " = " << b << '\n'

const ll INF = 1e18;
const int N = 1e5 + 100;
const ld EPS = 1e-12;
const int P = 239017;

vector<int> ans;
vector<pii> ans1;
bool used[N];
vector<unordered_set<int>> g;

void dfs(int v, int p) {
    ans.pb(v);
    used[v] = 1;
    int from = sz(ans) - 1;
    unordered_set<int>::iterator f = g[v].begin();
    for (; f != g[v].end(); f++) {
        if (*f == p)
            continue;
        ans1.pb({from, sz(ans)});
        if (used[*f]) {
            g[*f].erase(v);
            ans.pb(*f);
        } else {
            dfs(*f, v);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].insert(v);
        g[v].insert(u);
    }
    dfs(0, -1);

    cout << sz(ans) << '\n';\
    for (int i = 0; i < sz(ans); i++)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
    for (int i = 0; i < sz(ans1); i++)
        cout << ans1[i].ff + 1 << ' ' << ans1[i].ss + 1 << '\n';
}

int main() {
    FIO;
    int t = 1;
    //cin >> t;
    //cout << fixed << setprecision(0);
    while (t--) {
        solve();
    }
    return 0;
}
