#include<iostream>
#include<algorithm>
#include<vector>
#include<set>

#define int long long

using namespace std;

vector < vector < int > > graf(1, vector < int > (1));
vector < int > kras;
set < int > correct_finish;
int cycle = 0;

void rec(int tec, int pred, int kol)
{
	if (tec == 0)
	{
		if (kol == 4)
			cycle ++;
		return ;
	}
	if (kol > 4)
		return ;
		
	kras[tec] = 1;
	for (int i = 0; i < graf[tec].size(); i++)
	{
		if (graf[tec][i] != pred and kras[graf[tec][i]] != 1)
		//	cout << "From " << tec << "to " <<  << endl;
			rec(graf[tec][i], tec, kol + 1);
	}
}

signed main()
{
	int n, m;
	cin >> n >> m;
	
	graf.resize(n);
	kras.resize(n, 0);
	
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		graf[a - 1].push_back(b - 1);
		graf[b - 1].push_back(a - 1);
		
		if (a == 1)
			correct_finish.insert(b - 1);
	}
	
	for (int i = 0; i < graf[0].size(); i++)
	{
		for (int j = 0; j < n; j++)
			kras[j] = 0;
	//	cout << "New rec\n";
	//	cout << "From " << 0 << "to " << i << endl;
		rec(graf[0][i], 0, 1);
	}	
	
	cout << cycle;	
	return 0;
}
