#include<algorithm>
#include<iostream>
#include<vector>
#include<set>

#define int long long

using namespace std;

vector < vector < int > > graf(1, vector < int > (1));
vector < int > correct_finish;
vector < set < int > > finish_links;
int cycle = 0;

int set_and(set <int> fir, set <int> sec)
{
	int tec = 0;
	for (set <int> :: iterator it = fir.begin(); it != fir.end(); ++it){
		if (*it != 0){
			if (sec.find(*it) != sec.end()){
				tec ++;
			}
		}
	}
			
	return tec;
}

signed main()
{
	int n, m;
	cin >> n >> m;
	
	graf.resize(n);
	
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		graf[a - 1].push_back(b - 1);
		graf[b - 1].push_back(a - 1);
		
		if (a == 1)
			correct_finish.push_back(b - 1);
		if (b == 1)
			correct_finish.push_back(a - 1);
	}	
	
	
	finish_links.resize(correct_finish.size());

	for (int i = 0; i < correct_finish.size(); i++)
		for (int j = 0; j < graf[correct_finish[i]].size(); j++)
			finish_links[i].insert(graf[correct_finish[i]][j]);
			
	/*
	for (int i = 0; i < correct_finish.size(); i++){
		cout << correct_finish[i] << ": ";
		for (set <int> :: iterator it = finish_links[i].begin(); it != finish_links[i].end(); ++it)
			cout << *it << " ";
		cout << endl;
	}
	*/
	for (int i = 0; i < correct_finish.size() - 1; i++)
	{
		for (int j = i + 1; j < correct_finish.size(); j++)
		{
			cycle += set_and(finish_links[i], finish_links[j]) * 2;
		}
	}
	cout << cycle;	
	return 0;
}
