#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
using namespace std;

struct point {
	double x;
	double y;
};

bool fun1(point a, point b, point c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool fun2(point a, point b, point c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

bool comp(point a, point b) {
	return a.x < b.x || a.x == b.x && a.y < b.y;
}

void my_answer (vector<point> & v) {
	if (v.size() == 1){
		return;
	}
	sort (v.begin(), v.end(), &comp);
	point p1 = v[0];
	point p2 = v.back();
	vector <point> up;
	up.push_back (p1);
	vector <point> down;
	down.push_back (p1);
	for (size_t i=1; i<v.size(); ++i) {
		if (i==v.size()-1 || fun1(p1, v[i], p2)) {
			while (up.size()>=2 && !fun1(up[up.size()-2], up[up.size()-1], v[i]))
				up.pop_back();
			up.push_back (v[i]);
		}
		if (i==v.size()-1 || fun2(p1, v[i], p2)) {
			while (down.size()>=2 && !fun2(down[down.size()-2], down[down.size()-1], v[i]))
				down.pop_back();
			down.push_back (v[i]);
		}
	}
	v.clear();
	for (size_t i=0; i<up.size(); ++i)
		v.push_back (up[i]);
	for (size_t i=down.size()-2; i>0; --i)
		v.push_back (down[i]);
}

vector<point> v;

int main()
{
	double n,l;
	double ans=0;
	point my_point;
	cin>>n>>l;
	for(int i=0;i<n;i++)
	{
		double x1,y1;
		cin>>x1>>y1;
		
		my_point.x=x1+l;
		my_point.y=y1;
		v.push_back(my_point);
		
		my_point.x=x1-l;
		my_point.y=y1;
		v.push_back(my_point);
		
		my_point.x=x1;
		my_point.y=y1-l;
		v.push_back(my_point);
		
		my_point.x=x1;
		my_point.y=y1+l;
		v.push_back(my_point);
	}
	my_answer(v);
	for(int i=0;i<v.size()-1;i++)
	{
		ans +=sqrt(abs(v[i].x-v[i+1].x)*abs(v[i].x-v[i+1].x)+abs(v[i].y-v[i+1].y)*abs(v[i].y-v[i+1].y) )      ;
	}
		ans += sqrt(abs(v[v.size()-1].x-v[0].x)*abs(v[v.size()-1].x-v[0].x)+abs(v[v.size()-1].y-v[0].y)*abs(v[v.size()-1].y-v[0].y) )      ;

	cout<<fixed<<setprecision(12);
	cout<<ans;
}
