#include <bits/stdc++.h>

using namespace std;
#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define eb emplace_back
#define pb push_back
typedef long long ll;
typedef long double ld;


struct point {
  ld x, y;
};

bool cmp(point a, point b) {
  return a.x < b.x || a.x == b.x && a.y < b.y;
}

bool cw(point a, point b, point c) {
  return a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) < 0;
}

bool ccw(point a, point b, point c) {
  return a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) > 0;
}

ld leng(point p1, point p2) {
  return sqrt((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y));
}

ll solve() {
  ll n, l;
  cin >> n >> l;
  vector<point> a;
  for (int i = 0; i < n; i++) {
    point p;
    cin >> p.x >> p.y;
    p.x += l;
    a.pb(p);
    p.x -= l;

    p.x -= l;
    a.pb(p);
    p.x += l;

    p.y += l;
    a.pb(p);
    p.y -= l;

    p.y -= l;
    a.pb(p);
    p.y += l;
  }
  sort(a.begin(), a.end(), &cmp);
  point p1 = a[0], p2 = a.back();
  vector<point> up, down;
  up.push_back(p1);
  down.push_back(p1);
  for (size_t i = 1; i < a.size(); ++i) {
    if (i == a.size() - 1 || cw(p1, a[i], p2)) {
      while (up.size() >= 2 && !cw(up[up.size() - 2], up[up.size() - 1], a[i]))
        up.pop_back();
      up.push_back(a[i]);
    }
    if (i == a.size() - 1 || ccw(p1, a[i], p2)) {
      while (down.size() >= 2 && !ccw(down[down.size() - 2], down[down.size() - 1], a[i]))
        down.pop_back();
      down.push_back(a[i]);
    }
  }
  a.clear();
  for (size_t i = 0; i < up.size(); ++i)
    a.push_back(up[i]);
  for (size_t i = down.size() - 2; i > 0; --i)
    a.push_back(down[i]);
  long double perim = 0;
  for (int i = 0; i < a.size(); i++) {
    perim += leng(a[i], a[(i + 1) % a.size()]);
  }
  cout << fixed << setprecision(10) << perim;
  return 1;
}

signed main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  int tt = 1;
//    cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}