#include <bits/stdc++.h>

using namespace std;
#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define eb emplace_back
#define pb push_back
#define MAX(x) *max_element(all(x))
#define MIN(x) *min_element(all(x))
#define rep(i, a, b) for(ll (i) = (a); i < b; i ++)
#define repr(i, a, b) for(ll (i) = (a); i > b; i --)
typedef long long ll;
typedef long double ld;
const ll mod = 1000000007;

template<class A>
istream &operator>> (istream &in, vector<A> &a){
  for(auto &i: a){
    in>>i;
  }
  return in;
}

template<class B>
ostream &operator<< (ostream &out, vector<B> &a){
  for(auto &i : a){
    out<<i<<" ";
  }
  out<<"\n";
  return out;
}

struct node{
  ll v, d, p;

  node (ll _v, ll _d, ll _p){
    v = _v;
    d = _d;
    p = _p;
  }
};

ll solve (){
  ll n, m;
  cin>>n>>m;
  vector<vector<ll>> g(n);
  set<ll> good;
  rep(i, 0, m){
    ll a, b;
    cin>>a>>b;
    a--;
    b--;
    g[a].pb(b);
    g[b].pb(a);
    if(a == 0){
      good.insert(b);
    }else if(b == 0){
      good.insert(a);
    }
  }
  vector<vector<ll>> dp(4, vector<ll>(n));
  queue<node> q;
  vector<vector<ll>> used(4, vector<ll> (n));
  used[0][0] = 1;
  used[1][0] = 1;
  used[2][0] = 1;
  used[3][0] = 1;
  for(auto x: good){
    dp[1][x] = 1;
    used[1][x] = 1;
    q.push({x, 1, 0});
  }
  while (!q.empty()) {
    node cur = q.front();
    q.pop();
    if(cur.d >= 3){
      continue;
    }
    for(ll to: g[cur.v]){
      if(to == 0){
        continue;
      }
      if(!used[cur.d + 1][to]){
        q.push({to, cur.d + 1, cur.v});
        used[cur.d + 1][to] = 1;
      }
      if(to != cur.p){
        dp[cur.d + 1][to] += dp[cur.d][cur.v];
      }
    }
  }
  ll ans = 0;
  for(auto x: good){
    ans += dp[3][x];
  }
  cout<<ans;
}


signed main (){
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  ll tt = 1;
//  cin >> tt;
  while (tt--) {
    solve();
  }
}
