#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#define ll long long
#define ld long double

using namespace std;

const int N = 200200;
vector < ll > g[N];
int ans, pred[N];
bool check[N], check2[N];

void dfs(ll, ll, int);
int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;
    for(ll i = 0; i < m; i++){
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
        if(a == 0)
            check[b] = 1;
        else if(b == 0)
            check[a] = 1;
    }

    for(int i = 0; i < n; i++){
        if(check[i]){
            for(int j = 0; j < g[i].size(); j++){
                if(g[i][j] != 0){
                    for(int k = 0; k < g[g[i][j]].size(); k++){
                        if(check[g[g[i][j]][k]] && g[g[i][j]][k] != i){
                            ans++;
                        }
                    }
                }
            }
        }
    }
    cout << ans << '\n';
    return 0;
}

