from typing import List, Set

n, m = map(int, input().split())

g: List[Set[int]] = [set() for _ in range(n)]

s2is1 = lambda s: int(s) - 1

for _ in range(m):
    a, b = map(s2is1, input().split())
    g[a].add(b)
    g[b].add(a)

pos = [0] * n
for h1 in g[0]:
    pos[h1] = 1
    for h2 in g[h1]:
        pos[h2] = min(2, pos[h2])

c = 0
for h1 in g[0]:
    for h2 in g[h1] - {0, h1}:
        for h3 in g[h2] - {0, h1, h2}:
            c += pos[h3] == 1

print(c)
