#include <iostream>
#include <cmath>
#include <algorithm>
#define int long long
using namespace std;
/*
signed main() {
    int n;
    cin >> n;
    if (n == 1)
    {
        cout << 0 << "\n";
        return 0;
    }
    int d = sqrt(n);
    int left = max(1LL, d - (int)1e6), right = min(n, d + (int)1e6);
    int res = 1e18;
    for (int a = left; a <= right; ++a) {
        int y = a * abs(n / a + (n % a == 0 ? 0 : 1)) - n;
        int x = (n - y * a + y) / a;
        if (x == 0 && y == 0) continue;
        if (abs(x - y) <= 1 || x == 0 || y == 0)
            res = min(res, abs(n / a + (n % a == 0 ? 0 : 1) - a));
        //cout << a << ' ' << res << '\n';
    }

    cout << res << '\n';
}
*/
#include <iostream>
#include <cmath>
#include <algorithm>
#define int long long
using namespace std;

signed main() {
    int n;
    cin >> n;

    int res = 1e18;
    int d = sqrt(n);
    int left = max(1LL, d - (int)1e6), right = min(n, d + (int)1e6);
    for (int a = left; a <= right; ++a) {
        if (n % a == 0) {
            res = min(res, abs(n / a - a));
        }
        else if (a > 1) {
            if ((n - a) % (2 * a - 1) == 0) {
                res = min(res, abs((n - a) / (2 * a - 1) * 2 + 1 - a));
            }
            if ((n - a + 1) % (2 * a - 1) == 0){
                res = min(res, abs((n - a + 1) / (2 * a - 1) * 2 + 1 - a));
            }
            if (n % (2 * a - 1) == 0){
                res = min(res, abs(n / (2 * a - 1) * 2 - a));
            }
        }
        //cout << a << ' ' << res << '\n';
    }
    cout << res << '\n';
}
