#include <iostream>
#include <map>
#include <set>
using namespace std;

const int N = 101;
int a[N];
int n;

map<pair<int, int>, int> mp;
set<long long> st;

void subsetSums(int n)
{
	long long total = 1 << n;
	for (long long i = 0; i < total; i++) {
		long long sum = 0;
		for (int j = 0; j < n; j++)
			if (i & (1 << j))
				sum += a[j];
		st.insert(sum);
	}
}

int main()
{
	int i, j, sum = 0, res = 0;
	cin >> n;
	for (i = 0; i < n; i++) {
		cin >> a[i];
		sum += a[i];
	}
	n = sizeof(a) / sizeof(a[0]);
	subsetSums(n);
	for (auto i : st) {
		for (j = 0; j <= i; j++) {
			mp[make_pair(j, sum - i)] = 1;
			mp[make_pair(sum - i, j)] = 1;
		}
	}
	for (auto i : mp)
		if (i.second == 1)
			res++;
	cout << res << endl;
	return 0;
}