#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <cmath>
#include <set>
#include <unordered_map>
#include <queue>
#include <cassert>
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << endl;
using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(7);
    int n, k; cin >> n >> k;
    vector <int> a(n);
    for (auto& x : a) cin >> x;
    sort(a.begin(), a.end());
    for (int i = 0; i < n; ++i)
        a.push_back(a[i]);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int l = i, r = i + n + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            int len = 0;
            if (a[m] < a[i]) {
                len = k - (a[i] - a[m]);
            }
            else len = a[m] - a[i];
            if (len > k / 2) r = m;
            else l = m;
        }
        if (i == l) continue;
        ans += (l - i - 1) * (l - i - 2) / 2;
    }
    ans = n * (n - 1) * (n - 2) / 6 - ans;
    cout << ans << '\n';
	return 0;
}