#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

//#define int long long

typedef long long ll;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    int s = 0;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        s += a[i];
    }
    vector<int> dp(s + 1, 0);
    vector<int> ps(s+1, 0);

    
    dp[0] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < s; j++) {
            if (!dp[j] || j + a[i] > s) continue;
            dp[j + a[i]] = 1;
        }
    }

    ll ans = s + s + 1;
    ps[0] = 0;
    for (int i = 1; i < s; i++) {
        //if (i > 0)
            ps[i] = ps[i-1] + dp[i];
        if (dp[i]) ans += (ll)(s - i);
    }

    int lst = s;
    for (int i = 1; i < s; i++){
        if (!dp[i]) continue;
        while (lst > s - i) lst--;
        ans += (ll)(s - i);
        if (lst >= 0) ans -= (ll)ps[lst];
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}