#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

#define int long long

typedef long double ld;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, v, u;
    cin >> n >> v >> u;

    vector<int> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }


    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());

    a.push_back(0);

    ld time_passed = 0;
    ld res = 0;

    for (int i = 0; i < n; ++i) {
        int k = i + 1;

        ld cur = a[i];
        ld next = a[i + 1];

        ld t_next = (ld) k * (cur - next) / (ld) u;

        ld total_time = time_passed + t_next;

        if (v * total_time >= next) {
            res += (cur - time_passed * (ld) v) / ((ld) u / (ld) k + v);
            break;
        }

        res = total_time;
        time_passed = total_time;
    }

    cout << setprecision(239) << res * u;

    return 0;
}