#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <stack>
#include <queue>
                 
using namespace std;
using namespace __gnu_pbds;
        
         
        
/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/
      
#define int long long             
#define eb emplace_back
#define pb push_back
#define ld long double
#define mp make_pair
#define f first
#define s second
#define gleg(x) return cout << x, 0
#define pii pair <int, int> 
#define deb(a) cerr << #a << " = " << a << '\n';
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(30); \
    cerr << fixed << setprecision(11); \
}
        
template < typename firstType, typename secondType = null_type, class compare = less_equal < firstType > >
struct sett {
    typedef tree <
        firstType,
        secondType,
        compare,
        rb_tree_tag,
        tree_order_statistics_node_update
    > _ ;
};
        
         
const int INF = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXI = 350;
const int MOD = 998244353;
const int MOD1 = 1e9 + 7;
const int MAXST = 2000000;
const int P = 31;
const int P1 = 37;
const int N = 2e6 + 1e5;
const ld PI = 3.14159265358979323;
       
               
ostream &operator<<(ostream &stream, const pair <int, int> &p) {
    stream << p.first << ' ' << p.second << ' ';
    return stream;
}

struct Gvect{
    int x, y, ind;
    Gvect(int x, int y): x(x), y(y) {}
    Gvect(Gvect a, Gvect b): x(b.x - a.x), y(b.y - a.y) {}
    Gvect(){};
};

int operator%(Gvect a, Gvect b){ return a.x * b.y - a.y * b.x; }
int operator*(Gvect a, Gvect b){ return a.x * b.x + a.y * b.y; }

Gvect p[10];
int d[10], v[10];

int sign(int a){
    if (a == 0)
        return 0;
    return (a < 0 ? -1 : 1);
}

bool seg_cr(Gvect a, Gvect b, Gvect c, Gvect d){
    if (Gvect(a, b) % Gvect(c, d)){
        if (sign(Gvect(a, b) % Gvect(a, d)) * sign(Gvect(a, b) % Gvect(a, c)) <= 0 &&
            sign(Gvect(c, d) % Gvect(c, b)) * sign(Gvect(c, d) % Gvect(c, a)) <= 0)
            return 1;
    }
    else{
        if (Gvect(a, b) % Gvect(a, c))
            return 0;
        if (Gvect(c, a) * Gvect(c, b) <= 0 ||
            Gvect(a, c) * Gvect(a, d) <= 0 ||
            Gvect(b, c) * Gvect(b, d) <= 0)
            return 1;
    }
    return 0;
}

signed main(){
    fast();
    srand(time(0));
    //#ifdef _LOCAL                 
        //freopen("power.in", "r", stdin);
        //freopen("power.out", "w", stdout);
    //#endif
    #ifdef _LOCAL               
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif 

    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> p[i].x >> p[i].y, d[i] = i;
    int mx = -INF;
    do{
        bool cond = 1;
        for (int i = 1; i < n - 1; i++)
            for (int j = 0; j < n - 1; j++)
                if (!(i == j || d[i] == d[(j + 1) % (n - 1)] || d[(i + 1) % (n - 1)] == d[j]) && seg_cr(p[d[i]], p[d[(i + 1) % n]], p[d[j]], p[d[(j + 1) % n]])){
                    //cout << d[i] << ' ' << d[(i + 1) % n] << ' ' << d[j] << ' ' << d[(j + 1) % n] << '\n';
                    cond = 0;
                }
        //deb(cond);
        if (!cond)
            continue;

        int s = 0;
        for (int i = 0; i < n; i++){
            int nx = (i + 1) % n;
            s += (p[d[nx]].x - p[d[i]].x) * (p[d[nx]].y + p[d[i]].y);
        }

        //deb(s);
        if (abs(s) > mx){
            mx = s;
            for (int i = 0; i < n; i++)
                v[i] = d[i];
        }
    } while(next_permutation(d, d + n));
    //deb(mx);
    if (mx){
        cout << "Yes" << '\n';
        for (int i = 0; i < n; i++)
            cout << v[i] + 1 << ' ';
    }
    else
        cout << "No\n";
    return 0;
}