﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;
#define EPS 1e-9

template <class T = int>
T next() { T x; cin >> x; return x; }

int v, u;

bool is_possible(vector<int>& arr, long double t)
{
    long double anst = 0, rest = 0;

    for (int ic : arr)
        anst += (ic - min((long double)ic, v * t));
    
    return anst <= u * t;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout.precision(20);

    int n = next();
    v = next(), u = next();
    vector<int> arr(n);

    for (int& v : arr)
        cin >> v;
       
    long double l = 0, r = 2e9;
    while (r - l > EPS)
    {
        long double m = (r + l) / 2;

        if (is_possible(arr, m))
            r = m;
        else
            l = m;
    }

    cout << u * r << '\n';

    return 0;
}