﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;
#define EPS 7e-6

template <class T = int>
T next() { T x; cin >> x; return x; }

int v, u;

bool is_possible(vector<int>& arr, long double x)
{
    long double anst = 0;

    for (int ic : arr)
        anst += (ic - min((long double)ic, v * x / u));
    
    return x > anst;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    int n = next();
    ll sum = 0;
    v = next(), u = next();
    vector<int> arr(n);

    for (int& ic : arr)
    {
        cin >> ic;
        sum += ic;
    }
       
    long double l = 0, r = 1e15;
    while (r - l > EPS)
    {
        long double m = (r + l) / 2;

        if (is_possible(arr, m))
            r = m;
        else
            l = m;
    }

    cout.precision(30);
    cout << r << '\n';

    return 0;
}