#include <iostream>
#include <list>
#include <set>
using namespace std;

const int SIZE{100005};
int n, m, state[SIZE], last{1};
list<int> gr[SIZE], tr[SIZE], color;
set<pair<int, int>> ribs;

void dfs(int x, int p, int tx)
{
    if (state[x] == 1)
        return;
    state[x] = 1;
    for (int i : gr[x])
        if (ribs.count({i, x}) == 0)
        {
            ribs.insert({i, x});
            ribs.insert({x, i});
            tr[tx].push_back(++last);
            color.push_back(i);
            dfs(i, x, last);
        }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    int u, v;
    for (int i = 0; i < m; ++i)
    {
        cin >> v >> u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    color.push_back(1);
    dfs(1, 0, 1);
    cout << last << "\n";
    for (int i : color)
        cout << i << " ";
    cout << "\n";
    for (int i = 1; i <= last; ++i)
        for (int j : tr[i])
            cout << i << " " << j << "\n";
}