// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
 
#include <iostream>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <chrono>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <math.h>
#include <limits.h>
#include <cstdio>
#include <stdio.h>
#include <queue>
#include <bitset>
#include <cstdlib>
#include <deque>
#include <cassert>
#include <stack>
using namespace std;
 
#define MP make_pair
#define X first
#define Y second
#define ll long long
#define ull unsigned long long
#define double long double
const int N = 3e5 + 12, INF = 1e9 + 7;
const double EPS = 1e-8;

int n;
ll a[N], V, U;

bool check(double x){
	double ost = 0;
	for(int i = 1;i <= n;i++){
		double cs = a[i] - x * V;
		if(cs > EPS)
			ost += cs;
	}	
	if(U * x - ost > EPS)
		return 1;
	return 0;
}

int main () {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> n >> V >> U;
	for(int i = 1; i <= n; ++i)
		cin >> a[i];
	double tl = 0, tr = INF;
	for(int i = 0;i < 100;i++){
		double tm = (tl + tr) / 2;
		if(check(tm))
			tr = tm;
		else
			tl = tm;
	}
	cout << setprecision(10) << fixed;
	cout << tr * U;
}
