#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <queue>
#include <deque>
#include <tuple>
#include <cassert>
#include <cstring>

using namespace std;

#define fi first
#define se second
#define int long long


template <typename T,typename S>
istream& operator >>(istream& in, pair<T,S> &m) {
    in >> m.fi >> m.se;
    return in;
}

template <typename T>
istream& operator >>(istream& in, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        in >> m[i];
    return in;
}

template <typename T,typename S>
ostream& operator <<(ostream& out, pair<T,S> &m) {
    out << m.fi << ' ' << m.se;
    return out;
}

template <typename T>
ostream& operator <<(ostream& out, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        out << m[i] << ' ';
    return out;
}





/*
void solution0()
{
    int n, L;
    cin >> n >> L;
    vector<int> x(n);
    for (int i = 0; i < n; i++)
    {
        cin >> x[i];
    }
    simple_solution(L, x);
    sort(x.begin(), x.end());
    // start: simple for x[0]
    for (int i = 1; i < n; i++)
    {
        if (x[i] > x[0] || x[i] <= fmod(a[i] + L2, L))
        {
            if (a[j] == fmod(a[i] + S2, S))
            {
                p.second++;
            }
            p.first++;
        }
        else
        {
            if (a[j] == fmod(a[i] + S2, S))
            {
                p.first++;
            }
            p.second++;
        }
        res += p.first * p.second;
    }
}*/

vector<set<int>> gr;
vector<int> used, res, clr;
int last;

void dfs(int v, int p = -1) {
    used[v] = 1;
    for (int i : gr[v]) {
        if (gr.size() <= i) continue;
        if (used[i] == 1 && i!=p) {
            res[last] = clr[i];
            gr[v].erase(i);
            gr[v].insert(last);
            gr[i].erase(v);
            last++;
        } else
        if (used[i] == 0) {
            dfs(i, v);
        }
    }

    used[v] = 2;
}

void solution()
{
    int n, m;
    cin >> n >> m;
    last = n;
    used.resize(n, 0);
    gr.resize(n);
    clr.resize(n);
    for (int i = 0; i < n; ++i) clr[i] = i+1;
    res.resize(n+m+m+n, -1);
    for (int i = 0; i < n; ++i)
        res[i] = i+1;
    for (int i = 0; i < m; ++i) {
        int u ,v;
        cin >> u >> v;
        u--; v--;
        gr[u].insert(v);
        gr[v].insert(u);
    }
dfs(0);
    int sz = 0;
    for (int i = 0; res[i] != -1; ++i) {
        sz = i+1;
    }
    cout << sz << endl;
    for (int i = 0; i < sz; ++i) cout << res[i] << ' ';
    cout << endl;
    set<pair<int,int>> usedd;
    for (int i = 0; i < n; ++i) {
        for (int j : gr[i]) {
            if (!usedd.count({max(i, j), min(i,j)})) {
                cout << i+1 << ' ' << j+1 << '\n';
                usedd.insert({max(i, j), min(i,j)});
            }
        }
    }
}

int32_t main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solution();
}



