#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "---"; cerr.flush()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)2e5 + 5;
const ll mod = (ll)1e9 + 7;

void operator delete(void*);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n;

ll ans = inf;

vector<ll> divs;

void solve(ll x) {
    vector<ll> div;
    x = 2 * x - 1;
    for (ll i = 1; i * i <= x; i++) {
        if (x % i == 0) {
            div.push_back(i);
            div.push_back(x / i);
        }
    }
    // i == 2 * a  - 1
    for (ll i : div) {
        ll a = i + 1;
        if (a % 2) continue;
        a = a / 2;
        ll kek = x / i;
        ll xx = a - kek;
        ans = min(ans, abs(xx));
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n;
    //case 1;
    for (ll i = 1; i * i <= n; i++) {
        if (n % i) continue;
        divs.push_back(i);
        divs.push_back(n / i);
        ans = min(ans, abs(i - n / i));
    }
    //case 2;
    for (ll i : divs) {
        if (i % 2 == 0) continue;
        ll a = (i + 1) / 2;
        ll k = n / i;
        k *= 2;
        ans = min(ans, abs(a - k));
    }
    //case 3;
    solve(n);
    //case 4;
    solve(n + 1);
    cout << ans;
    return 0;
}
