#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "---"; cerr.flush()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)2e5 + 5;
const ll mod = (ll)1e9 + 7;

void operator delete(void*);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n, m;

vector<ll> g[cst];

bool used[cst];

vector<ll> col;

vector<pair<ll, ll>> edges;
set<pair<ll, ll>> edgg;

ll fr[cst];

void dfs(ll v, ll pr = -1) {
    used[v] = 1;
    for (ll u : g[v]) {
        if (u == pr) continue;
        if (!used[u]) {
            fr[u] = col.size();
            col.push_back(u);
            edges.push_back({ fr[v], fr[u] });
            edgg.insert({ fr[v], fr[u] });
            edgg.insert({ fr[u], fr[v] });
            dfs(u, v);
        }
    }
}

vector<pair<ll, ll>> vc;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> m;
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
        vc.push_back({ a, b });
    }
    col.push_back(-1);
    fr[1] = 1;
    col.push_back(1);
    dfs(1);
    for (auto i : vc) {
        if (edgg.count(i)) continue;
        edges.push_back({ fr[i.second], col.size() });
        col.push_back(i.first);
    }

    cout << col.size() - 1 << endl;
    for (ll i = 1; i < col.size(); i++) cout << col[i] << " ";
    cout << endl;
    for (auto i : edges) cout << i.first << " " << i.second << endl;
    return 0;
}
