//#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
        
#define ll long long
#define ull unsigned ll
#define vi vector<ll>
#define vvi vector<vi>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ld long double
#define pll pair<ll, ll>
#define mt make_tuple
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define base complex<ld>

using namespace std;
const ll INF = (ll)2e9;
const ll inf = (ll)4e18;
const ld eps = (ld)1e-9;
const ll mod = (ll)1e9 + 7; 
const ll mod2 = (ll)1e9 + 9;
const ll MAXN = (ll)1e7 + 11;
const ll MAXC = (ll)1e6 + 10;
const ll MAXE = (ll)1000;
const ll MAXLOG = (ll)19;
const ll maxlen = (ll)1e5;
const ll asci = (ll)256;
const ll block = 512;
const ld PI = acos(-1LL);
const ld e = 2.7182818284;
        
/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<
pii,
null_type,
less<pii>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;*/
        
template <class T>
istream& operator >>(istream &in, vector<T> &arr){
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


struct edge {
    ll u, ind;
};


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    for (int i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb({u, i});
        g[u].pb({v, i});
    }

    vector<ll> colour(m + 1), used(n);
    vector<ll> usedEdge(m);
    vector<pll> eAns;
    int d = 0;

    function<void(ll, ll)> dfs = [&](ll v, ll pr) {
        used[v] = 1;
        for (auto e : g[v]) {
            if (e.ind == pr) {
                continue;
            }
            if (used[e.u] and !usedEdge[e.ind]) {
                colour[n + d] = e.u;
                eAns.pb({v, n + d});
                usedEdge[e.ind] = true;
                d++;
            } else if (!used[e.u]) {
                eAns.pb({v, e.u});
                usedEdge[e.ind] = true;
                dfs(e.u, e.ind);
            }
        }
    };

    for (int i = 0; i < n; i++) {
        colour[i] = i;
    }
    dfs(0, -1);
    cout << m + 1 << "\n";
    for (int i = 0; i < m + 1; i++) {
        cout << colour[i] + 1 << " ";
    }
    cout << "\n";
    for (auto e : eAns) {
        cout << e.first + 1 << " " << e.second + 1 << "\n";
    }
}
 
signed main() {
    srand(time(0LL));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr); 
#endif
    cout.precision(30);
    
    solve();
 
    return 0LL;
}