//#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
         
#define ll long long
#define ull unsigned ll
#define vi vector<ll>
#define vvi vector<vi>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ld long double
#define pll pair<ll, ll>
#define mt make_tuple
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define base complex<ld>
 
using namespace std;
const ll INF = (ll)2e9;
const ll inf = (ll)4e18;
const ld eps = (ld)1e-12;
const ll mod = (ll)1e9 + 7; 
const ll mod2 = (ll)1e9 + 9;
const ll MAXN = (ll)1e4 + 1;
const ll MAXC = (ll)1e3 + 10;
const ll MAXE = (ll)1000;
const ll MAXLOG = (ll)19;
const ll maxlen = (ll)1e5;
const ll asci = (ll)256;
const ll block = 512;
const ld PI = acos(-1LL);
const ld e = 2.7182818284;
         
/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<
pii,
null_type,
less<pii>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;*/
         
template <class T>
istream& operator >>(istream &in, vector<T> &arr){
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};

struct md{
    int len = INF, cnt = 0, p = -1;

    md(int len, int cnt, int p = -1): len(len), cnt(cnt), p(p) {}
    md() {}
};

bool operator <(const md &a, const md &b) {
    if (a.len == b.len) return a.cnt > b.cnt;
    return a.len < b.len;
}

int dp[MAXN][MAXN];
int matr[MAXC][MAXC];
int used[MAXC];
md d[MAXC];

int dist(string a, string b) {
    int n = a.size();
    int m = b.size();
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            dp[i][j] = INF;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i < n && j < m && a[i] == b[j]) mn(dp[i + 1][j + 1], dp[i][j]);
            else if (i < n && j < m) mn(dp[i + 1][j + 1], dp[i][j] + 1);
            if (i < n) mn(dp[i + 1][j], dp[i][j] + 1);
            if (j < m) mn(dp[i][j + 1], dp[i][j] + 1);
        }
    }
    return dp[n][m];
}

void solve() {
    vector<string> a(2); cin >> a;
    int n; cin >> n;
    n += 2;
    a.resize(n);
    for (int i = 2; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            matr[i][j] = INF;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            matr[i][j] = dist(a[i], a[j]);
            matr[j][i] = matr[i][j];
        }
    }
    d[0] = md(0, 0);
    for (int i = 0; i < n; ++i) {
        int v = 0;
        for (int j = 0; j < n; ++j) {
            if (used[j] == used[v]) {
                if (d[j] < d[v]) v = j;
            } else if (used[j] < used[v]) v = j;
        }
        used[v] = 1;
        for (int u = 0; u < n; ++u) {
            if (!used[u]) mn(d[u], md(d[v].len + matr[v][u], d[v].cnt + 1, v));
        }
    }
    vector<string> ans;
    cout << d[1].len << " " << d[1].cnt - 1 << "\n";
    for (int v = 1; v != -1; v = d[v].p) {
        if (v > 1) ans.push_back(a[v]);
    }
    reverse(all(ans));
    for (auto x : ans) cout << x << "\n";
}
  
signed main() {
    srand(time(0LL));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr); 
#endif
    cout.precision(30);
     
    solve();
  
    return 0LL;
}