#include <bits/stdc++.h>
#define X first
#define Y second
#define P pair<int, int>
#define all(v) v.begin(),v.end()
#define pb push_back
using namespace std;
const int MAXN = (int)(1e5 + 123);
vector <P> points;
int x[MAXN], y[MAXN];
bool cmp(P a, P b) {
  if (a.X > b.X) return true;
  else if (a.X == b.X && a.Y > b.Y)
    return true;
  return false;
}
double dist(P a, P b) {
  return sqrt((a.X-b.X)*(a.X-b.X) + (a.Y-b.Y)*(a.Y-b.Y));
}
int orientation(P p, P q, P r) {
    int val = (q.Y - p.Y) * (r.X - q.X) -
              (q.X - p.X) * (r.Y - q.Y);
    if (val == 0) return 0;
    return (val > 0)? 1: 2;
}
vector<P> convexHull() {
    vector<P> hull;
    int l = 0;
    int p = 0, q;
    do {
        hull.pb(points[p]);
        q = (p+1)%(int(points.size()));
        for (int i = 0; i < points.size(); i++) {
           if (orientation(points[p], points[i], points[q]) == 2) q = i;
        }
        p = q;

    } while (p != l);
    return hull;
}
int main() {
  // freopen("input.txt", "r", stdin);
  int n, l;
  cin >> n >> l;
  for (int i=1; i<=n; i++) cin >> x[i] >> y[i];
  //Left
  for (int i=1; i<=n; i++) points.pb({x[i]-l, y[i]});
  //Right
  for (int i=1; i<=n; i++) points.pb({x[i]+l, y[i]});
  //Down
  for (int i=1; i<=n; i++) points.pb({x[i], y[i]-l});
  //Up
  for (int i=1; i<=n; i++) points.pb({x[i], y[i]+l});

  sort(all(points), cmp);
  vector <P> res = convexHull();
  // for (int i=0; i<res.size(); i++)
  //   cout <<res[i].X<<" "<<res[i].Y<<endl;
  double ans = 0;
  for (int i=0; i<res.size(); i++)
    ans += dist(res[i], res[(i-1+res.size()) % int(res.size())]);
  cout <<ans;
}
