#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

vector<vector<pair<int, int>>> gr;
vector<bool> used;
int sch = 0;
set<pair<int, int>> correct_gr;
set<pair<int, int>> correct_gr2;
vector<int> vertexes;

void dfs(pair<int, int> v, pair<int, int> p) {
    if (p.first != v.first) {
        pair<int, int> now;
        now.first = min(v.first, p.first);
        now.second = max(v.first, p.first);
        if (correct_gr.find(now) == correct_gr.end()) {
            correct_gr.insert(now);
            sch++;
            pair<int, int> temp;
            temp.first = min(p.second, sch);
            temp.second = max(p.second, sch);
            v.second = sch;
            correct_gr2.insert(temp);
            vertexes.push_back(v.first + 1);
        }
    }
    if (!used[v.first]) {
        used[v.first] = true;
        for (auto u : gr[v.first])
            dfs(u, v);
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    used.resize(n, false);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        pair<int, int> a1, b1;
        a1.second = b1.second = -1;
        a1.first = a - 1;
        b1.first = b - 1;
        gr[a - 1].push_back(b1);
        gr[b - 1].push_back(a1);
    }
    vertexes.push_back(1);
    pair<int, int> x, y;
    x.first = y.first = 0;
    x.second = y.second = 0;
    dfs(x, y);
    cout << vertexes.size() << "\n";
    for (auto u : vertexes)
        cout << u << " ";
    cout << "\n";
    int k = correct_gr2.size();
    for (int i = 0; i < k; i++) {
        pair<int, int> r = *correct_gr2.begin();
        cout << r.first + 1 << " " << r.second + 1 << "\n";
        correct_gr2.erase(r);
    }
}