#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

vector<vector<int>> gr;
vector<bool> near;
int ans = 0;

void dfs(int v, int p, int lvl) {
    if (lvl == 3 && near[v])
        ans++;
    if(lvl != 3)
        for (auto to : gr[v]) {
            if (to != p)
                dfs(to, v, lvl + 1);
        }
}

int main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    near.resize(n, false);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if (a == 1)
            near[b - 1] = true;
        if (b == 1)
            near[a - 1] = true;
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    dfs(0, 0, 0);
    cout << ans;
}