#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <bitset>
#include <cmath>
#include <tuple>
#include <map>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n, L;
	cin >> n >> L;
	vector<ll>x(n);
	set<ll>xx;
	for (int i = 0; i < n; i++) {
		cin >> x[i];
		x[i] *= 2;
		xx.insert(x[i]);
	}
	sort(x.begin(), x.end());
	L *= 2;
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		ll dx = (x[i] + L / 2) % L;
		ll l = x[i];
		ll r = dx;
		if (l > r)swap(l, r);
		ll left = max(0, lower_bound(x.begin(), x.end(), r) - upper_bound(x.begin(), x.end(), l));
		ll right = n - left;
		if (xx.count(l)) {
			right--;
		}
		if (xx.count(r)) {
			right--;
		}
		ans += (left - 1) * left / 2 + (right - 1) * right / 2;
	}
	ans /= 2;
	cout << (ll)n * (n - 1) * (n - 2) / 6 - ans;
	return 0;
}