#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	double melt, eat;
	cin >> n >> melt >> eat;
	vector<int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	a.push_back(0);
	n = a.size();
	sort(a.rbegin(), a.rend());
	vector<double>b(n);
	for (int i = 0; i < n; i++) {
		b[i] = a[i];
	}
	int cnt = 1;
	double cur = a[0];
	double time = 0;
	for (int i = 1; i < n; i++) {
		a[i] -= time * melt;
		double t = (cur - a[i]) / (eat / cnt);
		if (t * ((eat / cnt) + melt) >= cur) {
			t = cur / ((eat / cnt) + melt);
		}
		cur -= ((eat / cnt) + melt) * t;
		cnt++;
		time += t;
	}
	cout << fixed << setprecision(10) << time * eat;
	return 0;
}