#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);


typedef long long ll;
using namespace std;

int main() {
	fastio;
	int n, m;
	cin >> n >> m;
	set<int> in1;
	vector<pair<int, int>>in2;
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a  >> b;
		if (a > b)
			swap(a, b);
		if (a == 1)
			in1.insert(b);
		else
			in2.emplace_back(a, b);
	}
	map<int, int> cnt;
	for (auto&it : in2)
	{
		if (in1.find(it.first) != in1.end())
			cnt[it.second]++;
		if (in1.find(it.second) != in1.end())
			cnt[it.first]++;
	}
	ll ans = 0;
	for (auto&it : cnt)
	{
		if (it.second > 1)
		{
			ans += (ll)it.second * ((ll)it.second - 1LL);
		}
	}
	cout << ans;
	return 0;
}

