// #pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
// #pragma GCC target("avx,avx2")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-15;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

using namespace std;

int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io;
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(10) << std::fixed;
    long double START_TIME = clock();

    ll n;
    std::cin >> n;
    ll ans = n - 1;
    // first way
    for(ll i = 2; i * i <= n; i++) {
        if(n % i) continue;
        mn(ans, std::llabs(i - n / i));
    }
    n = 2 * n;
    for(ll r = 2; r * r <= n; r++) {
        if(n % r) continue;
        if(r % 2 == 0) {
            ll k = ((n / r) - 1);
            if(k % 2 == 0) {
                k /= 2;
                mn(ans, std::llabs(k + 1 - r));
            }
        }

        ll r1 = n / r;
        if(r1 % 2 == 0) {
            ll k = ((n / r1) - 1);
            if(k % 2 == 0) {
                k /= 2;
                mn(ans, std::llabs(k + 1 - r1));
            }
        }
    }
    // second way
    n += 1;
    for(ll r1 = 2; r1 * r1 <= n; r1++) {
        if(n % r1) continue;
        if(r1 % 2) {
            ll k = n / r1 - 1;
            if(k % 2 == 0) {
                k /= 2;
                mn(ans, std::llabs(k + 1 - r1));
            }
        }

        r1 = n / r1;
        if(r1 % 2) {
            ll k = n / r1 - 1;
            if(k % 2 == 0) {
                k /= 2;
                mn(ans, std::llabs(k + 1 - r1));
            }
        }

        r1 = n / r1;
    }
    // third way
    n -= 2;
    for(ll r1 = 2; r1 * r1 <= n; r1++) {
        if(n % r1) continue;
        if(r1 % 2) {
            ll k = n / r1 - 1;
            if(k % 2 == 0) {
                k /= 2;
                mn(ans, std::llabs(k + 1 - r1));
            }
        }

        r1 = n / r1;
        if(r1 % 2) {
            ll k = n / r1 - 1;
            if(k % 2 == 0) {
                k /= 2;
                mn(ans, std::llabs(k + 1 - r1));
            }
        }

        r1 = n / r1;
    }
    std::cout << ans << '\n';

    std::cerr << '\n';
    long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    // debug(TIME);
    return 0;
}