// #pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
// #pragma GCC target("avx,avx2")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-15;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

using namespace std;
const int MAXN = 2e5;
std::vector<int> g[MAXN];
ll h1[MAXN], h2[MAXN];
int dist[MAXN];

int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io;
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(10) << std::fixed;
    long double START_TIME = clock();

    int n, m;
    std::cin >> n >> m;
    for(int i = 0; i < m; i++) {
        int from, to;
        std::cin >> from >> to;
        from--, to--;
        g[from].push_back(to);
        g[to].push_back(from);
    }
    memset(dist, inf, sizeof(dist));
    std::queue<int> q;
    // q.push(0);
    for(auto &i : g[0]) {
        q.push(i);
        dist[i] = 1;
    }
    memset(h1, 0, sizeof(h1));
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        if(dist[v] > 2) break;
        if(dist[v] == 1) {
            for(auto &i : g[v]) {
                h1[i]++;
                if(dist[i] == inf) dist[i] = dist[v] + 1;
            }
        }
        if(dist[v] == 2) continue;
    }
    ll ans = 0;
    for(int i = 1; i < n; i++) {
        // debug(h1[i]);
        ans += h1[i] * (h1[i] - 1);
    }
    std::cout << ans;

    std::cerr << '\n';
    long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    // debug(TIME);
    return 0;
}