#include <bits/stdc++.h>

using namespace std;

/*struct Fenwick {
    int n;
    int *t;

    void init(int _n) {
        n = _n;
        t = new int[n];
        memset(t, 0, sizeof(int) * n);
    }



};*/

long long dfs(int v, bool** connected, int& n, bool* used, int turn) {
    //cout << v << endl;
    long long ans = 0;
    used[v] = true;
    if (turn == 3) {
        if (connected[v][0]) {
            ans = 1;
        }
    } else {
        for (int u = 0; u < n; u++) {
            if (connected[v][u] && !used[u]) {
                ans += dfs(u, connected, n, used, turn + 1);
            }
        }
    }

    used[v] = false;
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;

    bool** connected = new bool*[n];
    for (int i = 0; i < n; i++) {
        connected[i] = new bool[n];
        for (int j = 0; j < n; j++) {
            connected[i][j] = false;
        }
    }
    bool* used = new bool[n];
    memset(used, 0, sizeof(bool) * n);
    int a, b;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        a--;
        b--;
        connected[a][b] = true;
        connected[b][a] = true;
        //cout << connected[a].back() << " " << connected
    }

    cout << dfs(0, connected, n, used, 0);

    return 0;
}
