#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <string>
#include <list>
using namespace std;

#define ll long long
#define OPTIMIZM ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)
#define A 10
#define B 11
#define C 12
#define D 13
#define E 14
#define F 15
#define G 16
#define H 17
#define I 18
#define J 19

void taskC();
void taskE();
void taskB();

int main()
{
	OPTIMIZM;
	taskE();
	return 0;
} 

ll Count(vector <int> points, int left, int right) {
	ll counter = 0;
	for (int i = 0; i < points.size(); i++)
	{
		if (points[i] >= left & points[i] <= right) counter++;
	}
	return counter;
}

void taskB() {
	int n, L;
	cin >> n >> L;
	vector <int> points(n);
	for (int i = 0; i < n; i++)
	{
		int tmp;
		cin >> tmp;
		points[i] = tmp;
	}
	sort(points.begin(), points.end());
	ll count = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = i+1; j < n; j++)
		{
			count += Count(points, points[i] + L / 2, points[j] + L / 2);
		}
	}
	cout << count;
}

void taskE() {
	ll n;
	cin >> n;
	ll result = abs(1 - n);
	ll sqr = sqrt(n) + 1;
	for (ll m = 2; m <= sqr; m++)
	{
		if (m*m == n) result = 0;
		else if (n%m == 0) {
			int width = n / m;
			result = min(result, abs(m - width));
		}
		else {
			int pair = 2 * m - 1;
			int width = n / pair;
			if (pair*width == n) result = min(result, abs(m - width * 2));
			else if (pair*width + m == n) {
				result = min(result, abs(m - (width * 2 + 1)));
			}
			else if (pair*width + m - 1 == n) {
				result = min(result, abs(m - (width * 2 + 1)));
			}
		}
	}
	cout << result;
}


	/*int width = (int)sqrt(n);
	while(true) {
		ll s = 0;
		int counter = 1;
		while (true) {
			if (counter % 2 == 1)
				s += width;
			else s += width - 1;
			counter++;
			if (s>n){
				width++;
				break;
			}
			else if (s == n) {  //  
				cout << abs(width - counter);
				return;
			}
		}
	}*/


void taskC() {
	int k, n, rounds;
	cin >> k >> n;
	rounds = 0;
	int a = n;
	for (int i = 0; i < k; i++)
	{
		int tmp;
		cin >> tmp;
		if (a - tmp > 0) a = a - tmp;
		else if (a - tmp == 0) {
			a = n;
			rounds++;
			if (i == k - 1) {
				a = 0;
			}
		}
	}
	cout << rounds << endl;
	cout << a;
}