#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;
const int N = 1e6 + 1;
struct T {
    int color1, color2;
};
vector<int> versh[N], new_versh[N];
int n, m;
T colors[N];
queue<int> q;
void bfs(int v)
{
    q.push(v);
    colors[v].color2 = 1;
    while (!q.empty())
    {
        int t = q.front();
        for (auto to : versh[t])
        {
            if (colors[to].color2 == 0)
            {
                colors[to].color2 = colors[t].color2 + 1;
                new_versh[to].push_back(t);
                new_versh[t].push_back(to);
                q.push(to);
            }
            else if (colors[to].color2 > colors[t].color2)
            {
                new_versh[n + 1].push_back(t);
                colors[n + 1].color1 = colors[to].color1;
                colors[n + 1].color2 = colors[to].color2;
                n++;
            }
            else if (colors[to].color2 == colors[t].color2 && colors[to].color1 < colors[t].color1)
            {
                new_versh[n + 1].push_back(t);
                colors[n + 1].color1 = colors[to].color1;
                colors[n + 1].color2 = colors[to].color2;
                n++;
            }
        }
        q.pop();
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        versh[x].push_back(y);
        versh[y].push_back(x);
    }
    for (int i = 1; i < N; i++)
    {
        colors[i].color1 = i;
        colors[i].color2 = 0;
    }
    bfs(1);
    cout << n << endl;
    for (int i = 1; i <= n; i++)
    {
        cout << colors[i].color1 << " ";
    }
    cout << endl;
    for (int i = 1; i <= n; i++)
    {
        for (auto to : new_versh[i])
        {
            cout << i << " " << to << endl;
        }
    }
}
