﻿#include <iostream>
#include <vector>
#include <cmath> 
#include <random>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>

#define kak_zhe_hochetsya_tyanochku ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define in(i, a) for(auto i : a)
#define inl(i, a) for(auto& i : a)

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e18 + 7, MOD = 1e9 + 7;

template <class T> void print(vector<T>& a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << "\n";
}

ll n;
ld v, u;
vector<ld> a;

int main() {
    kak_zhe_hochetsya_tyanochku;
    cout.precision(23);
    cin >> n >> v >> u;
    a.resize(n);
    rep(i, n) {
        cin >> a[i];
    }
    sort(all(a));
    ld ans = 0;
    ld cur_dead = 0;
    ll first_alive = 0;
    ll last_count = 1;
    while (true) {
        if (last_count + first_alive == n) {
            a[n - last_count] -= cur_dead;
            ld cur_t = a[n - last_count] / (u / last_count + v);
            ans += u * cur_t;
            break;
        }
        else if ((a[n - 1 - last_count] - cur_dead) / v > (a[n - last_count] - a[n - 1 - last_count]) / (u / last_count) && first_alive >= 0) {
            ld cur_t = (a[n - last_count] - a[n - 1 - last_count]) / (u / last_count);
            cur_dead += v * cur_t;
            ans += u * cur_t;
            ll left = first_alive-1, right = n - last_count;
            while (left + 1 < right) {
                ll mid = (left + right) / 2;
                if (a[mid] <= cur_dead) {
                    left = mid;
                }
                else {
                    right = mid;
                }
            }
            first_alive = right;
            ++last_count;
        }
        else {
            a[n - last_count] -= cur_dead;
            ld cur_t = a[n - last_count] / (u / last_count + v);
            ans += u * cur_t;
            break;
        }
    }
    cout << ans;
}