﻿#include <iostream>
#include <vector>
#include <cmath> 
#include <random>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>

#define kak_zhe_hochetsya_tyanochku ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define in(i, a) for(auto i : a)
#define inl(i, a) for(auto& i : a)

using namespace std;

using ll = long long;

const ll INF = 1e18 + 7, MOD = 1e9 + 7;

template <class T> void print(vector<T>& a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << "\n";
}

int main() {
    kak_zhe_hochetsya_tyanochku;
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    rep(i, m) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<vector<int>> dp(n, vector<int>(4, 0));
    dp[0][0] = 1;
    rep(i, 3) {
        rep(v, n) {
            in(u, g[v]) {
                dp[v][i + 1] += dp[u][i];
            }
        }
    }
    ll ans = 0;
    in(v, g[0]) {
        ans += dp[v][3] - g[v].size() - g[0].size() + 1;
    }
    cout << ans;
}

