#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;


void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void formatting () {
    cout << fixed;
    cout.precision(12);
    cout << setprecision(11);
}

void solve();

int main () {
    acceleration();
    formatting();
    solve();
}
ll const N = 510, mod = 1e9+ 7;
vector<double> a;

ll GCD (ll n, ll m) {
    if (!m) return n;
    return GCD(m, n % m);
}

ll Bin_Pow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (Bin_Pow(n, k / 2) * Bin_Pow(n, k / 2)) % mod;
    else return (n * Bin_Pow(n, k - 1)) % mod;
}

void solve () {
    ll n, x, v, u, sum = 0, idx, k, m = 1e18, t, ans, o;
    cin >> n;
    for(ll i = 1; i * i <= n; i++){
        if(n % i == 0)
            m = min(m, abs(n / i - i));
    }
    for(ll i = 1; i * i <= n; i++){
        if((n + i) % (2 * i) == 0){
            m = min(m, abs((n + i)/ (2 * i) - 2 * i));
        }
        if((n + i) % (2 * i + 1) == 0){
            m = min(m, abs((n + i)/ (2 * i + 1) - 2 * i - 1));
        }
        if((n + i) % (2 * i - 1) == 0){
            m = min(m, abs((n + i)/ (2 * i - 1) - 2 * i + 1));
        }
    }
    cout << m << '\n';

}
