#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

const long double EPS = 1e-9;

bool Less(long double d1, long double d2)
{
    return d1 + EPS < d2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    long long n, ans;
    cin >> n;
    ans = n - 1;

    for (long long i = 1; i * i < 10 * n; ++i) {
        if (!(n % i)) ans = min(ans, abs(n / i - i));

        if (!(n % (2 * i + 1))) ans = min(ans, abs(n / (2 * i + 1) * 2 - i - 1));

        if (!((n - i) % (2 * i + 1))) ans = min(ans, abs((n - i) / (2 * i + 1) * 2 - i));

        if (!((n - i - 1) % (2 * i + 1))) ans = min(ans, abs((n - i - 1) / (2 * i + 1) * 2 - i));
    }
    for (long long i = 1; i * i < 10 * n; ++i) {
        if (i % 2 == 0) {
            if ((2 * n - i) % (2 * i) == 0) {
                long long k = (2 * n - i) / (2 * i) + 1;
                ans = min(ans, abs(k - i));
            }
        }
        else {
            long long j = i / 2;
            if ((n - j - 1) % (2 * j + 1) == 0) {
                long long k = (n - j - 1) / (2 * j + 1) + 1;
                ans = min(ans, abs(i - k));
            }
            if ((n - j) % (2 * j + 1) == 0) {
                long long k = (n - j) / (2 * j + 1) + 1;
                ans = min(ans, abs(i - k));
            }
        }
    }
    cout << ans;
}