﻿using System;
using System.Linq;

internal static class Program
{
    private static int[] Petya(int n, int L, int[] moves)
    {
        var rounds = 0;
        var lastRound = 0;
        var currentL = L + 0;
        for (var i = 0; i < moves.Length; i++)
        {
            if (currentL - moves[i] >= 0)
            {
                currentL -= moves[i];
            }
            else
            {
                rounds++;
                currentL = L;
            }
        }

        lastRound = currentL;

        return new int[] {rounds, lastRound};
    }

    private static void Main(string[] args)
    {
        var nL = Console.ReadLine().Split(' ').Select(int.Parse).ToArray();
        var moves = Console.ReadLine().Split(' ').Select(int.Parse).ToArray();

        var result = Petya(nL[0], nL[1], moves);

        Console.WriteLine(result[0]);
        Console.WriteLine(result[1]);
    }
}