#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

#define endl "\n"
#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

int ans = 0;
vector<int> s;
void dfs(int u, int depth, vector <vector <int>>& w) {
    if (depth == 0) {
        if (u == 0) {
            ++ans;
        }
        return;
    }
    for (int v : s) {
        if (v == u) {
            return;
        }
    }
    s.push_back(u);

    for (int v : w[u]) {
        dfs(v, depth - 1, w);
    }
    s.pop_back();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> w(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        w[u].push_back(v);
        w[v].push_back(u);
    }
    ans = 0;
    bool kek[n];
    memset(kek, false, sizeof(kek));
    for (int v : w[0]) {
        kek[v] = true;
    }
    for (int i = 1; i < n; i++) {
//        if (kek[i]) {
//            continue;
//        }
        int lol = 0;
        for (int v : w[i]) {
            if (kek[v]) {
                lol++;
            }
        }
        ans += lol * (lol - 1);
    }
//    vector <int> cnt1(n);
//    for (int u : w[0]) {
//        for (int v : w[u]) {
//            ++cnt1[v];
//        }
//    }
//    for (int u = 0; u < n; ++u) {
//        ans += cnt1[u] * (cnt1[u] - 1);
//    }
    cout << ans << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}