#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 300001;
const long double e = 1e-6;

long double A[N];
ll n, u, v;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    cin >> n >> u >> v;
    for (ll i = 0; i < n; i++) {
        cin >> A[i];
    }
    sort(A, A + n);
    ll k = 1;
    ll cur = n - 1;
    long double t = 0;
    while (1) {
        if (cur == 0) {
            t += (long double)(A[cur]) * (long double)(k) / (v + k * u);
            break;
        }
        long double cel = A[cur - 1] - t * u;
        if (cel <= 0) {
            t += (long double)(A[cur]) * (long double)(k) / (v + k * u);
            break;
        }
        long double delta = (long double)(A[cur] - cel) * (long double)k / v;
        t += delta;
        if ((long double)(A[cur - 1]) - t * u < 0) {
            t -= delta;
            t += (long double)(A[cur]) * (long double)(k) / (v + k * u);
            break;
        }
        cur--;
        A[cur] -= t * u;
        k++;
    }
    cout << fixed << setprecision(7) << t * v;
}