#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 300001;
const long double e = 1e-12;

ll A[N];
ll n, u, v;

bool good(long double x) {
    long double t = 0;
    for (ll i = 0; i < n; i++) {
        t += max((long double)(0), ((long double)(A[i]) - x * v) / u);
    }
    if (t > x) {
        return 0;
    }
    return 1;
}
int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
 
    cin >> n >> v >> u;
    for (ll i = 0; i < n; i++) {
        cin >> A[i];
    }
    long double l = 0, r = 1e9;
    while ((r - l) > e) {
       long double m = (r + l) / 2;
        if (good(m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    cout << fixed << setprecision(7) << l * u;
}