#include <bits/stdc++.h>
using namespace std;

struct event {
    int left;
    int right;
    event(int l, int r) {
        this->left = l;
        this->right = r;
    };
};

bool cmp(event a, event b) {
    if (a.left == b.left) {
        return a.right < b.right;
    }
    return a.left < b.left;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int m;
    cin >> m;
    vector<event> a;
    int start, finish;
    cin >> start >> finish;
    while (!(start == 0 && finish == 0)) {
        if (start >= m || finish <= 0) {
            cin >> start >> finish;
            continue;
        }
        event seg(start, finish);
        a.push_back(seg);
        cin >> start >> finish;
    }
    sort(a.begin(), a.end(), cmp);
    vector<int> ans;
    int n = a.size();
    int l = 0, r = 0;
    int i_rmax = 0;
    for (int i = 0; i < n && r < m; ++i) {
        if (a[i].left <= l && a[i].right >= r && a[i].right >= a[i_rmax].right) {
            i_rmax = i;
        }
        if (i == n - 1 || (i < n - 1 && a[i + 1].left > l)) {
            if (a[i_rmax].left > r || a[i_rmax].right <= l) {
                cout << "No solution\n";
                return 0;
            }
            ans.push_back(i_rmax);
            l = a[i_rmax].left, r = a[i_rmax].right;
        }
    }
    if (ans.empty() || r < m) {
        cout << "No solution\n";
        return 0;
    }
    cout << (int)ans.size() << '\n';
    for (int i = 0; i < (int)ans.size(); ++i) {
        cout << a[ans[i]].left << ' ' << a[ans[i]].right << '\n';
    }

    return 0;
}
