#include <bits/stdc++.h>
const long double PI = acos(-1);
using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<bool> vis(n, false);
    vector<set<int>> g(n, set<int>());
    vector<int> cnt(n);
    set<int> needs;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> v >> u; --v; --u;
        g[v].insert(u);
        g[u].insert(v);
    }
    queue<pair<int, int>> q;
    q.push({0, 0});
    vis[0] = true;
    while (!q.empty() && q.front().second < 2) {
        int v = q.front().first;
        //cout << v << '\n';
        int depth = q.front().second;
        q.pop();
        for (auto u : g[v]) {
            cnt[u] += (depth == 1);
            if (vis[u] && cnt[u] >= 2 && u != 0) {
                //cout << u + 1 << '\n';
                needs.insert(u);
            }
            if (!vis[u]) {
                q.push({u, depth + 1});
                vis[u] = true;
            }
        }
    }
    int ans = 0;
    for (auto u : needs) {
        //cout << u + 1 << '\n';
        ans += cnt[u];
    }
    cout << ans << '\n';

    return 0;
}
