﻿#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <cstdlib>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <cstdarg>

#pragma GCC optimize("Ofast,unroll-loops,O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#define ll long long
#define ull unsigned ll
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ld long double
#define pii pair<ll, ll>
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define int long long

using namespace std;
#define magic_define ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); setprecision(17);

const ll INF = (ll)INT_MAX;
const ll inf = (ll)2e18;
const ld eps = (ld)1e-6;
const ll mod = 1e9 + 7;
const ll MAXN = (ll)2e5 + 10;
const ll MAXC = (ll)2e6 + 10;
const ll MAXE = (ll)1000;
const ll MAXLOG = (ll)16;
const ll maxlen = (ll)1e5;
const ll asci = (ll)256;
const ll block = 512;
const ld PI = acos(-1LL);
const ld e = 2.7182818284;

template <class T>
istream& operator >>(istream& in, vector<T>& a) {
	for (T& cnt : a) {
		in >> cnt;
	}
	return in;
};

double getTime() { return clock() / (double)CLOCKS_PER_SEC; };

//void solveA() {
//	int n; cin >> n;
//	vector<int>a(n); cin >> a;
//	vector<int> pref(n);
//	pref[0] = a[0];
//	for (int i = 1; i < n; i++) pref[i] = pref[i - 1] + a[i];
//	vector<pair<int, int>> len;
//	for (int i = 0; i < n; i++) {
//		for (int j = i; j < n; j++) {
//			int leng = !i ? pref[j] : pref[j] - pref[i - 1];
//			int leng1 = !i ? 0 : pref[i - 1];
//			int leng2 = pref[n - 1] - pref[j];
//			len.push_back({ leng, leng1 + leng2 });
//		}
//	}
//	len.push_back({ 0, pref[n - 1] });
//	
//	/*for (auto i : len) {
//		cout << i.first << ' ' << i.second << '\n';
//	}*/
//}

//struct point {
//	double x, y;
//	point() {}
//	point(double x, double y) : x(x), y(y) {}
//};
//
//pair<double, double> get_coords(int l, int x) {
//	double alpha = 2.0 * 3.141592 * x / l;
//	return { cos(alpha), sin(alpha) };
//}
//
//double area(point a, point b, point c) {
//	return abs((b.y - a.y) * (c.x - a.x) - (b.x - a.x) * (c.y - a.y));
//}
//
//void solveB() {
//	int n, l; cin >> n >> l;
//	vector<int> a(n); cin >> a;
//	vector<point> pr(n);
//	for (int i = 0; i < n; i++) {
//		pair<double, double> coord = get_coords(l, a[i]);
//		pr[i].x = coord.first;
//		pr[i].y = coord.second;
//	}
//	int ans = 0;
//	point p = {0,0};
//	for (int i = 0; i < n - 2; i++) {
//		for (int j = 0; j < n - 1; j++) {
//			for (int h = 0; h < n; h++) {
//				double s = area(pr[i], pr[j], pr[h]);
//				double s1 = area(pr[i], pr[j], p);
//				double s2 = area(pr[j], pr[h], p);
//				double s3 = area(pr[h], pr[i], p);
//				if (s1 + s2 + s3 - s <= 0) ans++;
//			}
//		}
//	}
//	cout << ans << '\n';
//}

vector<vector<int>> gr;
vector<int> d;
int ans = 0;
bool g_used[(int)1e5 + 100];

void dfs(int v, int count) {
    g_used[v] = true;
    for (auto to : gr[v]) {
        if (!to && count == 3)
            ++ans;
        if (!to || g_used[to])
            continue;
        if (count < 3)
            dfs(to, count + 1);
    }
    g_used[v] = false;
}

void solveE() {
    int n, m; cin >> n >> m;
    gr.resize(n), d.resize(n);
    vector<bool> used(n);
    for (int i = 0; i < m; i++) {
        int x, y; cin >> x >> y;
        x--, y--;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    for (auto to : gr[0]) {
        dfs(to, 1);
    }
    cout << ans << '\n';
}


signed main()
{
	magic_define;
	solveE();
}