﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define pint pair<int, int>
#define pll pair<ll, ll>

const ll inf = 1e9;
const ll INF = 1e18;
const ll M = 998244353;

void solve()
{
    ll n; cin >> n;
    ll sn = sqrt(n);
    ll ans = inf;
    for (int d = 1; d <= 2 * sqrt(n); ++d)
    {
        ll k = n % d;
        if (k && (k == n / d || k == (n + d - 1) / d))
        {
            ans = min(ans, abs(d - (n + d - 1) / d));
        }
        else if (k == 0)
        {
            ans = min(ans, abs(d - (n / d)));
        }
    }
    cout << ans << '\n';
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    ll t = 1; //cin >> t;
    while (t--)
    {
        solve();
    }
}