﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define pint pair<int, int>
#define pll pair<ll, ll>

const ll inf = 1e9;
const ll INF = 1e18;
const ll M = 998244353;

vector<int> a[100005];
vector<int> vis(100005, 0);
vector<int> c(200005);
int id = 0;
set<pair<int, int>> p;
int cn = 1;
void dfs(int v, int pr = -1)
{
    vis[v] = 1;
    c[v] = cn++;
    for (auto u : a[v])
    {
        if (u == pr)
            continue;
        if (vis[u] == 1)
        {
            p.insert({ min(id + 1, v + 1), max(id + 1, v + 1) });
            c[id] = c[u];
            id++;
        }
        else if (!vis[u])
        {
            dfs(u, v);
            p.insert({ min(u + 1, v + 1), max(u + 1, v + 1) });
        }
    }
    vis[v] = 2;
}
void solve()
{
    int n, m; cin >> n >> m;
    id = n;
    for (int i = 0; i < m; ++i)
    {
        int x, y; cin >> x >> y;
        --x, --y;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    dfs(0);
    cout << id << '\n';
    for (int i = 0; i < id; ++i)
    {
        cout << c[i] << ' ';
    }
    cout << '\n';
    for (auto pp : p)
    {
        cout << pp.first << ' ' << pp.second << '\n';
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    ll t = 1; //cin >> t;
    while (t--)
    {
        solve();
    }
}