#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <climits>
#include <queue>
#include <string>
using namespace std;
typedef long long ll;

const int INF = INT_MAX;

int n;
vector<int> a;
set<pair<ll, ll>> coords;
vector<bool> used;
vector<int> ans;

// void rec1(int k, ll x, ll y)
// {
//     if (k == n)
//     {
//         coords.insert(make_pair(x, y));
//         return;
//     }
//     rec1(k + 1, x + ans[k], y);
//     rec1(k + 1, x, y + ans[k]);
// }

// void rec2(int k)
// {
//     if (k == n)
//     {
//         rec1(0, 0, 0);
//         return;
//     }
//     for (int i = 0; i < n; i++)
//     {
//         if (!used[i])
//         {
//             used[i] = true;
//             ans[k] = a[i];
//             rec2(k + 1);
//             used[i] = false;
//         }
//     }
// }

vector<int> up;
vector<int> r;

void rec(int k)
{
    if (k == n)
    {
        ll x = 0, y = 0;
        for (int i : r)
            x += i;
        for (int i : up)
            y += i;
        coords.insert(make_pair(x, y));
        return;
    }
    up.push_back(a[k]);
    rec(k + 1);
    up.pop_back();
    r.push_back(a[k]);
    rec(k + 1);
    r.pop_back();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    cin >> n;
    a.resize(n);
    used.resize(n);
    ans.resize(n);
    for (int &i : a)
        cin >> i;
    rec(0);

    ll ans = 0;
    vector<pair<int, int>> c;

    for (auto i : coords)
        c.push_back(i);
    
    for (int i = 0; i < c.size(); i++)
    {
        ans += c[i].second + 1;
        if (c[i].first - i > 0)
            ans += c[i].first - i;
    }
    
    cout << ans;

    return 0;
}
