#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <climits>
#include <queue>
#include <string>
using namespace std;
typedef long long ll;

const int INF = INT_MAX;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);


    double n, v, u;
    cin >> n >> v >> u;
    set<double, greater<>> ice;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        ice.insert(x);
    }
    double a = *ice.begin();
    double k = 0;
    double ans = 0;

    for (auto i : ice)
    {   
        
        if (i != a && u > (k - 1) * v)
        {
            ans += (a - i + v * ans) / ((u - (k - 1) * v) / k);
            a -= u*(a - i + v * ans) / ((u - (k - 1) * v) / k);
        }
        else if (i != a)
        {
            break;
        }
        k++;
    }

    ans += k * a / (u + k * v);
    cout.precision(18);
    cout << ans * u;
    return 0;
}